/* A Bison parser, made by GNU Bison 2.5.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2011 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 268 of yacc.c  */
#line 106 "cfg.y"


#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <arpa/inet.h>
#include <string.h>
#include <errno.h>
#include "route_struct.h"
#include "globals.h"
#ifdef SHM_MEM
#include "shm_init.h"
#endif /* SHM_MEM */
#include "route.h"
#include "switch.h"
#include "dprint.h"
#include "sr_module.h"
#include "modparam.h"
#include "ip_addr.h"
#include "resolve.h"
#include "socket_info.h"
#include "name_alias.h"
#include "ut.h"
#include "dset.h"
#include "select.h"
#include "flags.h"
#include "tcp_init.h"
#include "tcp_options.h"
#include "sctp_options.h"
#include "pvar.h"
#include "lvalue.h"
#include "rvalue.h"
#include "sr_compat.h"
#include "msg_translator.h"

#include "ppcfg.h"
#include "pvapi.h"
#include "config.h"
#include "cfg_core.h"
#include "cfg/cfg.h"
#ifdef CORE_TLS
#include "tls/tls_config.h"
#endif
#include "timer_ticks.h"

#ifdef DEBUG_DMALLOC
#include <dmalloc.h>
#endif

/* hack to avoid alloca usage in the generated C file (needed for compiler
 with no built in alloca, like icc*/
#undef _ALLOCA_H

#define onsend_check(s) \
	do{\
		if (rt!=ONSEND_ROUTE) yyerror( s " allowed only in onsend_routes");\
	}while(0)

#ifdef USE_IPV6
	#define IF_AUTO_BIND_IPV6(x) x
#else
	#define IF_AUTO_BIND_IPV6(x) warn("IPV6 support not compiled");
#endif

#ifdef USE_DNS_CACHE
	#define IF_DNS_CACHE(x) x
#else
	#define IF_DNS_CACHE(x) warn("dns cache support not compiled in")
#endif

#ifdef USE_DNS_FAILOVER
	#define IF_DNS_FAILOVER(x) x
#else
	#define IF_DNS_FAILOVER(x) warn("dns failover support not compiled in")
#endif

#ifdef USE_NAPTR
	#define IF_NAPTR(x) x
#else
	#define IF_NAPTR(x) warn("dns naptr support not compiled in")
#endif

#ifdef USE_DST_BLACKLIST
	#define IF_DST_BLACKLIST(x) x
#else
	#define IF_DST_BLACKLIST(x) warn("dst blacklist support not compiled in")
#endif

#ifdef USE_STUN
	#define IF_STUN(x) x
#else 
	#define IF_STUN(x) warn("stun support not compiled in")
#endif

#ifdef USE_SCTP
	#define IF_SCTP(x) x
#else
	#define IF_SCTP(x) warn("sctp support not compiled in")
#endif

#ifdef USE_RAW_SOCKS
	#define IF_RAW_SOCKS(x) x
#else
	#define IF_RAW_SOCKS(x) warn("raw socket support not compiled in")
#endif


extern int yylex();
/* safer then using yytext which can be array or pointer */
extern char* yy_number_str;

static void yyerror(char* s, ...);
static void yyerror_at(struct cfg_pos* pos, char* s, ...);
static char* tmp;
static int i_tmp;
static unsigned u_tmp;
static struct socket_id* lst_tmp;
static struct name_lst*  nl_tmp;
static int rt;  /* Type of route block for find_export */
static str* str_tmp;
static str s_tmp;
static struct ip_addr* ip_tmp;
static struct avp_spec* s_attr;
static select_t sel;
static select_t* sel_ptr;
static pv_spec_t* pv_spec;
static struct action *mod_func_action;
static struct lvalue* lval_tmp;
static struct rvalue* rval_tmp;

static void warn(char* s, ...);
static void warn_at(struct cfg_pos* pos, char* s, ...);
static void get_cpos(struct cfg_pos* pos);
static struct rval_expr* mk_rve_rval(enum rval_type, void* v);
static struct rval_expr* mk_rve1(enum rval_expr_op op, struct rval_expr* rve1);
static struct rval_expr* mk_rve2(enum rval_expr_op op, struct rval_expr* rve1,
									struct rval_expr* rve2);
static int rval_expr_int_check(struct rval_expr *rve);
static int warn_ct_rve(struct rval_expr *rve, char* name);
static struct socket_id* mk_listen_id(char*, int, int);
static struct name_lst* mk_name_lst(char* name, int flags);
static struct socket_id* mk_listen_id2(struct name_lst*, int, int);
static void free_name_lst(struct name_lst* lst);
static void free_socket_id_lst(struct socket_id* i);

static struct case_stms* mk_case_stm(struct rval_expr* ct, int is_re, 
									struct action* a, int* err);
static int case_check_type(struct case_stms* stms);
static int case_check_default(struct case_stms* stms);
static int mod_f_params_pre_fixup(struct action* a);
static void free_mod_func_action(struct action* a);


extern int line;
extern int column;
extern int startcolumn;
extern int startline;
extern char *finame;

#define set_cfg_pos(x) \
	do{\
		if(x) {\
		(x)->cline = line;\
		(x)->cfile = (finame!=0)?finame:((cfg_file!=0)?cfg_file:"default");\
		}\
	}while(0)




/* Line 268 of yacc.c  */
#line 246 "cfg.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     FORWARD = 258,
     FORWARD_TCP = 259,
     FORWARD_TLS = 260,
     FORWARD_SCTP = 261,
     FORWARD_UDP = 262,
     EXIT = 263,
     DROP = 264,
     RETURN = 265,
     BREAK = 266,
     LOG_TOK = 267,
     ERROR = 268,
     ROUTE = 269,
     ROUTE_REQUEST = 270,
     ROUTE_FAILURE = 271,
     ROUTE_ONREPLY = 272,
     ROUTE_REPLY = 273,
     ROUTE_BRANCH = 274,
     ROUTE_SEND = 275,
     ROUTE_EVENT = 276,
     EXEC = 277,
     SET_HOST = 278,
     SET_HOSTPORT = 279,
     SET_HOSTPORTTRANS = 280,
     PREFIX = 281,
     STRIP = 282,
     STRIP_TAIL = 283,
     SET_USERPHONE = 284,
     APPEND_BRANCH = 285,
     REMOVE_BRANCH = 286,
     CLEAR_BRANCHES = 287,
     SET_USER = 288,
     SET_USERPASS = 289,
     SET_PORT = 290,
     SET_URI = 291,
     REVERT_URI = 292,
     FORCE_RPORT = 293,
     ADD_LOCAL_RPORT = 294,
     FORCE_TCP_ALIAS = 295,
     UDP_MTU = 296,
     UDP_MTU_TRY_PROTO = 297,
     UDP4_RAW = 298,
     UDP4_RAW_MTU = 299,
     UDP4_RAW_TTL = 300,
     IF = 301,
     ELSE = 302,
     SET_ADV_ADDRESS = 303,
     SET_ADV_PORT = 304,
     FORCE_SEND_SOCKET = 305,
     SET_FWD_NO_CONNECT = 306,
     SET_RPL_NO_CONNECT = 307,
     SET_FWD_CLOSE = 308,
     SET_RPL_CLOSE = 309,
     SWITCH = 310,
     CASE = 311,
     DEFAULT = 312,
     WHILE = 313,
     CFG_SELECT = 314,
     CFG_RESET = 315,
     URIHOST = 316,
     URIPORT = 317,
     MAX_LEN = 318,
     SETFLAG = 319,
     RESETFLAG = 320,
     ISFLAGSET = 321,
     SETAVPFLAG = 322,
     RESETAVPFLAG = 323,
     ISAVPFLAGSET = 324,
     METHOD = 325,
     URI = 326,
     FROM_URI = 327,
     TO_URI = 328,
     SRCIP = 329,
     SRCPORT = 330,
     DSTIP = 331,
     DSTPORT = 332,
     TOIP = 333,
     TOPORT = 334,
     SNDIP = 335,
     SNDPORT = 336,
     SNDPROTO = 337,
     SNDAF = 338,
     PROTO = 339,
     AF = 340,
     MYSELF = 341,
     MSGLEN = 342,
     UDP = 343,
     TCP = 344,
     TLS = 345,
     SCTP = 346,
     WS = 347,
     WSS = 348,
     DEBUG_V = 349,
     FORK = 350,
     FORK_DELAY = 351,
     LOGSTDERROR = 352,
     LOGFACILITY = 353,
     LOGNAME = 354,
     LOGCOLOR = 355,
     LISTEN = 356,
     ADVERTISE = 357,
     ALIAS = 358,
     SR_AUTO_ALIASES = 359,
     DNS = 360,
     REV_DNS = 361,
     DNS_TRY_IPV6 = 362,
     DNS_TRY_NAPTR = 363,
     DNS_SRV_LB = 364,
     DNS_UDP_PREF = 365,
     DNS_TCP_PREF = 366,
     DNS_TLS_PREF = 367,
     DNS_SCTP_PREF = 368,
     DNS_RETR_TIME = 369,
     DNS_RETR_NO = 370,
     DNS_SERVERS_NO = 371,
     DNS_USE_SEARCH = 372,
     DNS_SEARCH_FMATCH = 373,
     DNS_CACHE_INIT = 374,
     DNS_USE_CACHE = 375,
     DNS_USE_FAILOVER = 376,
     DNS_CACHE_FLAGS = 377,
     DNS_CACHE_NEG_TTL = 378,
     DNS_CACHE_MIN_TTL = 379,
     DNS_CACHE_MAX_TTL = 380,
     DNS_CACHE_MEM = 381,
     DNS_CACHE_GC_INT = 382,
     DNS_CACHE_DEL_NONEXP = 383,
     AUTO_BIND_IPV6 = 384,
     DST_BLST_INIT = 385,
     USE_DST_BLST = 386,
     DST_BLST_MEM = 387,
     DST_BLST_TTL = 388,
     DST_BLST_GC_INT = 389,
     DST_BLST_UDP_IMASK = 390,
     DST_BLST_TCP_IMASK = 391,
     DST_BLST_TLS_IMASK = 392,
     DST_BLST_SCTP_IMASK = 393,
     PORT = 394,
     STAT = 395,
     CHILDREN = 396,
     SOCKET_WORKERS = 397,
     CHECK_VIA = 398,
     PHONE2TEL = 399,
     SYN_BRANCH = 400,
     MEMLOG = 401,
     MEMDBG = 402,
     MEMSUM = 403,
     MEMSAFETY = 404,
     MEMJOIN = 405,
     CORELOG = 406,
     SIP_WARNING = 407,
     SERVER_SIGNATURE = 408,
     SERVER_HEADER = 409,
     USER_AGENT_HEADER = 410,
     REPLY_TO_VIA = 411,
     LOADMODULE = 412,
     LOADPATH = 413,
     MODPARAM = 414,
     MAXBUFFER = 415,
     SQL_BUFFER_SIZE = 416,
     USER = 417,
     GROUP = 418,
     CHROOT = 419,
     WDIR = 420,
     MHOMED = 421,
     DISABLE_TCP = 422,
     TCP_ACCEPT_ALIASES = 423,
     TCP_CHILDREN = 424,
     TCP_CONNECT_TIMEOUT = 425,
     TCP_SEND_TIMEOUT = 426,
     TCP_CON_LIFETIME = 427,
     TCP_POLL_METHOD = 428,
     TCP_MAX_CONNECTIONS = 429,
     TLS_MAX_CONNECTIONS = 430,
     TCP_NO_CONNECT = 431,
     TCP_SOURCE_IPV4 = 432,
     TCP_SOURCE_IPV6 = 433,
     TCP_OPT_FD_CACHE = 434,
     TCP_OPT_BUF_WRITE = 435,
     TCP_OPT_CONN_WQ_MAX = 436,
     TCP_OPT_WQ_MAX = 437,
     TCP_OPT_RD_BUF = 438,
     TCP_OPT_WQ_BLK = 439,
     TCP_OPT_DEFER_ACCEPT = 440,
     TCP_OPT_DELAYED_ACK = 441,
     TCP_OPT_SYNCNT = 442,
     TCP_OPT_LINGER2 = 443,
     TCP_OPT_KEEPALIVE = 444,
     TCP_OPT_KEEPIDLE = 445,
     TCP_OPT_KEEPINTVL = 446,
     TCP_OPT_KEEPCNT = 447,
     TCP_OPT_CRLF_PING = 448,
     TCP_OPT_ACCEPT_NO_CL = 449,
     TCP_CLONE_RCVBUF = 450,
     DISABLE_TLS = 451,
     ENABLE_TLS = 452,
     TLSLOG = 453,
     TLS_PORT_NO = 454,
     TLS_METHOD = 455,
     TLS_HANDSHAKE_TIMEOUT = 456,
     TLS_SEND_TIMEOUT = 457,
     SSLv23 = 458,
     SSLv2 = 459,
     SSLv3 = 460,
     TLSv1 = 461,
     TLS_VERIFY = 462,
     TLS_REQUIRE_CERTIFICATE = 463,
     TLS_CERTIFICATE = 464,
     TLS_PRIVATE_KEY = 465,
     TLS_CA_LIST = 466,
     DISABLE_SCTP = 467,
     ENABLE_SCTP = 468,
     SCTP_CHILDREN = 469,
     SCTP_SOCKET_RCVBUF = 470,
     SCTP_SOCKET_SNDBUF = 471,
     SCTP_AUTOCLOSE = 472,
     SCTP_SEND_TTL = 473,
     SCTP_SEND_RETRIES = 474,
     SCTP_ASSOC_TRACKING = 475,
     SCTP_ASSOC_REUSE = 476,
     SCTP_MAX_ASSOCS = 477,
     SCTP_SRTO_INITIAL = 478,
     SCTP_SRTO_MAX = 479,
     SCTP_SRTO_MIN = 480,
     SCTP_ASOCMAXRXT = 481,
     SCTP_INIT_MAX_ATTEMPTS = 482,
     SCTP_INIT_MAX_TIMEO = 483,
     SCTP_HBINTERVAL = 484,
     SCTP_PATHMAXRXT = 485,
     SCTP_SACK_DELAY = 486,
     SCTP_SACK_FREQ = 487,
     SCTP_MAX_BURST = 488,
     ADVERTISED_ADDRESS = 489,
     ADVERTISED_PORT = 490,
     DISABLE_CORE = 491,
     OPEN_FD_LIMIT = 492,
     SHM_MEM_SZ = 493,
     SHM_FORCE_ALLOC = 494,
     MLOCK_PAGES = 495,
     REAL_TIME = 496,
     RT_PRIO = 497,
     RT_POLICY = 498,
     RT_TIMER1_PRIO = 499,
     RT_TIMER1_POLICY = 500,
     RT_TIMER2_PRIO = 501,
     RT_TIMER2_POLICY = 502,
     MCAST_LOOPBACK = 503,
     MCAST_TTL = 504,
     TOS = 505,
     PMTU_DISCOVERY = 506,
     KILL_TIMEOUT = 507,
     MAX_WLOOPS = 508,
     PVBUFSIZE = 509,
     PVBUFSLOTS = 510,
     HTTP_REPLY_HACK = 511,
     VERSION_TABLE_CFG = 512,
     CFG_DESCRIPTION = 513,
     SERVER_ID = 514,
     LATENCY_LOG = 515,
     LATENCY_LIMIT_DB = 516,
     LATENCY_LIMIT_ACTION = 517,
     MSG_TIME = 518,
     FLAGS_DECL = 519,
     AVPFLAGS_DECL = 520,
     ATTR_MARK = 521,
     SELECT_MARK = 522,
     ATTR_FROM = 523,
     ATTR_TO = 524,
     ATTR_FROMURI = 525,
     ATTR_TOURI = 526,
     ATTR_FROMUSER = 527,
     ATTR_TOUSER = 528,
     ATTR_FROMDOMAIN = 529,
     ATTR_TODOMAIN = 530,
     ATTR_GLOBAL = 531,
     ADDEQ = 532,
     STUN_REFRESH_INTERVAL = 533,
     STUN_ALLOW_STUN = 534,
     STUN_ALLOW_FP = 535,
     SUBST = 536,
     SUBSTDEF = 537,
     SUBSTDEFS = 538,
     EQUAL = 539,
     LOG_OR = 540,
     LOG_AND = 541,
     BIN_OR = 542,
     BIN_AND = 543,
     BIN_XOR = 544,
     BIN_LSHIFT = 545,
     BIN_RSHIFT = 546,
     STRDIFF = 547,
     STREQ = 548,
     INTDIFF = 549,
     INTEQ = 550,
     MATCH = 551,
     DIFF = 552,
     EQUAL_T = 553,
     LTE = 554,
     GTE = 555,
     LT = 556,
     GT = 557,
     MINUS = 558,
     PLUS = 559,
     MODULO = 560,
     SLASH = 561,
     STAR = 562,
     BIN_NOT = 563,
     UNARY = 564,
     NOT = 565,
     DEFINED = 566,
     STRCAST = 567,
     INTCAST = 568,
     DOT = 569,
     STRLEN = 570,
     STREMPTY = 571,
     NUMBER = 572,
     ID = 573,
     NUM_ID = 574,
     STRING = 575,
     IPV6ADDR = 576,
     PVAR = 577,
     AVP_OR_PVAR = 578,
     EVENT_RT_NAME = 579,
     COMMA = 580,
     SEMICOLON = 581,
     RPAREN = 582,
     LPAREN = 583,
     LBRACE = 584,
     RBRACE = 585,
     LBRACK = 586,
     RBRACK = 587,
     CR = 588,
     COLON = 589
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 293 of yacc.c  */
#line 280 "cfg.y"

	long intval;
	unsigned long uval;
	char* strval;
	struct expr* expr;
	struct action* action;
	struct case_stms* case_stms;
	struct net* ipnet;
	struct ip_addr* ipaddr;
	struct socket_id* sockid;
	struct name_lst* name_l;
	struct avp_spec* attr;
	struct _pv_spec* pvar;
	struct lvalue* lval;
	struct rvalue* rval;
	struct rval_expr* rv_expr;
	select_t* select;



/* Line 293 of yacc.c  */
#line 637 "cfg.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 343 of yacc.c  */
#line 649 "cfg.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  437
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   11293

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  335
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  99
/* YYNRULES -- Number of rules.  */
#define YYNRULES  865
/* YYNRULES -- Number of states.  */
#define YYNSTATES  1620

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   589

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     8,    10,    13,    15,    17,    19,
      21,    23,    24,    27,    28,    31,    33,    34,    37,    38,
      41,    42,    45,    47,    49,    51,    53,    55,    57,    61,
      65,    67,    69,    71,    73,    75,    77,    79,    81,    83,
      85,    87,    89,    91,    93,    95,    97,   101,   105,   111,
     115,   117,   121,   125,   131,   135,   137,   140,   142,   145,
     148,   151,   153,   157,   159,   163,   165,   167,   170,   173,
     175,   179,   181,   185,   189,   193,   197,   201,   205,   209,
     213,   217,   221,   225,   229,   233,   237,   241,   245,   249,
     253,   257,   260,   264,   267,   271,   274,   278,   281,   285,
     288,   292,   295,   299,   302,   306,   309,   313,   316,   320,
     323,   327,   330,   334,   337,   341,   344,   348,   351,   355,
     358,   362,   365,   369,   372,   376,   379,   383,   386,   390,
     393,   397,   400,   404,   407,   411,   414,   418,   421,   425,
     428,   432,   435,   439,   442,   446,   449,   453,   456,   460,
     463,   467,   470,   474,   477,   481,   485,   489,   493,   497,
     501,   505,   509,   513,   517,   521,   525,   529,   533,   537,
     541,   545,   549,   553,   557,   561,   565,   569,   573,   577,
     581,   585,   589,   593,   597,   601,   605,   609,   613,   617,
     621,   625,   629,   633,   637,   641,   645,   649,   653,   657,
     661,   665,   669,   673,   677,   681,   685,   689,   693,   697,
     701,   705,   709,   713,   717,   721,   725,   729,   733,   737,
     741,   745,   749,   753,   757,   761,   765,   769,   773,   777,
     781,   785,   788,   792,   795,   799,   802,   806,   809,   813,
     817,   821,   825,   829,   833,   837,   841,   845,   849,   853,
     857,   861,   865,   869,   873,   877,   881,   885,   889,   893,
     897,   901,   905,   909,   913,   917,   921,   925,   929,   933,
     937,   941,   945,   949,   953,   957,   961,   965,   969,   973,
     977,   981,   985,   989,   993,   997,  1001,  1005,  1009,  1013,
    1017,  1021,  1025,  1029,  1033,  1037,  1041,  1045,  1049,  1053,
    1057,  1061,  1065,  1069,  1073,  1077,  1081,  1085,  1089,  1093,
    1097,  1101,  1105,  1109,  1113,  1117,  1121,  1125,  1129,  1133,
    1137,  1141,  1145,  1149,  1153,  1157,  1161,  1165,  1169,  1173,
    1177,  1181,  1185,  1189,  1193,  1197,  1201,  1205,  1209,  1213,
    1217,  1225,  1229,  1233,  1237,  1241,  1245,  1249,  1253,  1257,
    1261,  1265,  1269,  1273,  1277,  1281,  1285,  1289,  1293,  1297,
    1301,  1305,  1309,  1313,  1317,  1321,  1325,  1329,  1333,  1337,
    1341,  1345,  1349,  1353,  1357,  1361,  1365,  1369,  1373,  1377,
    1381,  1385,  1389,  1392,  1396,  1400,  1404,  1408,  1412,  1416,
    1420,  1424,  1428,  1432,  1436,  1440,  1444,  1448,  1452,  1456,
    1460,  1464,  1468,  1472,  1476,  1480,  1484,  1488,  1492,  1496,
    1500,  1504,  1508,  1512,  1516,  1520,  1524,  1528,  1532,  1536,
    1540,  1542,  1545,  1547,  1549,  1555,  1561,  1569,  1577,  1583,
    1592,  1601,  1604,  1607,  1610,  1613,  1617,  1621,  1630,  1639,
    1642,  1644,  1646,  1654,  1656,  1658,  1662,  1664,  1666,  1668,
    1670,  1672,  1677,  1685,  1688,  1691,  1696,  1704,  1707,  1709,
    1711,  1712,  1718,  1721,  1724,  1725,  1734,  1740,  1745,  1753,
    1756,  1761,  1769,  1772,  1780,  1783,  1786,  1789,  1792,  1795,
    1798,  1801,  1803,  1805,  1807,  1809,  1811,  1813,  1815,  1817,
    1819,  1821,  1823,  1825,  1827,  1829,  1831,  1833,  1835,  1837,
    1839,  1841,  1843,  1845,  1847,  1849,  1851,  1853,  1855,  1857,
    1859,  1861,  1863,  1865,  1867,  1869,  1871,  1873,  1875,  1879,
    1883,  1887,  1890,  1894,  1898,  1902,  1905,  1909,  1913,  1917,
    1921,  1924,  1928,  1932,  1936,  1940,  1944,  1948,  1952,  1956,
    1960,  1964,  1968,  1971,  1975,  1979,  1983,  1986,  1990,  1994,
    1996,  2000,  2002,  2006,  2010,  2014,  2018,  2020,  2022,  2024,
    2026,  2030,  2034,  2038,  2042,  2044,  2046,  2050,  2053,  2055,
    2058,  2061,  2063,  2065,  2067,  2070,  2073,  2075,  2078,  2082,
    2088,  2090,  2095,  2101,  2105,  2110,  2114,  2117,  2122,  2128,
    2132,  2137,  2142,  2145,  2147,  2153,  2158,  2161,  2167,  2171,
    2173,  2178,  2183,  2187,  2189,  2190,  2194,  2196,  2198,  2200,
    2202,  2204,  2206,  2208,  2210,  2212,  2214,  2216,  2220,  2222,
    2225,  2231,  2236,  2238,  2240,  2242,  2244,  2246,  2248,  2250,
    2252,  2254,  2256,  2258,  2260,  2262,  2264,  2266,  2268,  2270,
    2272,  2274,  2276,  2278,  2280,  2284,  2288,  2292,  2296,  2298,
    2300,  2302,  2304,  2307,  2310,  2313,  2317,  2321,  2325,  2329,
    2333,  2337,  2341,  2345,  2349,  2353,  2357,  2361,  2365,  2369,
    2373,  2378,  2383,  2386,  2389,  2392,  2395,  2399,  2403,  2407,
    2411,  2415,  2419,  2423,  2427,  2431,  2435,  2439,  2444,  2449,
    2452,  2456,  2458,  2460,  2462,  2466,  2471,  2476,  2481,  2488,
    2495,  2502,  2509,  2516,  2521,  2524,  2529,  2534,  2539,  2544,
    2551,  2558,  2565,  2572,  2579,  2584,  2587,  2592,  2597,  2602,
    2607,  2614,  2621,  2628,  2635,  2642,  2647,  2650,  2655,  2660,
    2665,  2670,  2677,  2684,  2691,  2698,  2705,  2710,  2713,  2718,
    2723,  2728,  2733,  2740,  2747,  2754,  2761,  2768,  2773,  2776,
    2781,  2786,  2793,  2796,  2801,  2806,  2811,  2814,  2819,  2824,
    2827,  2832,  2837,  2840,  2847,  2854,  2861,  2866,  2869,  2876,
    2879,  2884,  2889,  2894,  2897,  2902,  2907,  2912,  2915,  2920,
    2925,  2928,  2933,  2938,  2941,  2946,  2951,  2954,  2959,  2963,
    2966,  2971,  2975,  2978,  2983,  2987,  2992,  2995,  3000,  3005,
    3008,  3013,  3018,  3021,  3026,  3031,  3034,  3039,  3044,  3047,
    3052,  3057,  3060,  3065,  3069,  3071,  3075,  3077,  3081,  3083,
    3088,  3092,  3094,  3099,  3104,  3109,  3114,  3119,  3122,  3127,
    3132,  3135,  3140,  3145,  3148,  3152,  3154,  3158,  3160,  3164,
    3166,  3170,  3172,  3179,  3186,  3189,  3194,  3199,  3202,  3207,
    3208,  3214,  3217,  3218,  3222,  3224,  3226,  3230,  3233,  3235,
    3239,  3242,  3244,  3246,  3250,  3253
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     336,     0,    -1,   337,    -1,   337,   338,    -1,   338,    -1,
     337,     1,    -1,   361,    -1,   380,    -1,   354,    -1,   358,
      -1,   364,    -1,    -1,   339,   371,    -1,    -1,   340,   372,
      -1,   374,    -1,    -1,   341,   377,    -1,    -1,   342,   378,
      -1,    -1,   343,   379,    -1,   326,    -1,   333,    -1,   365,
      -1,   320,    -1,   395,    -1,   344,    -1,   344,   325,   345,
      -1,   328,   345,   327,    -1,   344,    -1,    88,    -1,    89,
      -1,    90,    -1,    91,    -1,   307,    -1,    88,    -1,    89,
      -1,    90,    -1,    91,    -1,    92,    -1,    93,    -1,   307,
      -1,   317,    -1,   307,    -1,   344,    -1,   344,   334,   349,
      -1,   347,   334,   344,    -1,   347,   334,   344,   334,   349,
      -1,   344,   334,     1,    -1,   346,    -1,   346,   334,   349,
      -1,   347,   334,   346,    -1,   347,   334,   346,   334,   349,
      -1,   346,   334,     1,    -1,   351,    -1,   351,   352,    -1,
     317,    -1,   303,   317,    -1,   264,   355,    -1,   264,     1,
      -1,   356,    -1,   356,   325,   355,    -1,   357,    -1,   357,
     334,   317,    -1,   320,    -1,   318,    -1,   265,   359,    -1,
     265,     1,    -1,   360,    -1,   360,   325,   359,    -1,   357,
      -1,    94,   284,   353,    -1,    94,   284,     1,    -1,    95,
     284,   317,    -1,    95,   284,     1,    -1,    96,   284,   317,
      -1,    96,   284,     1,    -1,    97,   284,   317,    -1,    97,
     284,     1,    -1,    98,   284,   318,    -1,    98,   284,     1,
      -1,    99,   284,   320,    -1,    99,   284,     1,    -1,   100,
     284,   317,    -1,   100,   284,     1,    -1,   105,   284,   317,
      -1,   105,   284,     1,    -1,   106,   284,   317,    -1,   106,
     284,     1,    -1,   107,   284,   317,    -1,   107,     1,    -1,
     108,   284,   317,    -1,   108,     1,    -1,   109,   284,   317,
      -1,   109,     1,    -1,   110,   284,   353,    -1,   110,     1,
      -1,   111,   284,   353,    -1,   111,     1,    -1,   112,   284,
     353,    -1,   112,     1,    -1,   113,   284,   353,    -1,   113,
       1,    -1,   114,   284,   317,    -1,   114,     1,    -1,   115,
     284,   317,    -1,   115,     1,    -1,   116,   284,   317,    -1,
     116,     1,    -1,   117,   284,   317,    -1,   117,     1,    -1,
     118,   284,   317,    -1,   118,     1,    -1,   119,   284,   317,
      -1,   119,     1,    -1,   120,   284,   317,    -1,   120,     1,
      -1,   121,   284,   317,    -1,   121,     1,    -1,   122,   284,
     317,    -1,   122,     1,    -1,   123,   284,   317,    -1,   123,
       1,    -1,   125,   284,   317,    -1,   125,     1,    -1,   124,
     284,   317,    -1,   124,     1,    -1,   126,   284,   317,    -1,
     126,     1,    -1,   127,   284,   317,    -1,   127,     1,    -1,
     128,   284,   317,    -1,   128,     1,    -1,   129,   284,   317,
      -1,   129,     1,    -1,   130,   284,   317,    -1,   130,     1,
      -1,   131,   284,   317,    -1,   131,     1,    -1,   132,   284,
     317,    -1,   132,     1,    -1,   133,   284,   317,    -1,   133,
       1,    -1,   134,   284,   317,    -1,   134,     1,    -1,   135,
     284,   317,    -1,   135,     1,    -1,   136,   284,   317,    -1,
     136,     1,    -1,   137,   284,   317,    -1,   137,     1,    -1,
     138,   284,   317,    -1,   138,     1,    -1,   139,   284,   317,
      -1,   140,   284,   320,    -1,   160,   284,   317,    -1,   160,
     284,     1,    -1,   161,   284,   317,    -1,   161,   284,     1,
      -1,   139,   284,     1,    -1,   141,   284,   317,    -1,   141,
     284,     1,    -1,   142,   284,   317,    -1,   142,   284,     1,
      -1,   143,   284,   317,    -1,   143,   284,     1,    -1,   144,
     284,   317,    -1,   144,   284,     1,    -1,   145,   284,   317,
      -1,   145,   284,     1,    -1,   146,   284,   353,    -1,   146,
     284,     1,    -1,   147,   284,   353,    -1,   147,   284,     1,
      -1,   148,   284,   353,    -1,   148,   284,     1,    -1,   149,
     284,   353,    -1,   149,   284,     1,    -1,   150,   284,   353,
      -1,   150,   284,     1,    -1,   151,   284,   353,    -1,   151,
     284,     1,    -1,   152,   284,   317,    -1,   152,   284,     1,
      -1,   257,   284,   320,    -1,   257,   284,     1,    -1,   162,
     284,   320,    -1,   162,   284,   318,    -1,   162,   284,     1,
      -1,   163,   284,   320,    -1,   163,   284,   318,    -1,   163,
     284,     1,    -1,   164,   284,   320,    -1,   164,   284,   318,
      -1,   164,   284,     1,    -1,   165,   284,   320,    -1,   165,
     284,   318,    -1,   165,   284,     1,    -1,   166,   284,   317,
      -1,   166,   284,     1,    -1,   167,   284,   317,    -1,   167,
     284,     1,    -1,   168,   284,   317,    -1,   168,   284,     1,
      -1,   169,   284,   317,    -1,   169,   284,     1,    -1,   170,
     284,   353,    -1,   170,   284,     1,    -1,   171,   284,   353,
      -1,   171,   284,     1,    -1,   172,   284,   353,    -1,   172,
     284,     1,    -1,   173,   284,   318,    -1,   173,   284,   320,
      -1,   173,   284,     1,    -1,   174,   284,   317,    -1,   174,
     284,     1,    -1,   175,   284,   317,    -1,   175,   284,     1,
      -1,   176,   284,   317,    -1,   176,   284,     1,    -1,   177,
     284,   366,    -1,   177,   284,     1,    -1,   178,   284,   368,
      -1,   178,   284,     1,    -1,   179,   284,   317,    -1,   179,
     284,     1,    -1,   180,   284,   317,    -1,   180,   284,     1,
      -1,   181,   284,   317,    -1,   181,     1,    -1,   182,   284,
     317,    -1,   182,     1,    -1,   183,   284,   317,    -1,   183,
       1,    -1,   184,   284,   317,    -1,   184,     1,    -1,   185,
     284,   317,    -1,   185,   284,     1,    -1,   186,   284,   317,
      -1,   186,   284,     1,    -1,   187,   284,   317,    -1,   187,
     284,     1,    -1,   188,   284,   317,    -1,   188,   284,     1,
      -1,   189,   284,   317,    -1,   189,   284,     1,    -1,   190,
     284,   317,    -1,   190,   284,     1,    -1,   191,   284,   317,
      -1,   191,   284,     1,    -1,   192,   284,   317,    -1,   192,
     284,     1,    -1,   193,   284,   317,    -1,   193,   284,     1,
      -1,   194,   284,   317,    -1,   194,   284,     1,    -1,   195,
     284,   317,    -1,   195,   284,     1,    -1,   196,   284,   317,
      -1,   196,   284,     1,    -1,   197,   284,   317,    -1,   197,
     284,     1,    -1,   198,   284,   317,    -1,   198,   284,     1,
      -1,   199,   284,   317,    -1,   199,   284,     1,    -1,   200,
     284,   203,    -1,   200,   284,   204,    -1,   200,   284,   205,
      -1,   200,   284,   206,    -1,   200,   284,     1,    -1,   207,
     284,   317,    -1,   207,   284,     1,    -1,   208,   284,   317,
      -1,   208,   284,     1,    -1,   209,   284,   320,    -1,   209,
     284,     1,    -1,   210,   284,   320,    -1,   210,   284,     1,
      -1,   211,   284,   320,    -1,   211,   284,     1,    -1,   201,
     284,   317,    -1,   201,   284,     1,    -1,   202,   284,   317,
      -1,   202,   284,     1,    -1,   212,   284,   317,    -1,   212,
     284,     1,    -1,   213,   284,   317,    -1,   213,   284,     1,
      -1,   214,   284,   317,    -1,   214,   284,     1,    -1,   215,
     284,   317,    -1,   215,   284,     1,    -1,   216,   284,   317,
      -1,   216,   284,     1,    -1,   217,   284,   317,    -1,   217,
     284,     1,    -1,   218,   284,   317,    -1,   218,   284,     1,
      -1,   219,   284,   317,    -1,   219,   284,     1,    -1,   220,
     284,   317,    -1,   220,   284,     1,    -1,   221,   284,   317,
      -1,   221,   284,     1,    -1,   222,   284,   353,    -1,   222,
     284,     1,    -1,   223,   284,   317,    -1,   223,   284,     1,
      -1,   224,   284,   317,    -1,   224,   284,     1,    -1,   225,
     284,   317,    -1,   225,   284,     1,    -1,   226,   284,   317,
      -1,   226,   284,     1,    -1,   227,   284,   317,    -1,   227,
     284,     1,    -1,   228,   284,   317,    -1,   228,   284,     1,
      -1,   229,   284,   353,    -1,   229,   284,     1,    -1,   230,
     284,   317,    -1,   230,   284,     1,    -1,   231,   284,   317,
      -1,   231,   284,     1,    -1,   232,   284,   317,    -1,   232,
     284,     1,    -1,   233,   284,   317,    -1,   233,   284,     1,
      -1,   153,   284,   317,    -1,   153,   284,     1,    -1,   154,
     284,   320,    -1,   154,   284,     1,    -1,   155,   284,   320,
      -1,   155,   284,     1,    -1,   156,   284,   317,    -1,   156,
     284,     1,    -1,   101,   284,   352,    -1,   101,   284,   352,
     102,   344,   334,   317,    -1,   101,   284,     1,    -1,   103,
     284,   352,    -1,   103,   284,     1,    -1,   104,   284,   317,
      -1,   104,   284,     1,    -1,   234,   284,   344,    -1,   234,
     284,     1,    -1,   235,   284,   317,    -1,   235,   284,     1,
      -1,   236,   284,   317,    -1,   236,   284,     1,    -1,   237,
     284,   317,    -1,   237,   284,     1,    -1,   238,   284,   317,
      -1,   238,   284,     1,    -1,   239,   284,   317,    -1,   239,
     284,     1,    -1,   240,   284,   317,    -1,   240,   284,     1,
      -1,   241,   284,   317,    -1,   241,   284,     1,    -1,   242,
     284,   317,    -1,   242,   284,     1,    -1,   243,   284,   317,
      -1,   243,   284,     1,    -1,   244,   284,   317,    -1,   244,
     284,     1,    -1,   245,   284,   317,    -1,   245,   284,     1,
      -1,   246,   284,   317,    -1,   246,   284,     1,    -1,   247,
     284,   317,    -1,   247,   284,     1,    -1,   248,   284,   317,
      -1,   248,   284,     1,    -1,   249,   284,   317,    -1,   249,
     284,     1,    -1,   250,   284,   317,    -1,   250,   284,   318,
      -1,   250,   284,     1,    -1,   251,   284,   317,    -1,   251,
       1,    -1,   252,   284,   317,    -1,   252,   284,     1,    -1,
     253,   284,   317,    -1,   253,   284,     1,    -1,   254,   284,
     317,    -1,   254,   284,     1,    -1,   255,   284,   317,    -1,
     255,   284,     1,    -1,   256,   284,   317,    -1,   256,   284,
       1,    -1,   278,   284,   317,    -1,   278,   284,     1,    -1,
     279,   284,   317,    -1,   279,   284,     1,    -1,   280,   284,
     317,    -1,   280,   284,     1,    -1,   259,   284,   317,    -1,
     260,   284,   317,    -1,   260,   284,     1,    -1,   261,   284,
     317,    -1,   261,   284,     1,    -1,   262,   284,   317,    -1,
     262,   284,     1,    -1,   263,   284,   317,    -1,   263,   284,
       1,    -1,    41,   284,   317,    -1,    41,   284,     1,    -1,
      38,   284,   317,    -1,    38,   284,     1,    -1,    42,   284,
     347,    -1,    42,   284,     1,    -1,    43,   284,   353,    -1,
      43,   284,     1,    -1,    44,   284,   317,    -1,    44,   284,
       1,    -1,    45,   284,   317,    -1,    45,   284,     1,    -1,
     363,    -1,     1,   284,    -1,   318,    -1,    57,    -1,   362,
     314,   362,   284,   317,    -1,   362,   314,   362,   284,   320,
      -1,   362,   314,   362,   284,   317,   258,   320,    -1,   362,
     314,   362,   284,   320,   258,   320,    -1,   362,   314,   362,
     284,     1,    -1,   362,   331,   317,   332,   314,   362,   284,
     317,    -1,   362,   331,   317,   332,   314,   362,   284,   320,
      -1,   157,   320,    -1,   157,     1,    -1,   158,   320,    -1,
     158,     1,    -1,   158,   284,   320,    -1,   158,   284,     1,
      -1,   159,   328,   320,   325,   320,   325,   320,   327,    -1,
     159,   328,   320,   325,   320,   325,   353,   327,    -1,   159,
       1,    -1,   366,    -1,   368,    -1,   317,   314,   317,   314,
     317,   314,   317,    -1,   321,    -1,   367,    -1,   331,   367,
     332,    -1,   317,    -1,   318,    -1,   320,    -1,    14,    -1,
      15,    -1,   370,   329,   398,   330,    -1,    14,   331,   369,
     332,   329,   398,   330,    -1,    14,     1,    -1,    15,     1,
      -1,    16,   329,   398,   330,    -1,    16,   331,   369,   332,
     329,   398,   330,    -1,    16,     1,    -1,    17,    -1,    18,
      -1,    -1,   373,   329,   375,   398,   330,    -1,    17,     1,
      -1,    18,     1,    -1,    -1,    17,   331,   369,   332,   376,
     329,   398,   330,    -1,    17,   331,   369,   332,     1,    -1,
      19,   329,   398,   330,    -1,    19,   331,   369,   332,   329,
     398,   330,    -1,    19,     1,    -1,    20,   329,   398,   330,
      -1,    20,   331,   369,   332,   329,   398,   330,    -1,    20,
       1,    -1,    21,   331,   324,   332,   329,   398,   330,    -1,
      21,     1,    -1,   281,   320,    -1,   281,     1,    -1,   282,
     320,    -1,   282,     1,    -1,   283,   320,    -1,   283,     1,
      -1,   298,    -1,   297,    -1,   293,    -1,   292,    -1,   302,
      -1,   301,    -1,   300,    -1,   299,    -1,   381,    -1,   296,
      -1,   298,    -1,   297,    -1,   295,    -1,   294,    -1,   293,
      -1,   292,    -1,   296,    -1,   302,    -1,   301,    -1,   300,
      -1,   299,    -1,    71,    -1,    72,    -1,    73,    -1,    81,
      -1,    79,    -1,    83,    -1,    75,    -1,    77,    -1,    85,
      -1,    87,    -1,   387,    -1,    80,    -1,    78,    -1,    74,
      -1,    76,    -1,   389,    -1,    70,   383,   426,    -1,    70,
     383,   318,    -1,    70,   383,     1,    -1,    70,     1,    -1,
     386,   383,   426,    -1,   386,   383,    86,    -1,   386,   383,
       1,    -1,   386,     1,    -1,   388,   382,   426,    -1,   388,
     381,   426,    -1,   388,   382,     1,    -1,   388,   381,     1,
      -1,   388,     1,    -1,    84,   381,   348,    -1,    84,   381,
     426,    -1,    84,   381,     1,    -1,    82,   381,   348,    -1,
      82,   381,   426,    -1,    82,   381,     1,    -1,   390,   383,
     392,    -1,   390,   383,   426,    -1,   390,   383,   393,    -1,
     390,   383,    86,    -1,   390,   383,     1,    -1,   390,     1,
      -1,    86,   381,   386,    -1,    86,   381,   390,    -1,    86,
     381,     1,    -1,    86,     1,    -1,   365,   306,   365,    -1,
     365,   306,   317,    -1,   365,    -1,   365,   306,     1,    -1,
     318,    -1,   393,   314,   318,    -1,   393,   303,   318,    -1,
     393,   314,     1,    -1,   393,   303,     1,    -1,   318,    -1,
     319,    -1,   317,    -1,   394,    -1,   395,   314,   394,    -1,
     395,   303,   394,    -1,   395,   314,     1,    -1,   395,   303,
       1,    -1,   429,    -1,   399,    -1,   329,   398,   330,    -1,
     398,   399,    -1,   399,    -1,   398,     1,    -1,   396,   326,
      -1,   400,    -1,   404,    -1,   405,    -1,   433,   326,    -1,
     427,   326,    -1,   326,    -1,   396,     1,    -1,    46,   426,
     397,    -1,    46,   426,   397,    47,   397,    -1,   426,    -1,
      56,   401,   334,   398,    -1,    56,   306,   401,   334,   398,
      -1,    56,   401,   334,    -1,    56,   306,   401,   334,    -1,
      57,   334,   398,    -1,    57,   334,    -1,    56,     1,   334,
     398,    -1,    56,   306,     1,   334,   398,    -1,    56,     1,
     334,    -1,    56,   306,     1,   334,    -1,    56,   401,   334,
       1,    -1,   403,   402,    -1,   402,    -1,    55,   426,   329,
     403,   330,    -1,    55,   426,   329,   330,    -1,    55,     1,
      -1,    55,   426,   329,     1,   330,    -1,    58,   426,   397,
      -1,   318,    -1,   318,   331,   353,   332,    -1,   318,   331,
     320,   332,    -1,   407,   314,   406,    -1,   406,    -1,    -1,
     267,   409,   407,    -1,   268,    -1,   269,    -1,   270,    -1,
     271,    -1,   272,    -1,   273,    -1,   274,    -1,   275,    -1,
     276,    -1,   318,    -1,   411,    -1,   410,   314,   411,    -1,
     266,    -1,   413,   412,    -1,   413,   412,   331,   353,   332,
      -1,   413,   412,   331,   332,    -1,   414,    -1,   416,    -1,
     414,    -1,   416,    -1,   415,    -1,   414,    -1,   421,    -1,
     320,    -1,   322,    -1,   323,    -1,   284,    -1,   417,    -1,
     420,    -1,   421,    -1,   353,    -1,   320,    -1,   418,    -1,
     420,    -1,   421,    -1,   408,    -1,   396,    -1,   391,    -1,
     329,   398,   330,    -1,   329,     1,   330,    -1,   328,   427,
     327,    -1,   328,     1,   327,    -1,   310,    -1,   308,    -1,
     303,    -1,   424,    -1,   425,   426,    -1,   313,   426,    -1,
     312,   426,    -1,   426,   304,   426,    -1,   426,   303,   426,
      -1,   426,   307,   426,    -1,   426,   306,   426,    -1,   426,
     305,   426,    -1,   426,   287,   426,    -1,   426,   288,   426,
      -1,   426,   289,   426,    -1,   426,   290,   426,    -1,   426,
     291,   426,    -1,   426,   385,   426,    -1,   426,   384,   426,
      -1,   426,   286,   426,    -1,   426,   285,   426,    -1,   328,
     426,   327,    -1,   315,   328,   426,   327,    -1,   316,   328,
     426,   327,    -1,   311,   426,    -1,   425,     1,    -1,   313,
       1,    -1,   312,     1,    -1,   426,   304,     1,    -1,   426,
     303,     1,    -1,   426,   307,     1,    -1,   426,   306,     1,
      -1,   426,   305,     1,    -1,   426,   287,     1,    -1,   426,
     288,     1,    -1,   426,   385,     1,    -1,   426,   384,     1,
      -1,   426,   286,     1,    -1,   426,   285,     1,    -1,   315,
     328,     1,   327,    -1,   316,   328,     1,   327,    -1,   311,
       1,    -1,   423,   422,   426,    -1,    67,    -1,    68,    -1,
      69,    -1,     3,   328,   327,    -1,     3,   328,   393,   327,
      -1,     3,   328,   320,   327,    -1,     3,   328,   365,   327,
      -1,     3,   328,   393,   325,   317,   327,    -1,     3,   328,
     320,   325,   317,   327,    -1,     3,   328,   365,   325,   317,
     327,    -1,     3,   328,    61,   325,    62,   327,    -1,     3,
     328,    61,   325,   317,   327,    -1,     3,   328,    61,   327,
      -1,     3,     1,    -1,     3,   328,     1,   327,    -1,     7,
     328,   393,   327,    -1,     7,   328,   320,   327,    -1,     7,
     328,   365,   327,    -1,     7,   328,   393,   325,   317,   327,
      -1,     7,   328,   320,   325,   317,   327,    -1,     7,   328,
     365,   325,   317,   327,    -1,     7,   328,    61,   325,    62,
     327,    -1,     7,   328,    61,   325,   317,   327,    -1,     7,
     328,    61,   327,    -1,     7,     1,    -1,     7,   328,     1,
     327,    -1,     4,   328,   393,   327,    -1,     4,   328,   320,
     327,    -1,     4,   328,   365,   327,    -1,     4,   328,   393,
     325,   317,   327,    -1,     4,   328,   320,   325,   317,   327,
      -1,     4,   328,   365,   325,   317,   327,    -1,     4,   328,
      61,   325,    62,   327,    -1,     4,   328,    61,   325,   317,
     327,    -1,     4,   328,    61,   327,    -1,     4,     1,    -1,
       4,   328,     1,   327,    -1,     5,   328,   393,   327,    -1,
       5,   328,   320,   327,    -1,     5,   328,   365,   327,    -1,
       5,   328,   393,   325,   317,   327,    -1,     5,   328,   320,
     325,   317,   327,    -1,     5,   328,   365,   325,   317,   327,
      -1,     5,   328,    61,   325,    62,   327,    -1,     5,   328,
      61,   325,   317,   327,    -1,     5,   328,    61,   327,    -1,
       5,     1,    -1,     5,   328,     1,   327,    -1,     6,   328,
     393,   327,    -1,     6,   328,   320,   327,    -1,     6,   328,
     365,   327,    -1,     6,   328,   393,   325,   317,   327,    -1,
       6,   328,   320,   325,   317,   327,    -1,     6,   328,   365,
     325,   317,   327,    -1,     6,   328,    61,   325,    62,   327,
      -1,     6,   328,    61,   325,   317,   327,    -1,     6,   328,
      61,   327,    -1,     6,     1,    -1,     6,   328,     1,   327,
      -1,    12,   328,   320,   327,    -1,    12,   328,   317,   325,
     320,   327,    -1,    12,     1,    -1,    12,   328,     1,   327,
      -1,    64,   328,   317,   327,    -1,    64,   328,   357,   327,
      -1,    64,     1,    -1,    65,   328,   317,   327,    -1,    65,
     328,   357,   327,    -1,    65,     1,    -1,    66,   328,   317,
     327,    -1,    66,   328,   357,   327,    -1,    66,     1,    -1,
     428,   328,   419,   325,   357,   327,    -1,   428,   328,   419,
     325,     1,   327,    -1,   428,   328,     1,   325,   357,   327,
      -1,   428,   328,     1,   327,    -1,   428,     1,    -1,    13,
     328,   320,   325,   320,   327,    -1,    13,     1,    -1,    13,
     328,     1,   327,    -1,    14,   328,   426,   327,    -1,    14,
     328,   318,   327,    -1,    14,     1,    -1,    14,   328,     1,
     327,    -1,    22,   328,   320,   327,    -1,    23,   328,   320,
     327,    -1,    23,     1,    -1,    23,   328,     1,   327,    -1,
      26,   328,   320,   327,    -1,    26,     1,    -1,    26,   328,
       1,   327,    -1,    28,   328,   317,   327,    -1,    28,     1,
      -1,    28,   328,     1,   327,    -1,    27,   328,   317,   327,
      -1,    27,     1,    -1,    27,   328,     1,   327,    -1,    29,
     328,   327,    -1,    29,     1,    -1,    31,   328,   353,   327,
      -1,    31,   328,   327,    -1,    31,     1,    -1,    31,   328,
       1,   327,    -1,    32,   328,   327,    -1,    24,   328,   320,
     327,    -1,    24,     1,    -1,    24,   328,     1,   327,    -1,
      25,   328,   320,   327,    -1,    25,     1,    -1,    25,   328,
       1,   327,    -1,    35,   328,   320,   327,    -1,    35,     1,
      -1,    35,   328,     1,   327,    -1,    33,   328,   320,   327,
      -1,    33,     1,    -1,    33,   328,     1,   327,    -1,    34,
     328,   320,   327,    -1,    34,     1,    -1,    34,   328,     1,
     327,    -1,    36,   328,   320,   327,    -1,    36,     1,    -1,
      36,   328,     1,   327,    -1,    37,   328,   327,    -1,    37,
      -1,    38,   328,   327,    -1,    38,    -1,    39,   328,   327,
      -1,    39,    -1,    40,   328,   317,   327,    -1,    40,   328,
     327,    -1,    40,    -1,    40,   328,     1,   327,    -1,    42,
     328,   347,   327,    -1,    42,   328,     1,   327,    -1,    48,
     328,   344,   327,    -1,    48,   328,     1,   327,    -1,    48,
       1,    -1,    49,   328,   317,   327,    -1,    49,   328,     1,
     327,    -1,    49,     1,    -1,    50,   328,   350,   327,    -1,
      50,   328,     1,   327,    -1,    50,     1,    -1,    51,   328,
     327,    -1,    51,    -1,    52,   328,   327,    -1,    52,    -1,
      53,   328,   327,    -1,    53,    -1,    54,   328,   327,    -1,
      54,    -1,    59,   328,   320,   325,   317,   327,    -1,    59,
     328,   320,   325,   426,   327,    -1,    59,     1,    -1,    59,
     328,     1,   327,    -1,    60,   328,   320,   327,    -1,    60,
       1,    -1,    60,   328,     1,   327,    -1,    -1,   318,   430,
     328,   431,   327,    -1,   318,     1,    -1,    -1,   431,   325,
     432,    -1,   432,    -1,   426,    -1,     9,   328,   327,    -1,
       9,   426,    -1,     9,    -1,     8,   328,   327,    -1,     8,
     426,    -1,     8,    -1,    10,    -1,    10,   328,   327,    -1,
      10,   426,    -1,    11,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   693,   693,   696,   697,   698,   701,   702,   703,   704,
     705,   706,   706,   707,   707,   708,   709,   709,   710,   710,
     711,   711,   712,   713,   716,   734,   743,   758,   759,   765,
     766,   770,   771,   772,   773,   774,   777,   778,   779,   780,
     781,   782,   783,   786,   787,   790,   791,   792,   793,   794,
     798,   799,   800,   801,   802,   806,   807,   810,   811,   814,
     815,   817,   818,   821,   824,   830,   831,   835,   836,   839,
     840,   843,   849,   850,   851,   852,   853,   854,   855,   858,
     859,   865,   866,   867,   868,   869,   870,   871,   872,   873,
     874,   875,   876,   877,   878,   879,   880,   881,   882,   883,
     884,   885,   886,   888,   889,   890,   891,   892,   893,   894,
     895,   896,   897,   898,   899,   900,   901,   902,   903,   904,
     905,   906,   907,   908,   909,   910,   911,   912,   913,   914,
     915,   916,   917,   918,   919,   920,   921,   922,   923,   926,
     927,   930,   931,   934,   935,   936,   937,   940,   941,   944,
     945,   948,   949,   952,   953,   954,   959,   960,   961,   962,
     963,   964,   965,   966,   967,   968,   969,   970,   971,   972,
     973,   974,   975,   976,   977,   978,   979,   980,   981,   982,
     983,   984,   985,   986,   987,   988,   991,   992,   999,  1006,
    1007,  1008,  1009,  1010,  1011,  1012,  1013,  1014,  1015,  1016,
    1017,  1018,  1025,  1026,  1033,  1034,  1041,  1042,  1049,  1050,
    1057,  1058,  1068,  1069,  1083,  1097,  1098,  1105,  1106,  1113,
    1114,  1121,  1122,  1131,  1132,  1145,  1146,  1153,  1154,  1161,
    1162,  1169,  1170,  1177,  1178,  1185,  1186,  1193,  1194,  1201,
    1202,  1209,  1210,  1217,  1218,  1225,  1226,  1233,  1234,  1241,
    1242,  1249,  1250,  1257,  1258,  1265,  1266,  1273,  1274,  1281,
    1282,  1289,  1290,  1297,  1298,  1305,  1306,  1313,  1314,  1321,
    1328,  1335,  1342,  1349,  1356,  1357,  1364,  1365,  1372,  1373,
    1380,  1381,  1388,  1389,  1396,  1397,  1404,  1405,  1412,  1413,
    1420,  1421,  1428,  1429,  1436,  1437,  1444,  1445,  1452,  1453,
    1460,  1461,  1468,  1469,  1482,  1483,  1496,  1497,  1500,  1501,
    1504,  1505,  1508,  1509,  1512,  1513,  1516,  1517,  1520,  1521,
    1524,  1525,  1528,  1529,  1532,  1533,  1536,  1537,  1540,  1541,
    1544,  1545,  1546,  1547,  1550,  1551,  1554,  1555,  1556,  1557,
    1570,  1584,  1586,  1597,  1598,  1599,  1600,  1606,  1607,  1617,
    1618,  1619,  1620,  1621,  1622,  1629,  1630,  1637,  1638,  1639,
    1640,  1641,  1642,  1643,  1644,  1645,  1646,  1647,  1648,  1649,
    1650,  1651,  1652,  1653,  1654,  1661,  1662,  1669,  1670,  1671,
    1698,  1699,  1700,  1701,  1702,  1703,  1704,  1705,  1706,  1707,
    1708,  1709,  1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,
    1718,  1719,  1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,
    1728,  1730,  1731,  1733,  1735,  1736,  1737,  1740,  1741,  1744,
    1745,  1746,  1749,  1750,  1754,  1759,  1764,  1769,  1774,  1777,
    1782,  1790,  1796,  1797,  1802,  1803,  1808,  1809,  1820,  1831,
    1834,  1835,  1838,  1867,  1887,  1888,  1892,  1902,  1903,  1907,
    1908,  1912,  1921,  1939,  1940,  1943,  1952,  1970,  1974,  1975,
    1980,  1980,  1989,  1990,  1992,  1991,  2016,  2021,  2030,  2048,
    2050,  2059,  2077,  2079,  2098,  2101,  2102,  2103,  2104,  2105,
    2106,  2128,  2129,  2130,  2131,  2134,  2135,  2136,  2137,  2140,
    2141,  2147,  2148,  2149,  2150,  2151,  2152,  2153,  2156,  2157,
    2158,  2159,  2166,  2167,  2168,  2175,  2176,  2177,  2181,  2182,
    2183,  2184,  2185,  2190,  2191,  2194,  2195,  2196,  2202,  2204,
    2206,  2207,  2209,  2211,  2213,  2215,  2217,  2218,  2220,  2221,
    2222,  2223,  2225,  2227,  2229,  2231,  2233,  2235,  2236,  2274,
    2276,  2278,  2280,  2283,  2285,  2287,  2289,  2306,  2307,  2318,
    2319,  2323,  2324,  2340,  2356,  2357,  2360,  2361,  2362,  2371,
    2372,  2388,  2404,  2406,  2413,  2455,  2456,  2459,  2460,  2461,
    2464,  2465,  2466,  2467,  2468,  2469,  2470,  2471,  2474,  2482,
    2492,  2509,  2516,  2523,  2530,  2537,  2542,  2547,  2548,  2549,
    2550,  2551,  2554,  2563,  2570,  2595,  2611,  2612,  2617,  2636,
    2645,  2657,  2672,  2673,  2676,  2676,  2686,  2687,  2688,  2689,
    2690,  2691,  2692,  2693,  2694,  2697,  2700,  2701,  2704,  2711,
    2714,  2721,  2727,  2728,  2737,  2738,  2739,  2742,  2743,  2755,
    2779,  2797,  2832,  2836,  2846,  2861,  2873,  2874,  2876,  2877,
    2878,  2892,  2893,  2894,  2895,  2896,  2897,  2898,  2902,  2903,
    2904,  2917,  2923,  2924,  2925,  2926,  2927,  2928,  2929,  2930,
    2931,  2932,  2933,  2934,  2935,  2936,  2937,  2939,  2940,  2941,
    2942,  2943,  2944,  2945,  2946,  2947,  2948,  2949,  2950,  2951,
    2952,  2953,  2954,  2955,  2957,  2959,  2960,  2961,  2962,  2963,
    2966,  2984,  2985,  2986,  2989,  2990,  2991,  2992,  2993,  2994,
    2995,  2996,  2997,  2998,  2999,  3000,  3001,  3002,  3003,  3004,
    3005,  3006,  3007,  3008,  3009,  3010,  3011,  3012,  3013,  3014,
    3015,  3016,  3017,  3018,  3019,  3020,  3021,  3022,  3023,  3031,
    3039,  3047,  3055,  3063,  3071,  3079,  3087,  3095,  3096,  3098,
    3106,  3114,  3122,  3131,  3140,  3149,  3157,  3166,  3174,  3175,
    3177,  3180,  3181,  3182,  3183,  3190,  3197,  3198,  3204,  3211,
    3212,  3218,  3225,  3226,  3232,  3235,  3238,  3239,  3240,  3243,
    3244,  3245,  3254,  3263,  3264,  3265,  3266,  3267,  3268,  3269,
    3270,  3271,  3272,  3273,  3274,  3275,  3276,  3277,  3278,  3279,
    3280,  3284,  3288,  3289,  3290,  3291,  3292,  3293,  3294,  3295,
    3296,  3297,  3298,  3299,  3300,  3301,  3302,  3303,  3304,  3305,
    3306,  3307,  3308,  3309,  3310,  3311,  3312,  3313,  3314,  3315,
    3323,  3331,  3339,  3340,  3342,  3344,  3355,  3356,  3357,  3373,
    3374,  3375,  3379,  3382,  3383,  3386,  3389,  3392,  3395,  3398,
    3401,  3404,  3407,  3410,  3413,  3414,  3415,  3418,  3419,  3420,
    3420,  3447,  3449,  3451,  3452,  3455,  3472,  3476,  3480,  3484,
    3489,  3493,  3498,  3502,  3506,  3510
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "FORWARD", "FORWARD_TCP", "FORWARD_TLS",
  "FORWARD_SCTP", "FORWARD_UDP", "EXIT", "DROP", "RETURN", "BREAK",
  "LOG_TOK", "ERROR", "ROUTE", "ROUTE_REQUEST", "ROUTE_FAILURE",
  "ROUTE_ONREPLY", "ROUTE_REPLY", "ROUTE_BRANCH", "ROUTE_SEND",
  "ROUTE_EVENT", "EXEC", "SET_HOST", "SET_HOSTPORT", "SET_HOSTPORTTRANS",
  "PREFIX", "STRIP", "STRIP_TAIL", "SET_USERPHONE", "APPEND_BRANCH",
  "REMOVE_BRANCH", "CLEAR_BRANCHES", "SET_USER", "SET_USERPASS",
  "SET_PORT", "SET_URI", "REVERT_URI", "FORCE_RPORT", "ADD_LOCAL_RPORT",
  "FORCE_TCP_ALIAS", "UDP_MTU", "UDP_MTU_TRY_PROTO", "UDP4_RAW",
  "UDP4_RAW_MTU", "UDP4_RAW_TTL", "IF", "ELSE", "SET_ADV_ADDRESS",
  "SET_ADV_PORT", "FORCE_SEND_SOCKET", "SET_FWD_NO_CONNECT",
  "SET_RPL_NO_CONNECT", "SET_FWD_CLOSE", "SET_RPL_CLOSE", "SWITCH", "CASE",
  "DEFAULT", "WHILE", "CFG_SELECT", "CFG_RESET", "URIHOST", "URIPORT",
  "MAX_LEN", "SETFLAG", "RESETFLAG", "ISFLAGSET", "SETAVPFLAG",
  "RESETAVPFLAG", "ISAVPFLAGSET", "METHOD", "URI", "FROM_URI", "TO_URI",
  "SRCIP", "SRCPORT", "DSTIP", "DSTPORT", "TOIP", "TOPORT", "SNDIP",
  "SNDPORT", "SNDPROTO", "SNDAF", "PROTO", "AF", "MYSELF", "MSGLEN", "UDP",
  "TCP", "TLS", "SCTP", "WS", "WSS", "DEBUG_V", "FORK", "FORK_DELAY",
  "LOGSTDERROR", "LOGFACILITY", "LOGNAME", "LOGCOLOR", "LISTEN",
  "ADVERTISE", "ALIAS", "SR_AUTO_ALIASES", "DNS", "REV_DNS",
  "DNS_TRY_IPV6", "DNS_TRY_NAPTR", "DNS_SRV_LB", "DNS_UDP_PREF",
  "DNS_TCP_PREF", "DNS_TLS_PREF", "DNS_SCTP_PREF", "DNS_RETR_TIME",
  "DNS_RETR_NO", "DNS_SERVERS_NO", "DNS_USE_SEARCH", "DNS_SEARCH_FMATCH",
  "DNS_CACHE_INIT", "DNS_USE_CACHE", "DNS_USE_FAILOVER", "DNS_CACHE_FLAGS",
  "DNS_CACHE_NEG_TTL", "DNS_CACHE_MIN_TTL", "DNS_CACHE_MAX_TTL",
  "DNS_CACHE_MEM", "DNS_CACHE_GC_INT", "DNS_CACHE_DEL_NONEXP",
  "AUTO_BIND_IPV6", "DST_BLST_INIT", "USE_DST_BLST", "DST_BLST_MEM",
  "DST_BLST_TTL", "DST_BLST_GC_INT", "DST_BLST_UDP_IMASK",
  "DST_BLST_TCP_IMASK", "DST_BLST_TLS_IMASK", "DST_BLST_SCTP_IMASK",
  "PORT", "STAT", "CHILDREN", "SOCKET_WORKERS", "CHECK_VIA", "PHONE2TEL",
  "SYN_BRANCH", "MEMLOG", "MEMDBG", "MEMSUM", "MEMSAFETY", "MEMJOIN",
  "CORELOG", "SIP_WARNING", "SERVER_SIGNATURE", "SERVER_HEADER",
  "USER_AGENT_HEADER", "REPLY_TO_VIA", "LOADMODULE", "LOADPATH",
  "MODPARAM", "MAXBUFFER", "SQL_BUFFER_SIZE", "USER", "GROUP", "CHROOT",
  "WDIR", "MHOMED", "DISABLE_TCP", "TCP_ACCEPT_ALIASES", "TCP_CHILDREN",
  "TCP_CONNECT_TIMEOUT", "TCP_SEND_TIMEOUT", "TCP_CON_LIFETIME",
  "TCP_POLL_METHOD", "TCP_MAX_CONNECTIONS", "TLS_MAX_CONNECTIONS",
  "TCP_NO_CONNECT", "TCP_SOURCE_IPV4", "TCP_SOURCE_IPV6",
  "TCP_OPT_FD_CACHE", "TCP_OPT_BUF_WRITE", "TCP_OPT_CONN_WQ_MAX",
  "TCP_OPT_WQ_MAX", "TCP_OPT_RD_BUF", "TCP_OPT_WQ_BLK",
  "TCP_OPT_DEFER_ACCEPT", "TCP_OPT_DELAYED_ACK", "TCP_OPT_SYNCNT",
  "TCP_OPT_LINGER2", "TCP_OPT_KEEPALIVE", "TCP_OPT_KEEPIDLE",
  "TCP_OPT_KEEPINTVL", "TCP_OPT_KEEPCNT", "TCP_OPT_CRLF_PING",
  "TCP_OPT_ACCEPT_NO_CL", "TCP_CLONE_RCVBUF", "DISABLE_TLS", "ENABLE_TLS",
  "TLSLOG", "TLS_PORT_NO", "TLS_METHOD", "TLS_HANDSHAKE_TIMEOUT",
  "TLS_SEND_TIMEOUT", "SSLv23", "SSLv2", "SSLv3", "TLSv1", "TLS_VERIFY",
  "TLS_REQUIRE_CERTIFICATE", "TLS_CERTIFICATE", "TLS_PRIVATE_KEY",
  "TLS_CA_LIST", "DISABLE_SCTP", "ENABLE_SCTP", "SCTP_CHILDREN",
  "SCTP_SOCKET_RCVBUF", "SCTP_SOCKET_SNDBUF", "SCTP_AUTOCLOSE",
  "SCTP_SEND_TTL", "SCTP_SEND_RETRIES", "SCTP_ASSOC_TRACKING",
  "SCTP_ASSOC_REUSE", "SCTP_MAX_ASSOCS", "SCTP_SRTO_INITIAL",
  "SCTP_SRTO_MAX", "SCTP_SRTO_MIN", "SCTP_ASOCMAXRXT",
  "SCTP_INIT_MAX_ATTEMPTS", "SCTP_INIT_MAX_TIMEO", "SCTP_HBINTERVAL",
  "SCTP_PATHMAXRXT", "SCTP_SACK_DELAY", "SCTP_SACK_FREQ", "SCTP_MAX_BURST",
  "ADVERTISED_ADDRESS", "ADVERTISED_PORT", "DISABLE_CORE", "OPEN_FD_LIMIT",
  "SHM_MEM_SZ", "SHM_FORCE_ALLOC", "MLOCK_PAGES", "REAL_TIME", "RT_PRIO",
  "RT_POLICY", "RT_TIMER1_PRIO", "RT_TIMER1_POLICY", "RT_TIMER2_PRIO",
  "RT_TIMER2_POLICY", "MCAST_LOOPBACK", "MCAST_TTL", "TOS",
  "PMTU_DISCOVERY", "KILL_TIMEOUT", "MAX_WLOOPS", "PVBUFSIZE",
  "PVBUFSLOTS", "HTTP_REPLY_HACK", "VERSION_TABLE_CFG", "CFG_DESCRIPTION",
  "SERVER_ID", "LATENCY_LOG", "LATENCY_LIMIT_DB", "LATENCY_LIMIT_ACTION",
  "MSG_TIME", "FLAGS_DECL", "AVPFLAGS_DECL", "ATTR_MARK", "SELECT_MARK",
  "ATTR_FROM", "ATTR_TO", "ATTR_FROMURI", "ATTR_TOURI", "ATTR_FROMUSER",
  "ATTR_TOUSER", "ATTR_FROMDOMAIN", "ATTR_TODOMAIN", "ATTR_GLOBAL",
  "ADDEQ", "STUN_REFRESH_INTERVAL", "STUN_ALLOW_STUN", "STUN_ALLOW_FP",
  "SUBST", "SUBSTDEF", "SUBSTDEFS", "EQUAL", "LOG_OR", "LOG_AND", "BIN_OR",
  "BIN_AND", "BIN_XOR", "BIN_LSHIFT", "BIN_RSHIFT", "STRDIFF", "STREQ",
  "INTDIFF", "INTEQ", "MATCH", "DIFF", "EQUAL_T", "LTE", "GTE", "LT", "GT",
  "MINUS", "PLUS", "MODULO", "SLASH", "STAR", "BIN_NOT", "UNARY", "NOT",
  "DEFINED", "STRCAST", "INTCAST", "DOT", "STRLEN", "STREMPTY", "NUMBER",
  "ID", "NUM_ID", "STRING", "IPV6ADDR", "PVAR", "AVP_OR_PVAR",
  "EVENT_RT_NAME", "COMMA", "SEMICOLON", "RPAREN", "LPAREN", "LBRACE",
  "RBRACE", "LBRACK", "RBRACK", "CR", "COLON", "$accept", "cfg",
  "statements", "statement", "$@1", "$@2", "$@3", "$@4", "$@5",
  "listen_id", "listen_id_lst", "listen_id2", "proto", "eqproto", "port",
  "phostport", "listen_phostport", "id_lst", "intno", "flags_decl",
  "flag_list", "flag_spec", "flag_name", "avpflags_decl", "avpflag_list",
  "avpflag_spec", "assign_stm", "cfg_var_id", "cfg_var", "module_stm",
  "ip", "ipv4", "ipv6addr", "ipv6", "route_name", "route_main",
  "route_stm", "failure_route_stm", "route_reply_main",
  "onreply_route_stm", "$@6", "$@7", "branch_route_stm", "send_route_stm",
  "event_route_stm", "preprocess_stm", "equalop", "cmpop", "strop",
  "rve_equalop", "rve_cmpop", "uri_type", "eint_op_onsend", "eint_op",
  "eip_op_onsend", "eip_op", "exp_elem", "ipnet", "host", "host_if_id",
  "host_or_if", "fcmd", "stm", "actions", "action", "if_cmd", "ct_rval",
  "single_case", "case_stms", "switch_cmd", "while_cmd", "select_param",
  "select_params", "select_id", "$@8", "attr_class_spec", "attr_name_spec",
  "attr_spec", "attr_mark", "attr_id", "attr_id_num_idx", "attr_id_no_idx",
  "attr_id_ass", "attr_id_any", "attr_id_any_str", "pvar", "avp_pvar",
  "assign_op", "lval", "rval", "rve_un_op", "rval_expr", "assign_action",
  "avpflag_oper", "cmd", "$@9", "func_params", "func_param", "ret_cmd", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   335,   336,   337,   337,   337,   338,   338,   338,   338,
     338,   339,   338,   340,   338,   338,   341,   338,   342,   338,
     343,   338,   338,   338,   344,   344,   344,   345,   345,   346,
     346,   347,   347,   347,   347,   347,   348,   348,   348,   348,
     348,   348,   348,   349,   349,   350,   350,   350,   350,   350,
     351,   351,   351,   351,   351,   352,   352,   353,   353,   354,
     354,   355,   355,   356,   356,   357,   357,   358,   358,   359,
     359,   360,   361,   361,   361,   361,   361,   361,   361,   361,
     361,   361,   361,   361,   361,   361,   361,   361,   361,   361,
     361,   361,   361,   361,   361,   361,   361,   361,   361,   361,
     361,   361,   361,   361,   361,   361,   361,   361,   361,   361,
     361,   361,   361,   361,   361,   361,   361,   361,   361,   361,
     361,   361,   361,   361,   361,   361,   361,   361,   361,   361,
     361,   361,   361,   361,   361,   361,   361,   361,   361,   361,
     361,   361,   361,   361,   361,   361,   361,   361,   361,   361,
     361,   361,   361,   361,   361,   361,   361,   361,   361,   361,
     361,   361,   361,   361,   361,   361,   361,   361,   361,   361,
     361,   361,   361,   361,   361,   361,   361,   361,   361,   361,
     361,   361,   361,   361,   361,   361,   361,   361,   361,   361,
     361,   361,   361,   361,   361,   361,   361,   361,   361,   361,
     361,   361,   361,   361,   361,   361,   361,   361,   361,   361,
     361,   361,   361,   361,   361,   361,   361,   361,   361,   361,
     361,   361,   361,   361,   361,   361,   361,   361,   361,   361,
     361,   361,   361,   361,   361,   361,   361,   361,   361,   361,
     361,   361,   361,   361,   361,   361,   361,   361,   361,   361,
     361,   361,   361,   361,   361,   361,   361,   361,   361,   361,
     361,   361,   361,   361,   361,   361,   361,   361,   361,   361,
     361,   361,   361,   361,   361,   361,   361,   361,   361,   361,
     361,   361,   361,   361,   361,   361,   361,   361,   361,   361,
     361,   361,   361,   361,   361,   361,   361,   361,   361,   361,
     361,   361,   361,   361,   361,   361,   361,   361,   361,   361,
     361,   361,   361,   361,   361,   361,   361,   361,   361,   361,
     361,   361,   361,   361,   361,   361,   361,   361,   361,   361,
     361,   361,   361,   361,   361,   361,   361,   361,   361,   361,
     361,   361,   361,   361,   361,   361,   361,   361,   361,   361,
     361,   361,   361,   361,   361,   361,   361,   361,   361,   361,
     361,   361,   361,   361,   361,   361,   361,   361,   361,   361,
     361,   361,   361,   361,   361,   361,   361,   361,   361,   361,
     361,   361,   361,   361,   361,   361,   361,   361,   361,   361,
     361,   361,   361,   361,   361,   361,   361,   361,   361,   361,
     361,   361,   361,   361,   361,   361,   361,   361,   361,   361,
     361,   361,   361,   361,   361,   361,   361,   361,   361,   361,
     361,   361,   362,   362,   363,   363,   363,   363,   363,   363,
     363,   364,   364,   364,   364,   364,   364,   364,   364,   364,
     365,   365,   366,   367,   368,   368,   369,   369,   369,   370,
     370,   371,   371,   371,   371,   372,   372,   372,   373,   373,
     375,   374,   374,   374,   376,   374,   374,   377,   377,   377,
     378,   378,   378,   379,   379,   380,   380,   380,   380,   380,
     380,   381,   381,   381,   381,   382,   382,   382,   382,   383,
     383,   384,   384,   384,   384,   384,   384,   384,   385,   385,
     385,   385,   386,   386,   386,   387,   387,   387,   388,   388,
     388,   388,   388,   389,   389,   390,   390,   390,   391,   391,
     391,   391,   391,   391,   391,   391,   391,   391,   391,   391,
     391,   391,   391,   391,   391,   391,   391,   391,   391,   391,
     391,   391,   391,   391,   391,   391,   391,   392,   392,   392,
     392,   393,   393,   393,   393,   393,   394,   394,   394,   395,
     395,   395,   395,   395,   396,   397,   397,   398,   398,   398,
     399,   399,   399,   399,   399,   399,   399,   399,   400,   400,
     401,   402,   402,   402,   402,   402,   402,   402,   402,   402,
     402,   402,   403,   403,   404,   404,   404,   404,   405,   406,
     406,   406,   407,   407,   409,   408,   410,   410,   410,   410,
     410,   410,   410,   410,   410,   411,   412,   412,   413,   414,
     415,   416,   417,   417,   418,   418,   418,   419,   419,   419,
     420,   421,   422,   423,   423,   423,   424,   424,   424,   424,
     424,   424,   424,   424,   424,   424,   424,   424,   425,   425,
     425,   426,   426,   426,   426,   426,   426,   426,   426,   426,
     426,   426,   426,   426,   426,   426,   426,   426,   426,   426,
     426,   426,   426,   426,   426,   426,   426,   426,   426,   426,
     426,   426,   426,   426,   426,   426,   426,   426,   426,   426,
     427,   428,   428,   428,   429,   429,   429,   429,   429,   429,
     429,   429,   429,   429,   429,   429,   429,   429,   429,   429,
     429,   429,   429,   429,   429,   429,   429,   429,   429,   429,
     429,   429,   429,   429,   429,   429,   429,   429,   429,   429,
     429,   429,   429,   429,   429,   429,   429,   429,   429,   429,
     429,   429,   429,   429,   429,   429,   429,   429,   429,   429,
     429,   429,   429,   429,   429,   429,   429,   429,   429,   429,
     429,   429,   429,   429,   429,   429,   429,   429,   429,   429,
     429,   429,   429,   429,   429,   429,   429,   429,   429,   429,
     429,   429,   429,   429,   429,   429,   429,   429,   429,   429,
     429,   429,   429,   429,   429,   429,   429,   429,   429,   429,
     429,   429,   429,   429,   429,   429,   429,   429,   429,   429,
     429,   429,   429,   429,   429,   429,   429,   429,   429,   429,
     429,   429,   429,   429,   429,   429,   429,   429,   429,   429,
     429,   429,   429,   429,   429,   429,   429,   429,   429,   429,
     429,   429,   429,   429,   429,   429,   429,   429,   429,   430,
     429,   429,   431,   431,   431,   432,   433,   433,   433,   433,
     433,   433,   433,   433,   433,   433
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     1,     2,     1,     1,     1,     1,
       1,     0,     2,     0,     2,     1,     0,     2,     0,     2,
       0,     2,     1,     1,     1,     1,     1,     1,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     5,     3,
       1,     3,     3,     5,     3,     1,     2,     1,     2,     2,
       2,     1,     3,     1,     3,     1,     1,     2,     2,     1,
       3,     1,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       7,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       1,     2,     1,     1,     5,     5,     7,     7,     5,     8,
       8,     2,     2,     2,     2,     3,     3,     8,     8,     2,
       1,     1,     7,     1,     1,     3,     1,     1,     1,     1,
       1,     4,     7,     2,     2,     4,     7,     2,     1,     1,
       0,     5,     2,     2,     0,     8,     5,     4,     7,     2,
       4,     7,     2,     7,     2,     2,     2,     2,     2,     2,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     3,
       3,     2,     3,     3,     3,     2,     3,     3,     3,     3,
       2,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     3,     3,     3,     2,     3,     3,     1,
       3,     1,     3,     3,     3,     3,     1,     1,     1,     1,
       3,     3,     3,     3,     1,     1,     3,     2,     1,     2,
       2,     1,     1,     1,     2,     2,     1,     2,     3,     5,
       1,     4,     5,     3,     4,     3,     2,     4,     5,     3,
       4,     4,     2,     1,     5,     4,     2,     5,     3,     1,
       4,     4,     3,     1,     0,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     1,     2,
       5,     4,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     3,     3,     3,     1,     1,
       1,     1,     2,     2,     2,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       4,     4,     2,     2,     2,     2,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     4,     4,     2,
       3,     1,     1,     1,     3,     4,     4,     4,     6,     6,
       6,     6,     6,     4,     2,     4,     4,     4,     4,     6,
       6,     6,     6,     6,     4,     2,     4,     4,     4,     4,
       6,     6,     6,     6,     6,     4,     2,     4,     4,     4,
       4,     6,     6,     6,     6,     6,     4,     2,     4,     4,
       4,     4,     6,     6,     6,     6,     6,     4,     2,     4,
       4,     6,     2,     4,     4,     4,     2,     4,     4,     2,
       4,     4,     2,     6,     6,     6,     4,     2,     6,     2,
       4,     4,     4,     2,     4,     4,     4,     2,     4,     4,
       2,     4,     4,     2,     4,     4,     2,     4,     3,     2,
       4,     3,     2,     4,     3,     4,     2,     4,     4,     2,
       4,     4,     2,     4,     4,     2,     4,     4,     2,     4,
       4,     2,     4,     3,     1,     3,     1,     3,     1,     4,
       3,     1,     4,     4,     4,     4,     4,     2,     4,     4,
       2,     4,     4,     2,     3,     1,     3,     1,     3,     1,
       3,     1,     6,     6,     2,     4,     4,     2,     4,     0,
       5,     2,     0,     3,     1,     1,     3,     2,     1,     3,
       2,     1,     1,     3,     2,     1
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     423,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   422,    22,    23,     0,     0,     4,     0,
       0,     0,     0,     0,     8,     9,     6,     0,   420,    10,
       0,    15,     7,   421,   462,     0,   463,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    91,     0,    93,     0,    95,
       0,    97,     0,    99,     0,   101,     0,   103,     0,   105,
       0,   107,     0,   109,     0,   111,     0,   113,     0,   115,
       0,   117,     0,   119,     0,   121,     0,   123,     0,   127,
       0,   125,     0,   129,     0,   131,     0,   133,     0,   135,
       0,   137,     0,   139,     0,   141,     0,   143,     0,   145,
       0,   147,     0,   149,     0,   151,     0,   153,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   432,   431,   434,
       0,   433,   439,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   231,     0,   233,     0,   235,
       0,   237,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   382,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    60,    66,
      65,    59,    61,    63,    68,    71,    67,    69,     0,     0,
       0,   476,   475,   478,   477,   480,   479,     1,     5,     3,
       0,     0,     0,    12,     0,    14,     0,    17,     0,    19,
       0,    21,     0,     0,   460,   446,   447,   448,     0,   411,
     410,   409,   408,   413,    31,    32,    33,    34,    35,   412,
     415,     0,    57,   414,   417,   416,   419,   418,    73,    72,
      75,    74,    77,    76,    79,    78,    81,    80,    83,    82,
      85,    84,   341,   558,   556,   557,    25,   443,     0,     0,
      30,    50,     0,    55,   339,    24,   440,   444,   441,   559,
      26,   343,   342,   345,   344,    87,    86,    89,    88,    90,
      92,    94,    96,    98,   100,   102,   104,   106,   108,   110,
     112,   114,   116,   118,   120,   122,   126,   124,   128,   130,
     132,   134,   136,   138,   140,   142,   144,   146,   148,   150,
     152,   160,   154,   155,   162,   161,   164,   163,   166,   165,
     168,   167,   170,   169,   172,   171,   174,   173,   176,   175,
     178,   177,   180,   179,   182,   181,   184,   183,   332,   331,
     334,   333,   336,   335,   338,   337,   436,   435,     0,   157,
     156,   159,   158,   189,   188,   187,   192,   191,   190,   195,
     194,   193,   198,   197,   196,   200,   199,   202,   201,   204,
     203,   206,   205,   208,   207,   210,   209,   212,   211,   215,
     213,   214,   217,   216,   219,   218,   221,   220,   223,     0,
     222,   225,   224,   227,   226,   229,   228,   230,   232,   234,
     236,   239,   238,   241,   240,   243,   242,   245,   244,   247,
     246,   249,   248,   251,   250,   253,   252,   255,   254,   257,
     256,   259,   258,   261,   260,   263,   262,   265,   264,   267,
     266,   272,   268,   269,   270,   271,   284,   283,   286,   285,
     274,   273,   276,   275,   278,   277,   280,   279,   282,   281,
     288,   287,   290,   289,   292,   291,   294,   293,   296,   295,
     298,   297,   300,   299,   302,   301,   304,   303,   306,   305,
     308,   307,   310,   309,   312,   311,   314,   313,   316,   315,
     318,   317,   320,   319,   322,   321,   324,   323,   326,   325,
     328,   327,   330,   329,   347,   346,   349,   348,   351,   350,
     353,   352,   355,   354,   357,   356,   359,   358,   361,   360,
     363,   362,   365,   364,   367,   366,   369,   368,   371,   370,
     373,   372,   375,   374,   377,   376,   380,   378,   379,   381,
     384,   383,   386,   385,   388,   387,   390,   389,   392,   391,
     186,   185,   399,   401,   400,   403,   402,   405,   404,   407,
     406,     0,     0,     0,   394,   393,   396,   395,   398,   397,
     453,     0,   454,     0,   457,     0,     0,   469,     0,     0,
     472,     0,     0,   474,     0,     0,     0,     0,     0,    58,
       0,    27,     0,     0,     0,     0,    56,     0,     0,     0,
       0,    62,    64,    70,     0,     0,     0,     0,     0,     0,
     861,   858,   862,   865,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   814,   816,   818,   821,     0,     0,     0,     0,     0,
     835,   837,   839,   841,     0,     0,     0,     0,     0,     0,
       0,   691,   692,   693,   618,     0,   630,   631,   576,     0,
       0,   568,   571,   572,   573,     0,   622,   623,   633,   634,
     635,     0,     0,     0,   564,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   466,     0,     0,     0,
      29,   445,    54,    44,    43,    51,    52,     0,   563,   558,
     561,   562,   560,     0,     0,   704,     0,   726,     0,   737,
       0,   748,     0,   715,     0,     0,   502,   503,   504,   515,
     508,   516,   509,   514,   506,   513,   505,     0,   507,     0,
     510,     0,   511,   604,   650,   649,   648,     0,     0,     0,
       0,     0,   637,     0,     0,   636,     0,   512,     0,   517,
       0,   643,   642,   641,     0,   624,   626,   625,   638,   639,
     640,   651,     0,   860,     0,   857,     0,   864,   752,     0,
     769,     0,   773,     0,     0,   777,     0,   796,     0,   799,
       0,   780,     0,   786,     0,   783,     0,   789,     0,   792,
       0,     0,   805,     0,   808,     0,   802,     0,   811,     0,
       0,     0,     0,     0,     0,     0,     0,   827,     0,   830,
       0,   833,     0,     0,     0,     0,     0,   596,     0,     0,
     844,     0,   847,     0,   756,     0,   759,     0,   762,     0,
     851,     0,   577,   570,   569,   451,   567,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,     0,   616,   619,
     632,     0,   575,   767,     0,   574,   455,     0,   467,     0,
     470,     0,     0,   428,   424,   425,     0,   461,     0,     0,
      28,     0,     0,     0,     0,     0,     0,   551,     0,   694,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   521,   484,   483,   490,   482,   481,   489,     0,
       0,     0,   546,     0,     0,   689,   672,   675,   654,   674,
     653,     0,     0,     0,   859,   624,   625,   639,   640,     0,
       0,     0,     0,   525,     0,   530,   488,   487,   486,   485,
       0,     0,   542,     0,   619,   673,   652,     0,     0,     0,
       0,     0,     0,     0,   496,   495,   494,   493,   497,   492,
     491,   501,   500,   499,   498,     0,     0,     0,     0,     0,
       0,     0,   856,   863,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   788,     0,   791,     0,   794,
       0,     0,     0,     0,     0,     0,     0,     0,   813,   815,
     817,     0,     0,   820,     0,     0,     0,   578,   565,     0,
       0,     0,     0,     0,    45,     0,     0,   834,   836,   838,
     840,     0,   598,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   852,     0,     0,   690,     0,   629,     0,
     627,     0,   628,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    53,   340,     0,     0,     0,   705,     0,   703,
       0,   696,     0,   697,     0,     0,     0,   695,   727,     0,
     725,     0,   718,     0,   719,     0,   717,   738,     0,   736,
       0,   729,     0,   730,     0,   728,   749,     0,   747,     0,
     740,     0,   741,     0,   739,   716,     0,   714,     0,   707,
       0,   708,     0,   706,   520,     0,   518,   536,    36,    37,
      38,    39,    40,    41,    42,   534,   535,   533,   531,   532,
     545,   543,   544,   599,   603,   605,     0,     0,     0,     0,
     647,   669,   646,   645,   644,   524,     0,   522,   529,   527,
     528,   526,   541,     0,    57,     0,   549,   537,   539,   538,
       0,   686,   668,   685,   667,   681,   660,   682,   661,   662,
     663,   664,   677,   656,   676,   655,   680,   659,   679,   658,
     678,   657,   684,   666,   683,   665,   753,     0,   750,   770,
       0,   774,   772,   771,   775,   778,   776,   797,   795,   800,
     798,   781,   779,   787,   785,   784,   782,   793,   790,   806,
     804,   809,   807,   803,   801,   812,   810,   822,   819,   824,
     823,     0,     0,   826,   825,   829,   828,   832,     0,     0,
     831,     0,     0,     0,   595,   593,     0,   845,     0,   848,
     846,   754,   755,   757,   758,   760,   761,   855,     0,   854,
     617,   621,     0,   766,   619,     0,     0,     0,     0,     0,
     426,   427,     0,   465,     0,   437,   438,   452,     0,     0,
       0,     0,   555,   553,   554,   552,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   687,
     670,   688,   671,     0,     0,     0,     0,   566,   579,    49,
      46,    47,   597,     0,     0,     0,   580,   586,   594,   592,
      57,     0,     0,   850,     0,     0,     0,   456,   468,   471,
     473,   429,   430,   442,   701,   702,   699,   700,   698,   723,
     724,   721,   722,   720,   734,   735,   732,   733,   731,   745,
     746,   743,   744,   742,   712,   713,   710,   711,   709,     0,
       0,   602,   550,   548,   547,   620,   751,   768,     0,   589,
       0,     0,     0,     0,   842,   843,   853,   765,   764,   763,
     601,   600,    48,     0,   590,   584,   591,     0,     0,     0
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,   186,   187,   188,   189,   190,   191,   192,   193,   500,
     822,   501,   502,  1355,   925,  1256,   503,   504,   975,   194,
     421,   422,   423,   195,   426,   427,   196,   197,   198,   199,
     505,   506,   507,   508,   458,   442,   443,   445,   200,   201,
     817,   917,   447,   449,   451,   202,  1138,  1171,  1139,  1200,
    1201,   976,   977,   978,   979,   980,   981,  1387,  1111,   509,
     510,   982,  1247,   890,   891,   892,  1545,  1465,  1466,   893,
     894,  1364,  1365,   983,  1144,  1077,  1078,  1079,   984,   985,
     986,   987,   898,   988,  1281,   989,   990,  1081,   901,   991,
     992,  1159,   902,   903,   904,  1061,  1478,  1479,   905
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -1095
static const yytype_int16 yypact[] =
{
    2443,  -246,    47,    66,  -225,  -212,  -199,  -187,  -162,  -154,
   -1095,  -135,  -132,  -125,  -122,   -96,   -78,   -75,   -70,   -63,
     -60,   -44,   -41,    98,   144,   285,   392,   500,   501,   637,
     643,   663,   665,   667,   671,   673,   711,   712,   713,   765,
     791,   818,   833,   882,   886,   888,   889,   891,   895,   902,
     904,   906,   907,   908,   915,   -40,   -35,    -4,    -3,     0,
       6,    33,    65,   311,   366,   377,   378,   385,   393,   403,
     417,   420,   427,   119,    15,    49,   436,   447,   495,   580,
     610,   630,   638,   639,   654,   664,   666,   675,   679,   680,
     683,   689,   697,   716,   784,   785,   800,   916,   927,   928,
     940,   804,   809,   819,   836,   848,   849,   850,   856,   869,
     870,   875,   883,   892,   934,   935,   939,   942,   943,   947,
     959,   963,   986,   990,  1001,  1006,  1015,  1020,  1027,  1028,
    1031,  1034,  1050,  1057,  1099,  1100,  1114,  1116,  1117,  1119,
    1120,  1122,  1123,  1124,  1174,  1175,  1176,  1178,  1179,  1182,
    1184,  1185,  1186,  1188,  1189,  1190,  1194,  1207,  1208,  1209,
    1210,  1211,  1212,   941,  1238,  1239,  1240,  1241,  1242,  1243,
    1244,  1245,  1246,  1247,  1252,    38,    74,  1253,  1254,  1255,
     178,   197,   209, -1095, -1095, -1095,   318,  1580, -1095,   214,
     315,   901,  1037,  1042, -1095, -1095, -1095,  -181, -1095, -1095,
     428, -1095, -1095, -1095, -1095,   -43, -1095,   126,   272,   880,
     299,   284,   313,   302,   323,   324,   473,   278,   210,   533,
      95,   127,   571,   602,   607, -1095,   748, -1095,   749, -1095,
     762, -1095,  -234, -1095,  -234, -1095,  -234, -1095,  -234, -1095,
     763, -1095,   764, -1095,   769, -1095,   775, -1095,   789, -1095,
     799, -1095,   801, -1095,   843, -1095,   884, -1095,   913, -1095,
     933, -1095,   965, -1095,  1223, -1095,  1249, -1095,  1250, -1095,
    1251, -1095,  1256, -1095,  1258, -1095,  1259, -1095,  1260, -1095,
    1261, -1095,  1262, -1095,  1265, -1095,  1266, -1095,  1268,   614,
     577,   623,   627,   636,   641,   657,   303,   304,   308,   309,
     310,   314,   658,   659,   225,   241,   662, -1095, -1095, -1095,
     247, -1095, -1095,  1267,   677,   681,   120,   206,   226,   236,
     682,   692,   705,   706,   483,   484,   521,   240,   709,   723,
     724,   725,    11,   733,   734, -1095,  1269, -1095,  1271, -1095,
    1272, -1095,  1273,   735,   736,   737,   738,   739,   741,   747,
     750,   753,   754,   755,   757,   759,   760,   761,    91,   766,
     768,   770,   772,   254,   255,   256,   773,   774,   777,   779,
     780,   781,   782,   787,   788,   790,   582,   792,   793,   794,
     795,   796,   797,   583,   798,   802,   806,   807,    26,   808,
     811,   812,   813,   814,   822,   824,   825,   826,   832,   834,
     838,   839,   840,   844,    57, -1095,  1274,   851,   852,   854,
     857,   860,   257,  1275,   861,   864,   865,   866, -1095, -1095,
   -1095, -1095,  1294,  1231, -1095, -1095, -1095,  1295,   867,   868,
     872, -1095, -1095, -1095, -1095, -1095, -1095, -1095,  -246, -1095,
      50,    69,  1297, -1095,    72, -1095,    76, -1095,    80, -1095,
      32, -1095,   -16,  1311, -1095, -1095, -1095, -1095,  1237, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095,  1312, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095,  1313, -1095, -1095, -1095, -1095,  1136,  1309,
   -1095,  1236,  1298,  1074,  1469, -1095, -1095, -1095, -1095, -1095,
    -232, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,  1306, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,  1313,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095,   -84,  1316,   -84, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095,   -43, -1095, 10967, -1095, 10967,   -43, -1095, 10967,   -43,
   -1095, 10967,   -43, -1095,  1314,  1288,  1302, 10967,    75, -1095,
    1318,  1315,  1317,  1304,   297,  1058, -1095,  1136,   218,   275,
    1319, -1095, -1095, -1095,  1320,    52,    94,    99,   101,   102,
   10109, 10227, 10313, -1095,   104,   105,   107,  1322,   109,   122,
     123,   125,   128,   131,   135,   137,  1323,   140,   150,   153,
     154,  1325,  1326,  1327,  1328,  1329, 10436,   168,   169,   188,
    1330,  1334,  1338,  1339,  5952, 10436,   190,   193,   195,   199,
     200, -1095, -1095, -1095, -1095,   203, -1095, -1095, -1095,    24,
    3419, -1095, -1095, -1095, -1095,   985, -1095, -1095, -1095, -1095,
   -1095,  1290,  1321,   204, -1095,  1342,  3488,  1337,  3640,  1340,
    3816,  1341,  1350,    34,  1332,  3885, -1095,  1454,  1356,  1136,
   -1095, -1095, -1095, -1095, -1095, -1095,  1307,  1308, -1095, -1095,
   -1095, -1095, -1095,  1346,  1455, -1095,    79, -1095,   100, -1095,
     152, -1095,   159, -1095,   174,   917, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095,   430, -1095,   430,
   -1095,   829, -1095, -1095,  1312, -1095, -1095,  6077,  6281,  6406,
    1457,  1458, -1095,  5294, 10832, -1095,   924, -1095,   905, -1095,
     936, -1095, -1095, -1095,   985, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095,  6610,  2442,  5419,  2442,  5623,  2442, -1095,   246,
   -1095,   258, -1095,  6735,  1518, -1095,   259, -1095,   260, -1095,
     261, -1095,   262, -1095,   876, -1095,   877, -1095,  1519, -1095,
       9,  1520, -1095,   265, -1095,   266, -1095,   267, -1095,   268,
    1521,  1522,  1523,    56,   971,  6939,  9781, -1095,   189, -1095,
     878, -1095,   231,  1524,  1525,  1526,  1527, -1095,  1067,  9781,
   -1095,   270, -1095,   271, -1095,   412, -1095,   584, -1095,   595,
   -1095,  1528, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095,  1541, -1095,  1533,
   -1095, 10436, -1095, -1095,   245, -1095, -1095,  1536, -1095,  1560,
   -1095,  1561,  1562, -1095,  1385,  1599,   -16, -1095, 10967,  1575,
   -1095,  -223,  1576,  -186, 10967,  1567,   -36, -1095,   394, -1095,
     910,   962,  1568,   914,   919,   946,   966,  1569,   950,   954,
     961,   969,  1570,   973,   998,  1008,   981,  1572,  1012,  1055,
    1060,  1013, -1095, -1095, -1095, -1095, -1095, -1095, -1095,  7064,
    4965,  5090, -1095,  1248,  1582, -1095, -1095, -1095, -1095, -1095,
   -1095,  7268,  7393,  1574, -1095,  1618,  1619,  1620,  1621,  1125,
    1583,  1577,  3968, -1095,  7597, -1095, -1095, -1095, -1095, -1095,
    7722,  7926, -1095,  2759,  1578, -1095, -1095,  8051,  8255,  8380,
    8584, 10436, 10436, 10436, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095,  8709,  8913,  9038,  9242,  9367,
    9571,  9696, -1095, -1095,  1584,  1601,  1600,  1602,  1603,  1604,
      97,  1214,  1605,  1614,  1625,  1627,  1628,  1629,  1631,  1640,
    1641,  1645,  1646,  1647,  1655, -1095,  1668, -1095,  1669, -1095,
    1670,  1671,  1672,  1673,  1674,  1683,  1694,  1696, -1095, -1095,
   -1095,  1697,  1698, -1095,  1700,  1709, 10967,  1883, -1095,  1710,
    1714,  1715,  1716,  1724,  1730,  1731,  1739, -1095, -1095, -1095,
   -1095,    22, -1095,  1740,  1743,  1742,  1752,  1763,  1765,  1766,
    1767,  1769,  1778, 10436,  1788,  1738,  2442,  1063, -1095,   985,
   -1095,  1785, -1095, 10967, 10967, 10967, 10967,  1791,  1792,  1835,
    4037,  1806, -1095, -1095,  1795,  1808,  4213, -1095,   183, -1095,
    1819, -1095,  1820, -1095,   281,   282,  1821, -1095, -1095,   574,
   -1095,  1822, -1095,  1823, -1095,  1824, -1095, -1095,   609, -1095,
    1833, -1095,  1844, -1095,  1846, -1095, -1095,   613, -1095,  1847,
   -1095,  1848, -1095,  1850, -1095, -1095,   626, -1095,  1859, -1095,
    1864, -1095,  1865, -1095, -1095,  1980,  1183, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095,  1183, -1095, -1095,  1183,
   -1095, -1095, -1095,  1852, -1095,  1876,  1866,  1257,  1867,  1581,
   -1095, -1095, -1095, -1095, -1095, -1095,  2049,  1183, -1095,  1183,
   -1095,  1040, -1095,  2120,  1313,  1911,  1885, -1095,   -81,  1183,
    -139, -1095,  2699, -1095,  2740, -1095,  2894, -1095,  1144,  1957,
    2025,  1310, -1095,   390, -1095,   390, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095,  1183, -1095,  1040, -1095,  1872, -1095, -1095,
    1875, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095,  4365, 10763, -1095, -1095, -1095, -1095, -1095,   322,  1136,
   -1095,  1889,  5748,  1886, -1095, -1095,   -14, -1095, 10640, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095,  2442,  1072, -1095,
   -1095, -1095,   -84, -1095, -1095,   253,  4434,  4541,  4610,  4762,
   -1095, -1095,  -213, -1095,  1904, -1095, -1095, -1095,  1895,  1896,
    1897,  1899, -1095, -1095, -1095, -1095,  1900,  1901,  1903,  1905,
    1908,  1914,  1915,  1916,  1917,  1961,  1962,  1963,  1964,  1965,
    1966,  1967,  1968,  1969,  1970,  1972,  1973,   383,  1582, -1095,
   -1095, -1095, -1095,    17,  1978,  1974,  1977, -1095, -1095, -1095,
   -1095,  1979, -1095,  1999,  9900,  2023,  2442, 10967, -1095, -1095,
    1984,  2218, 10436, -1095,  1985,  2031,  2032, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095, -1095,  2028,
    2029, -1095, -1095,  1313, -1095, -1095, -1095, -1095,  -223, 10967,
    2030,  2034,   979,  2846, -1095, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095,  2915, 10967, 10967, -1095,  3091,  3243,  3312
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1095, -1095, -1095,  2044, -1095, -1095, -1095, -1095, -1095,  -386,
    1443,  1538,  -205,  1224, -1094, -1095, -1095,    67,  -210, -1095,
    1579, -1095,  -175, -1095,  1573, -1095, -1095,  -443, -1095, -1095,
    -923,  2038,  1874,  2045,  -107, -1095, -1095, -1095, -1095, -1095,
   -1095, -1095, -1095, -1095, -1095, -1095,  -912, -1095,  -768, -1095,
   -1095,  1285, -1095, -1095, -1095,  1286, -1095, -1095,   298,  -686,
   -1095,    46, -1044,  -637,  -854, -1095,   835,   918, -1095, -1095,
   -1095,   853, -1095, -1095, -1095, -1095,  1106,  -940,  -138,  -797,
   -1095,  -743, -1095, -1095, -1095,  -351,  -771, -1095, -1095, -1095,
   -1095,  -811,  -848, -1095, -1095, -1095, -1095,   830, -1095
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -850
static const yytype_int16 yytable[] =
{
     473,   425,   735,   479,   469,  1262,   896,  1292,   896,   815,
    1226,   896,   631,  1110,   896,  1115,   309,  1120,  1592,  1125,
     896,  1130,   522,  1461,   523,  1062,   524,   734,   525,   993,
     995,   997,   900,   813,   900,  1093,  1066,   900,   203,   418,
     900,    10,  1462,  1463,  1174,  1140,   900,  1141,   204,  1143,
     312,   800,  1066,   935,  1066,  1036,  1066,  1241,   766,   207,
     897,  1066,   897,  1048,  1049,   897,  1170,   206,   897,   471,
     802,   828,   208,   804,   897,   424,   916,   807,  1462,  1463,
    1105,   810,   829,   472,   923,   209,   565,   567,   569,   571,
     573,   575,   671,   896,   924,   937,   492,   210,  1060,   225,
     939,  1112,   941,   943,  1561,   998,  1000,  1562,  1002,   896,
    1005,   896,   821,   896,   614,   616,   618,   471,   896,   900,
     307,   593,   211,  1007,  1009,  1160,  1011,   459,   511,  1013,
     212,   472,  1015,   452,  1294,   900,  1017,   900,  1019,   900,
    1106,  1022,   930,   932,   900,   227,  1160,   897,  1160,   213,
     453,  1024,   214,  1117,  1026,  1028,  1146,  1148,  1150,   215,
    1122,  1113,   216,   897,   471,   897,   711,   897,   906,  1037,
    1039,   908,   897,   725,   910,  1127,  1155,   896,   472,   431,
     915,  1176,  1248,   464,   465,   466,   467,  1160,   217,  1041,
    1249,  1050,  1211,  1481,  1052,  1248,  1054,  1155,   433,  1155,
    1056,  1058,  1158,   900,  1060,  1083,   218,   596,  1164,   219,
     435,   488,  1173,  1118,   220,   464,   465,   466,   467,   928,
    1123,   221,  1304,  1158,   222,  1158,   580,   599,   440,   441,
    1156,   897,  1253,  1305,   419,  1128,   420,   602,  1155,   896,
     223,   619,   582,   224,   289,  1498,  1277,  1204,   586,   290,
    1386,  1156,   896,  1156,  1555,   684,   686,   688,   780,  1207,
    1213,  1215,  1217,  1219,  1158,   900,  1230,  1232,  1234,  1236,
    1276,  1263,  1265,   461,   455,   456,   931,   457,   900,   486,
     291,   292,  1502,  1504,   293,   474,   229,  1280,   512,  1298,
     294,  1299,  1156,   897,   672,   673,   674,   675,   922,   310,
     470,   896,   183,   478,   564,   566,   897,   896,  1066,   568,
     570,   572,   471,  1282,   476,   574,  1548,   295,   437,   464,
     465,   466,   467,  1539,   480,   482,   472,   900,  1346,  1356,
    1359,   444,   497,   900,  1593,   311,  1227,  1162,   497,  1484,
    1367,  1369,   499,   493,   494,   495,   496,   497,   499,   296,
    1063,  1094,  1464,  1377,  1095,   897,   419,   499,   420,  1379,
    1381,   897,  1389,   814,  1540,   896,  1392,  1394,  1396,  1398,
    1399,  1400,  1401,  1242,   767,   768,  -458,   313,   205,  -449,
     936,   801,   226,  1243,  1403,  1405,  1407,  1409,  1411,  1413,
    1415,   900,   419,   231,   420,  -459,   629,  1107,  -450,  1108,
     497,   805,   468,   806,  -464,   808,  1109,   809,  1538,   811,
     499,   812,   493,   494,   495,   496,   497,   629,  1107,   897,
    1114,   497,   938,   498,  1422,  -849,   499,   940,   228,   942,
     944,   499,   999,  1001,   468,  1003,  1066,  1006,   594,   308,
     595,   927,  1066,   460,   493,   494,   495,   496,   497,   896,
    1008,  1010,   899,  1012,   899,   498,  1014,   899,   499,  1016,
     899,  1290,  1477,  1018,  1143,  1020,   899,  1296,  1023,   629,
    1107,  1143,  1119,   497,   484,   900,   629,  1107,  1025,  1124,
     497,  1027,  1029,   499,   613,   615,   896,   896,   896,   896,
     499,   629,  1107,   896,  1129,   497,  1038,  1040,   432,   896,
    1499,   233,   235,   897,  1612,   499,   493,   494,   495,   496,
     497,   884,   900,   900,   900,   900,  1042,   434,  1051,   900,
     499,  1053,   617,  1055,   597,   900,   598,  1057,  1059,   436,
     489,  -849,  1084,   821,   490,   929,   494,   495,   468,   899,
     897,   897,   897,   897,   600,   581,   601,   897,   493,   494,
     495,   496,   497,   897,   603,   899,   604,   899,   620,   899,
     621,   583,   499,  1205,   899,  1278,  1206,   587,   887,   230,
     826,   419,   513,   420,   685,   687,   689,   781,  1208,  1214,
    1216,  1218,  1220,   710,   724,  1231,  1233,  1235,  1237,   462,
    1264,  1266,   929,   494,   495,   297,   487,  1066,  1248,  1503,
    1505,   475,   471,   515,   923,   471,   471,   471,   517,  1451,
    1594,   471,   471,   471,   924,   551,   472,   471,   425,   472,
     472,   472,  1157,   899,   554,   472,   472,   472,   556,   923,
     477,   472,  1066,  1066,  1066,  1066,  1507,   558,   237,   924,
     481,   483,   560,  1157,   239,  1157,  1486,  1487,  1488,  1489,
     298,  1546,  1250,  1289,   896,   896,  1254,  1551,   562,   576,
     578,   299,   300,   584,   241,   895,   243,   895,   245,   301,
     895,  1512,   247,   895,   249,  1517,   232,   302,   589,   895,
     900,   900,   591,   605,  1157,   899,   471,   303,  1522,   896,
     896,   896,   896,   607,   834,  1197,  1198,  1199,   899,   907,
     472,   304,   909,  1589,   305,   911,   609,   611,   897,   897,
     622,   306,   251,   253,   255,   900,   900,   900,   900,  1300,
     314,  1301,  1133,  1134,   624,   626,   628,  1136,  1137,  1267,
     419,   315,   420,  1546,   633,   635,   641,   643,   645,   647,
     649,  1477,   651,   897,   897,   897,   897,   899,   653,  1066,
     896,   655,   895,   899,   657,   659,   661,   454,   663,  1066,
     665,   667,   669,  1066,  1066,  1066,   257,   676,   895,   678,
     895,   680,   895,   682,   690,   692,   900,   895,   694,   316,
     696,   698,   700,   702,   234,   236,   471,   471,   704,   706,
     485,   708,   259,   712,   714,   716,   718,   720,   722,   726,
     472,   472,   896,   728,   897,   896,   896,   730,   732,   736,
    1228,   899,   738,   740,   742,   744,   896,   896,   896,   261,
     896,   896,   896,   746,   471,   748,   750,   752,   900,  1245,
    1142,   900,   900,   754,   263,   756,   895,  1255,   472,   758,
     760,   762,   900,   900,   900,   764,   900,   900,   900,   889,
     491,   889,   770,   772,   889,   774,   897,   889,   776,   897,
     897,   778,   783,   889,   317,   785,   787,   789,   794,   796,
     897,   897,   897,   798,   897,   897,   897,  1221,  1223,  1251,
    1268,   463,  1270,   265,  1272,   471,   471,   267,   514,   269,
     271,  1508,   273,  1295,   318,   899,   275,   553,   895,   472,
     472,  1269,   419,   277,   420,   279,  1165,   281,   283,   285,
    1603,   895,  1271,   419,   319,   420,   287,   335,  1132,   516,
     446,   238,   320,   321,   518,  1163,  1513,   240,   337,   339,
    1518,   552,   899,   899,   899,   899,   889,  1172,   322,   899,
     555,   341,   405,  1523,   557,   899,  1279,   242,   323,   244,
     324,   246,   889,   559,   889,   248,   889,   250,   561,   325,
     895,   889,  1613,   326,   327,  1617,   895,   328,   464,   465,
     466,   467,  1244,   329,   563,   577,   579,  1618,  1619,   585,
    1616,   330,   835,   836,   837,   838,   839,   840,   841,   842,
     843,   844,   845,   846,   590,   252,   254,   256,   592,   606,
     331,   847,   848,   849,   850,   851,   852,   853,   854,   608,
     855,   856,   857,   858,   859,   860,   861,   862,   863,   864,
     889,   865,   610,   612,   895,   866,   623,   867,   868,   869,
     870,   871,   872,   873,   874,  -583,  -583,   875,   876,   877,
     625,   627,   629,   878,   879,   880,   881,   882,   883,   258,
     634,   636,   642,   644,   646,   648,   650,   448,   652,   464,
     465,   466,   467,   450,   654,   519,   520,   656,   332,   333,
     658,   660,   662,  1541,   664,   260,   666,   668,   670,   521,
     526,   527,   889,   677,   334,   679,   528,   681,   343,   683,
     691,   693,   529,   344,   695,   889,   697,   699,   701,   703,
     899,   899,   262,   345,   705,   707,   530,   709,   895,   713,
     715,   717,   719,   721,   723,   727,   531,   264,   532,   729,
     346,  1133,  1134,   731,   733,   737,  1136,  1137,   739,   741,
     743,   745,   347,   348,   349,   899,   899,   899,   899,   747,
     350,   749,   751,   753,   889,   895,   895,   895,   895,   755,
     889,   757,   895,   351,   352,   759,   761,   763,   895,   353,
     533,   765,   464,   465,   466,   467,   266,   354,   771,   773,
     268,   775,   270,   272,   777,   274,   355,   779,   784,   276,
    1534,   786,   788,   790,   795,   797,   278,   468,   280,   799,
     282,   284,   286,  1222,  1224,  1252,   899,  1133,  1134,   288,
     336,   534,  1136,  1137,  1166,  1167,  1168,  1169,   889,  1133,
    1134,   338,   340,  1135,  1136,  1137,  1133,  1134,   356,   357,
    1135,  1136,  1137,   358,   342,   406,   359,   360,  1133,  1134,
     535,   361,  1135,  1136,  1137,  1302,  1116,  1303,  1121,  1309,
    1126,  1310,  1131,   362,  1311,   884,  1312,   363,   899,  1360,
     536,   899,   899,  1067,  1068,  1069,  1070,  1071,  1072,  1073,
    1074,  1075,   899,   899,   899,  1304,   899,   899,   899,  1304,
     364,  1313,  1304,  1314,   365,  1318,  1305,  1319,   468,  1320,
    1305,  1321,   537,  1305,  1304,   366,  1322,  1306,  1323,  1307,
     367,  1315,   889,  1316,  1324,  1305,  1325,   885,  1327,   368,
    1328,   886,   887,  1076,   369,   888,  1333,  1554,  1334,  -583,
    1556,   370,   371,   895,   895,   372,  1304,  1590,   373,   946,
     947,   948,   949,  1329,   951,  1330,   953,  1305,   955,   889,
     889,   889,   889,  1331,   374,  1332,   889,  1336,  1342,  1337,
    1343,   375,   889,  1195,  1196,  1197,  1198,  1199,   895,   895,
     895,   895,  1177,  1178,  1179,  1180,  1181,  1182,  1183,  1184,
    1185,  1186,  1187,  1188,  1189,  1190,  1191,  1192,  1193,  1194,
    1195,  1196,  1197,  1198,  1199,   493,   494,   495,   496,   497,
    1338,   468,  1339,   376,   377,  1340,   498,  1341,  1482,   499,
    1483,   493,   494,   495,   496,   497,  1261,  1552,   378,  1553,
     379,   380,   498,   381,   382,   499,   383,   384,   385,   895,
    1177,  1178,  1179,  1180,  1181,  1182,  1183,  1184,  1185,  1186,
    1187,  1188,  1189,  1190,  1191,  1192,  1193,  1194,  1195,  1196,
    1197,  1198,  1199,  1181,  1182,  1183,  1184,  1185,  1186,  1187,
    1188,  1189,  1190,  1191,  1192,  1193,  1194,  1195,  1196,  1197,
    1198,  1199,  1371,   493,   494,   495,   496,   497,   386,   387,
     388,   895,   389,   390,   895,   895,   391,   499,   392,   393,
     394,  1388,   395,   396,   397,   895,   895,   895,   398,   895,
     895,   895,  1191,  1192,  1193,  1194,  1195,  1196,  1197,  1198,
    1199,   399,   400,   401,   402,   403,   404,   889,   889,  1177,
    1178,  1179,  1180,  1181,  1182,  1183,  1184,  1185,  1186,  1187,
    1188,  1189,  1190,  1191,  1192,  1193,  1194,  1195,  1196,  1197,
    1198,  1199,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   889,   889,   889,   889,   417,   428,   429,   430,
     538,  1423,  1177,  1178,  1179,  1180,  1181,  1182,  1183,  1184,
    1185,  1186,  1187,  1188,  1189,  1190,  1191,  1192,  1193,  1194,
    1195,  1196,  1197,  1198,  1199,   792,   539,   540,   541,   818,
     824,   827,   913,   542,  1080,   543,   544,   545,   546,   547,
      -2,   438,   548,   549,  1530,   550,   637,   588,   638,   639,
     640,   769,   782,   889,   -11,   -11,   -13,     2,     3,   -16,
     -18,   -20,  1184,  1185,  1186,  1187,  1188,  1189,  1190,  1191,
    1192,  1193,  1194,  1195,  1196,  1197,  1198,  1199,     4,   791,
     793,     5,     6,     7,     8,     9,   803,   820,   816,   819,
     497,   830,   825,   832,   914,   918,   921,    10,   912,   933,
     919,  1101,  1102,  1287,   920,   889,  1096,  1082,   889,   889,
    1004,  1021,   934,  1030,  1031,  1032,  1033,  1034,  1043,   889,
     889,   889,  1044,   889,   889,   889,  1045,  1046,  1085,  1087,
    1099,  1103,  1089,  1091,    11,    12,    13,    14,    15,    16,
      17,    18,  1092,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,  1098,  1104,  1151,  1152,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,  1212,   170,
     171,   172,   173,   174,   175,   176,  1225,  1229,  1238,  1239,
    1240,  1257,  1258,  1259,  1260,  1274,  1273,  1288,   177,   178,
     179,   180,   181,   182,  1275,  1283,  1177,  1178,  1179,  1180,
    1181,  1182,  1183,  1184,  1185,  1186,  1187,  1188,  1189,  1190,
    1191,  1192,  1193,  1194,  1195,  1196,  1197,  1198,  1199,  1284,
    1285,  1286,  1291,  1293,  1297,  1308,  1317,  1326,   183,  1335,
    1363,  1370,  -622,  -623,  -634,  -635,   184,  1373,  1532,  1390,
    1372,  1416,  1060,   185,  -551,  -551,  -551,  -551,  -551,  -551,
    -551,  -551,  -551,  -551,  -551,  -551,  1417,  1418,  1420,  1419,
    1452,  1421,  1424,  -551,  -551,  -551,  -551,  -551,  -551,  -551,
    -551,  1425,  -551,  -551,  -551,  -551,  -551,  -551,  -551,  -551,
    -551,  -551,  1426,  -551,  1427,  1428,  1429,  -551,  1430,  -551,
    -551,  -551,  -551,  -551,  -551,  -551,  -551,  1431,  1432,  -551,
    -551,  -551,  1433,  1434,  1435,  -551,  -551,  -551,  -551,  -551,
    -551,  1060,  1436,  -519,  -519,  -519,  -519,  -519,  -519,  -519,
    -519,  -519,  -519,  -519,  -519,  1437,  1438,  1439,  1440,  1441,
    1442,  1443,  -519,  -519,  -519,  -519,  -519,  -519,  -519,  -519,
    1444,  -519,  -519,  -519,  -519,  -519,  -519,  -519,  -519,  -519,
    -519,  1445,  -519,  1446,  1447,  1448,  -519,  1449,  -519,  -519,
    -519,  -519,  -519,  -519,  -519,  -519,  1450,  1453,  -519,  -519,
    -519,  1454,  1455,  1456,  -519,  -519,  -519,  -519,  -519,  -519,
    1142,  1457,  -523,  -523,  -523,  -523,  -523,  -523,  -523,  -523,
    -523,  -523,  -523,  -523,  1458,  1459,  1460,  1467,  1468,  1469,
    1481,  -523,  -523,  -523,  -523,  -523,  -523,  -523,  -523,  1470,
    -523,  -523,  -523,  -523,  -523,  -523,  -523,  -523,  -523,  -523,
    1471,  -523,  1472,  1473,  1474,  -523,  1475,  -523,  -523,  -523,
    -523,  -523,  -523,  -523,  -523,  1476,  1076,  -523,  -523,  -523,
    1485,  1490,  1491,  -523,  -523,  -523,  -523,  -523,  -523,  1492,
    1494,  1142,  1495,  -540,  -540,  -540,  -540,  -540,  -540,  -540,
    -540,  -540,  -540,  -540,  -540,  1496,  1500,  1501,  1506,  1509,
    1510,  1511,  -540,  -540,  -540,  -540,  -540,  -540,  -540,  -540,
    1514,  -540,  -540,  -540,  -540,  -540,  -540,  -540,  -540,  -540,
    -540,  1515,  -540,  1516,  1519,  1520,  -540,  1521,  -540,  -540,
    -540,  -540,  -540,  -540,  -540,  -540,  1524,  -551,  -540,  -540,
    -540,  1525,  1526,  1527,  -540,  -540,  -540,  -540,  -540,  -540,
    1528,  1533,  1535,  1529,  1531,  1536,  -551,  -551,  -551,  -551,
    -551,  -551,  -551,  -551,  -551,  -551,  -551,  -551,  -551,  -551,
    -551,  -551,  -551,  -551,  -551,  -551,  -551,  -551,  -551,  1542,
    1547,  1563,  1564,  1565,  1566,  -551,  1567,  1568,  1569,  -551,
    1570,   439,  1571,  -551,  -551,  1572,  -551,  -551,  -551,  -849,
    -551,  1573,  1574,  1575,  1576,  -551,  -519,  1182,  1183,  1184,
    1185,  1186,  1187,  1188,  1189,  1190,  1191,  1192,  1193,  1194,
    1195,  1196,  1197,  1198,  1199,  -519,  -519,  -519,  -519,  -519,
    -519,  -519,  -519,  -519,  -519,  -519,  -519,  -519,  -519,  -519,
    -519,  -519,  -519,  -519,  -519,  -519,  -519,  -519,  1577,  1578,
    1579,  1580,  1581,  1582,  1583,  1584,  1585,  1586,  -519,  1587,
    1588,  1596,  -519,  -519,  1597,  -519,  -519,  -519,  -849,  -519,
    1595,  1604,  1607,  1598,  -519,  -523,  1183,  1184,  1185,  1186,
    1187,  1188,  1189,  1190,  1191,  1192,  1193,  1194,  1195,  1196,
    1197,  1198,  1199,  1599,  -523,  -523,  -523,  -523,  -523,  -523,
    -523,  -523,  -523,  -523,  -523,  -523,  -523,  -523,  -523,  -523,
    -523,  -523,  -523,  -523,  -523,  -523,  -523,  1602,  1608,  1609,
    1610,  1611,  1100,   926,  1614,  1358,   833,  -523,  1615,   630,
     831,  -523,  -523,   823,  -523,  -523,  -523,   632,  -523,  1601,
    1480,  1591,  1606,  -523,  1549,     0,  -540,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  -540,  -540,  -540,  -540,  -540,
    -540,  -540,  -540,  -540,  -540,  -540,  -540,  -540,  -540,  -540,
    -540,  -540,  -540,  -540,  -540,  -540,  -540,  -540,  1361,  1362,
       0,     0,     0,     0,     0,     0,     0,     0,  -540,     0,
       0,     0,  -540,  -540,     1,  -540,  -540,  -540,     0,  -540,
       0,     0,     0,     0,  -540,     0,     0,   -11,   -11,   -13,
       2,     3,   -16,   -18,   -20,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     4,     0,     0,     5,     6,     7,     8,     9,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      10,     0,     0,  1177,  1178,  1179,  1180,  1181,  1182,  1183,
    1184,  1185,  1186,  1187,  1188,  1189,  1190,  1191,  1192,  1193,
    1194,  1195,  1196,  1197,  1198,  1199,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    11,    12,    13,
      14,    15,    16,    17,    18,  1605,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,     0,     0,     0,     0,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,     0,   170,   171,   172,   173,   174,   175,   176,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   177,   178,   179,   180,   181,   182,  1177,  1178,  1179,
    1180,  1181,  1182,  1183,  1184,  1185,  1186,  1187,  1188,  1189,
    1190,  1191,  1192,  1193,  1194,  1195,  1196,  1197,  1198,  1199,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1382,   183,   835,   836,   837,   838,   839,     0,     0,   184,
       0,   844,   845,   846,     0,     0,   185,     0,     0,     0,
       0,   847,   848,   849,   850,   851,   852,   853,   854,     0,
     855,   856,   857,   858,   859,   860,   861,   862,   863,   864,
       0,   865,     0,     0,     0,     0,     0,   867,   868,   869,
     870,   871,   872,   873,     0,     0,     0,     0,   876,   877,
       0,     0,     0,   878,   879,   880,   881,   882,   883,   945,
     946,   947,   948,   949,   950,   951,   952,   953,   954,   955,
     956,   957,   958,   959,   960,  1383,   962,  1064,     0,   835,
     836,   837,   838,   839,   840,   841,   842,   843,   844,   845,
     846,     0,     0,     0,     0,     0,     0,     0,   847,   848,
     849,   850,   851,   852,   853,   854,     0,   855,   856,   857,
     858,   859,   860,   861,   862,   863,   864,     0,   865,     0,
       0,     0,   866,     0,   867,   868,   869,   870,   871,   872,
     873,   874,  -585,  -585,   875,   876,   877,     0,     0,     0,
     878,   879,   880,   881,   882,   883,  1064,     0,   835,   836,
     837,   838,   839,   840,   841,   842,   843,   844,   845,   846,
       0,     0,     0,     0,     0,     0,     0,   847,   848,   849,
     850,   851,   852,   853,   854,     0,   855,   856,   857,   858,
     859,   860,   861,   862,   863,   864,     0,   865,     0,     0,
       0,   866,     0,   867,   868,   869,   870,   871,   872,   873,
     874,  -587,  -587,   875,   876,   877,     0,     0,     0,   878,
     879,   880,   881,   882,   883,  1178,  1179,  1180,  1181,  1182,
    1183,  1184,  1185,  1186,  1187,  1188,  1189,  1190,  1191,  1192,
    1193,  1194,  1195,  1196,  1197,  1198,  1199,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   884,   963,  1179,  1180,  1181,
    1182,  1183,  1184,  1185,  1186,  1187,  1188,  1189,  1190,  1191,
    1192,  1193,  1194,  1195,  1196,  1197,  1198,  1199,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   964,     0,     0,     0,     0,   965,     0,   966,
     967,   968,   969,     0,   970,   971,  1384,  1385,     0,   972,
     497,   886,   887,     0,     0,     0,     0,  1035,   974,     0,
     499,     0,  1064,     0,   835,   836,   837,   838,   839,   840,
     841,   842,   843,   844,   845,   846,     0,     0,     0,     0,
       0,     0,   884,   847,   848,   849,   850,   851,   852,   853,
     854,     0,   855,   856,   857,   858,   859,   860,   861,   862,
     863,   864,     0,   865,     0,     0,     0,   866,     0,   867,
     868,   869,   870,   871,   872,   873,   874,  -581,  -581,   875,
     876,   877,     0,     0,     0,   878,   879,   880,   881,   882,
     883,     0,     0,     0,   885,     0,     0,     0,   886,   887,
       0,     0,   888,     0,     0,     0,  -585,     0,     0,     0,
       0,   884,  1180,  1181,  1182,  1183,  1184,  1185,  1186,  1187,
    1188,  1189,  1190,  1191,  1192,  1193,  1194,  1195,  1196,  1197,
    1198,  1199,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   885,     0,     0,     0,   886,   887,     0,
       0,   888,     0,     0,  1064,  -587,   835,   836,   837,   838,
     839,   840,   841,   842,   843,   844,   845,   846,     0,     0,
       0,     0,     0,     0,     0,   847,   848,   849,   850,   851,
     852,   853,   854,     0,   855,   856,   857,   858,   859,   860,
     861,   862,   863,   864,     0,   865,     0,     0,     0,   866,
       0,   867,   868,   869,   870,   871,   872,   873,   874,  -588,
    -588,   875,   876,   877,     0,     0,     0,   878,   879,   880,
     881,   882,   883,  1064,     0,   835,   836,   837,   838,   839,
     840,   841,   842,   843,   844,   845,   846,     0,     0,     0,
       0,     0,     0,     0,   847,   848,   849,   850,   851,   852,
     853,   854,     0,   855,   856,   857,   858,   859,   860,   861,
     862,   863,   864,     0,   865,     0,     0,   884,   866,     0,
     867,   868,   869,   870,   871,   872,   873,   874,  -582,  -582,
     875,   876,   877,     0,     0,     0,   878,   879,   880,   881,
     882,   883,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   885,
       0,     0,     0,   886,   887,     0,     0,   888,     0,     0,
    1064,  -581,   835,   836,   837,   838,   839,   840,   841,   842,
     843,   844,   845,   846,     0,     0,     0,     0,     0,     0,
       0,   847,   848,   849,   850,   851,   852,   853,   854,     0,
     855,   856,   857,   858,   859,   860,   861,   862,   863,   864,
       0,   865,     0,     0,     0,   866,     0,   867,   868,   869,
     870,   871,   872,   873,   874,     0,     0,   875,   876,   877,
       0,     0,     0,   878,   879,   880,   881,   882,   883,  1064,
       0,   835,   836,   837,   838,   839,   840,   841,   842,   843,
     844,   845,   846,     0,     0,     0,     0,     0,     0,   884,
     847,   848,   849,   850,   851,   852,   853,   854,     0,   855,
     856,   857,   858,   859,   860,   861,   862,   863,   864,     0,
     865,     0,     0,     0,   866,     0,   867,   868,   869,   870,
     871,   872,   873,   874,     0,     0,   875,   876,   877,     0,
       0,     0,   878,   879,   880,   881,   882,   883,     0,     0,
       0,   885,     0,     0,     0,   886,   887,     0,     0,   888,
       0,     0,     0,  -588,     0,     0,     0,     0,   884,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     885,     0,     0,     0,   886,   887,     0,     0,   888,     0,
       0,  1064,  -582,   835,   836,   837,   838,   839,   840,   841,
     842,   843,   844,   845,   846,     0,     0,     0,     0,     0,
       0,     0,   847,   848,   849,   850,   851,   852,   853,   854,
       0,   855,   856,   857,   858,   859,   860,   861,   862,   863,
     864,     0,   865,     0,     0,   884,   866,     0,   867,   868,
     869,   870,   871,   872,   873,   874,     0,     0,   875,   876,
     877,     0,     0,     0,   878,   879,   880,   881,   882,   883,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   885,     0,     0,
       0,   886,   887,     0,     0,   888,     0,     0,     0,  1065,
       0,     0,     0,     0,   884,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   885,     0,     0,     0,
     886,   887,     0,     0,   888,     0,     0,  1064,  1086,   835,
     836,   837,   838,   839,   840,   841,   842,   843,   844,   845,
     846,     0,     0,     0,     0,     0,     0,     0,   847,   848,
     849,   850,   851,   852,   853,   854,     0,   855,   856,   857,
     858,   859,   860,   861,   862,   863,   864,     0,   865,     0,
       0,     0,   866,     0,   867,   868,   869,   870,   871,   872,
     873,   874,     0,     0,   875,   876,   877,     0,     0,     0,
     878,   879,   880,   881,   882,   883,  1064,     0,   835,   836,
     837,   838,   839,   840,   841,   842,   843,   844,   845,   846,
       0,     0,     0,     0,     0,     0,   884,   847,   848,   849,
     850,   851,   852,   853,   854,     0,   855,   856,   857,   858,
     859,   860,   861,   862,   863,   864,     0,   865,     0,     0,
       0,   866,     0,   867,   868,   869,   870,   871,   872,   873,
     874,     0,     0,   875,   876,   877,     0,     0,     0,   878,
     879,   880,   881,   882,   883,     0,     0,     0,   885,     0,
       0,     0,   886,   887,     0,     0,   888,     0,     0,  1064,
    1088,   835,   836,   837,   838,   839,   840,   841,   842,   843,
     844,   845,   846,     0,     0,     0,     0,     0,     0,     0,
     847,   848,   849,   850,   851,   852,   853,   854,     0,   855,
     856,   857,   858,   859,   860,   861,   862,   863,   864,     0,
     865,     0,     0,     0,   866,     0,   867,   868,   869,   870,
     871,   872,   873,   874,     0,     0,   875,   876,   877,     0,
       0,     0,   878,   879,   880,   881,   882,   883,  1064,     0,
     835,   836,   837,   838,   839,   840,   841,   842,   843,   844,
     845,   846,     0,     0,     0,     0,     0,     0,     0,   847,
     848,   849,   850,   851,   852,   853,   854,     0,   855,   856,
     857,   858,   859,   860,   861,   862,   863,   864,     0,   865,
       0,     0,   884,   866,     0,   867,   868,   869,   870,   871,
     872,   873,   874,     0,     0,   875,   876,   877,     0,     0,
       0,   878,   879,   880,   881,   882,   883,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   885,     0,     0,     0,   886,   887,
       0,     0,   888,     0,     0,     0,  1090,     0,     0,     0,
       0,   884,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   885,     0,     0,     0,   886,   887,     0,
       0,   888,     0,     0,  1064,  1097,   835,   836,   837,   838,
     839,   840,   841,   842,   843,   844,   845,   846,     0,     0,
       0,     0,     0,     0,   884,   847,   848,   849,   850,   851,
     852,   853,   854,     0,   855,   856,   857,   858,   859,   860,
     861,   862,   863,   864,     0,   865,     0,     0,     0,   866,
       0,   867,   868,   869,   870,   871,   872,   873,   874,     0,
       0,   875,   876,   877,     0,     0,     0,   878,   879,   880,
     881,   882,   883,     0,     0,     0,   885,     0,     0,     0,
     886,   887,     0,     0,   888,     0,     0,     0,  1374,     0,
       0,     0,     0,   884,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   885,     0,     0,     0,   886,
     887,     0,     0,   888,     0,     0,  1064,  1493,   835,   836,
     837,   838,   839,   840,   841,   842,   843,   844,   845,   846,
       0,     0,     0,     0,     0,     0,     0,   847,   848,   849,
     850,   851,   852,   853,   854,     0,   855,   856,   857,   858,
     859,   860,   861,   862,   863,   864,     0,   865,     0,     0,
       0,   866,     0,   867,   868,   869,   870,   871,   872,   873,
     874,     0,     0,   875,   876,   877,     0,     0,     0,   878,
     879,   880,   881,   882,   883,  1064,     0,   835,   836,   837,
     838,   839,   840,   841,   842,   843,   844,   845,   846,     0,
       0,     0,     0,     0,     0,     0,   847,   848,   849,   850,
     851,   852,   853,   854,     0,   855,   856,   857,   858,   859,
     860,   861,   862,   863,   864,     0,   865,     0,     0,   884,
     866,     0,   867,   868,   869,   870,   871,   872,   873,   874,
       0,     0,   875,   876,   877,     0,     0,     0,   878,   879,
     880,   881,   882,   883,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   885,     0,     0,     0,   886,   887,     0,     0,   888,
       0,     0,  1064,  1497,   835,   836,   837,   838,   839,   840,
     841,   842,   843,   844,   845,   846,     0,     0,     0,     0,
       0,     0,     0,   847,   848,   849,   850,   851,   852,   853,
     854,     0,   855,   856,   857,   858,   859,   860,   861,   862,
     863,   864,     0,   865,     0,     0,     0,   866,     0,   867,
     868,   869,   870,   871,   872,   873,   874,     0,     0,   875,
     876,   877,     0,     0,     0,   878,   879,   880,   881,   882,
     883,  1064,     0,   835,   836,   837,   838,   839,   840,   841,
     842,   843,   844,   845,   846,     0,     0,     0,     0,     0,
       0,   884,   847,   848,   849,   850,   851,   852,   853,   854,
       0,   855,   856,   857,   858,   859,   860,   861,   862,   863,
     864,     0,   865,     0,     0,     0,   866,     0,   867,   868,
     869,   870,   871,   872,   873,   874,     0,     0,   875,   876,
     877,     0,     0,     0,   878,   879,   880,   881,   882,   883,
       0,     0,     0,   885,     0,     0,     0,   886,   887,     0,
       0,   888,     0,     0,     0,  1537,     0,     0,     0,     0,
     884,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   885,     0,     0,     0,   886,   887,     0,     0,
     888,     0,     0,  1064,  1557,   835,   836,   837,   838,   839,
     840,   841,   842,   843,   844,   845,   846,     0,     0,     0,
       0,     0,     0,     0,   847,   848,   849,   850,   851,   852,
     853,   854,     0,   855,   856,   857,   858,   859,   860,   861,
     862,   863,   864,     0,   865,     0,     0,   884,   866,     0,
     867,   868,   869,   870,   871,   872,   873,   874,     0,     0,
     875,   876,   877,     0,     0,     0,   878,   879,   880,   881,
     882,   883,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   885,
       0,     0,     0,   886,   887,     0,     0,   888,     0,     0,
       0,  1558,     0,     0,     0,     0,   884,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   885,     0,
       0,     0,   886,   887,     0,     0,   888,     0,     0,     0,
    1559,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1347,     0,   835,   836,
     837,   838,   839,     0,     0,     0,     0,   844,   845,   846,
       0,     0,     0,     0,     0,     0,     0,   847,   848,   849,
     850,   851,   852,   853,   854,     0,   855,   856,   857,   858,
     859,   860,   861,   862,   863,   864,     0,   865,     0,     0,
       0,     0,     0,   867,   868,   869,   870,   871,   872,   873,
       0,     0,     0,     0,   876,   877,     0,     0,   884,   878,
     879,   880,   881,   882,   883,   945,   946,   947,   948,   949,
     950,   951,   952,   953,   954,   955,   956,   957,   958,   959,
     960,   961,   962,  1348,  1349,  1350,  1351,  1352,  1353,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     885,     0,     0,     0,   886,   887,     0,     0,   888,     0,
       0,  1357,  1560,   835,   836,   837,   838,   839,     0,     0,
       0,     0,   844,   845,   846,     0,     0,     0,     0,     0,
       0,     0,   847,   848,   849,   850,   851,   852,   853,   854,
       0,   855,   856,   857,   858,   859,   860,   861,   862,   863,
     864,     0,   865,     0,     0,     0,     0,     0,   867,   868,
     869,   870,   871,   872,   873,     0,     0,     0,     0,   876,
     877,     0,     0,     0,   878,   879,   880,   881,   882,   883,
     945,   946,   947,   948,   949,   950,   951,   952,   953,   954,
     955,   956,   957,   958,   959,   960,   961,   962,  1348,  1349,
    1350,  1351,  1352,  1353,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   884,   963,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   964,     0,
       0,     0,  1354,   965,     0,   966,   967,   968,   969,     0,
     970,   971,   472,   885,     0,   972,     0,   886,   887,     0,
       0,     0,     0,  1035,   974,  1153,     0,   835,   836,   837,
     838,   839,     0,     0,     0,     0,   844,   845,   846,     0,
       0,     0,     0,     0,     0,     0,   847,   848,   849,   850,
     851,   852,   853,   854,     0,   855,   856,   857,   858,   859,
     860,   861,   862,   863,   864,     0,   865,     0,     0,     0,
       0,     0,   867,   868,   869,   870,   871,   872,   873,     0,
       0,     0,     0,   876,   877,     0,   884,   963,   878,   879,
     880,   881,   882,   883,   945,   946,   947,   948,   949,   950,
     951,   952,   953,   954,   955,   956,   957,   958,   959,   960,
     961,   962,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   964,     0,     0,     0,  1354,   965,     0,
     966,   967,   968,   969,     0,   970,   971,   472,   885,     0,
     972,     0,   886,   887,     0,     0,     0,     0,  1035,   974,
    1153,     0,   835,   836,   837,   838,   839,     0,     0,     0,
       0,   844,   845,   846,     0,     0,     0,     0,     0,     0,
       0,   847,   848,   849,   850,   851,   852,   853,   854,     0,
     855,   856,   857,   858,   859,   860,   861,   862,   863,   864,
       0,   865,     0,     0,     0,     0,     0,   867,   868,   869,
     870,   871,   872,   873,     0,     0,     0,     0,   876,   877,
       0,     0,     0,   878,   879,   880,   881,   882,   883,   945,
     946,   947,   948,   949,   950,   951,   952,   953,   954,   955,
     956,   957,   958,   959,   960,   961,   962,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     884,   963,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   964,     0,     0,
       0,     0,   965,     0,   966,   967,   968,   969,     0,   970,
     971,   472,   885,     0,   972,     0,   886,   887,     0,     0,
       0,  1154,  1035,   974,  1153,     0,   835,   836,   837,   838,
     839,     0,     0,     0,     0,   844,   845,   846,     0,     0,
       0,     0,     0,     0,     0,   847,   848,   849,   850,   851,
     852,   853,   854,     0,   855,   856,   857,   858,   859,   860,
     861,   862,   863,   864,     0,   865,     0,     0,     0,     0,
       0,   867,   868,   869,   870,   871,   872,   873,     0,     0,
       0,     0,   876,   877,     0,   884,   963,   878,   879,   880,
     881,   882,   883,   945,   946,   947,   948,   949,   950,   951,
     952,   953,   954,   955,   956,   957,   958,   959,   960,   961,
     962,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   964,     0,     0,     0,     0,   965,     0,   966,
     967,   968,   969,     0,   970,   971,   472,   885,     0,   972,
       0,   886,   887,     0,     0,     0,  1202,  1035,   974,  1543,
       0,   835,   836,   837,   838,   839,     0,     0,     0,     0,
     844,   845,   846,     0,     0,     0,     0,     0,     0,     0,
     847,   848,   849,   850,   851,   852,   853,   854,     0,   855,
     856,   857,   858,   859,   860,   861,   862,   863,   864,     0,
     865,     0,     0,     0,     0,     0,   867,   868,   869,   870,
     871,   872,   873,     0,     0,     0,     0,   876,   877,     0,
       0,     0,   878,   879,   880,   881,   882,   883,   945,   946,
     947,   948,   949,   950,   951,   952,   953,   954,   955,   956,
     957,   958,   959,   960,   961,   962,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   884,
     963,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   964,     0,     0,     0,
       0,   965,     0,   966,   967,   968,   969,     0,   970,   971,
     472,   885,     0,   972,     0,   886,   887,     0,     0,     0,
    1203,  1035,   974,  1047,     0,   835,   836,   837,   838,   839,
       0,     0,     0,     0,   844,   845,   846,     0,     0,     0,
       0,     0,     0,     0,   847,   848,   849,   850,   851,   852,
     853,   854,     0,   855,   856,   857,   858,   859,   860,   861,
     862,   863,   864,     0,   865,     0,     0,     0,     0,     0,
     867,   868,   869,   870,   871,   872,   873,     0,     0,     0,
       0,   876,   877,     0,   884,   963,   878,   879,   880,   881,
     882,   883,   945,   946,   947,   948,   949,   950,   951,   952,
     953,   954,   955,   956,   957,   958,   959,   960,   961,   962,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   964,     0,     0,  1544,     0,   965,     0,   966,   967,
     968,   969,     0,   970,   971,   472,   885,     0,   972,     0,
     886,   887,     0,     0,     0,     0,  1035,   974,  1145,     0,
     835,   836,   837,   838,   839,     0,     0,     0,     0,   844,
     845,   846,     0,     0,     0,     0,     0,     0,     0,   847,
     848,   849,   850,   851,   852,   853,   854,     0,   855,   856,
     857,   858,   859,   860,   861,   862,   863,   864,     0,   865,
       0,     0,     0,     0,     0,   867,   868,   869,   870,   871,
     872,   873,     0,     0,     0,     0,   876,   877,     0,     0,
       0,   878,   879,   880,   881,   882,   883,   945,   946,   947,
     948,   949,   950,   951,   952,   953,   954,   955,   956,   957,
     958,   959,   960,   961,   962,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   884,   963,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   964,     0,     0,     0,     0,
     965,     0,   966,   967,   968,   969,     0,   970,   971,   472,
     885,     0,   972,     0,   886,   887,     0,     0,     0,     0,
    1035,   974,  1147,     0,   835,   836,   837,   838,   839,     0,
       0,     0,     0,   844,   845,   846,     0,     0,     0,     0,
       0,     0,     0,   847,   848,   849,   850,   851,   852,   853,
     854,     0,   855,   856,   857,   858,   859,   860,   861,   862,
     863,   864,     0,   865,     0,     0,     0,     0,     0,   867,
     868,   869,   870,   871,   872,   873,     0,     0,     0,     0,
     876,   877,     0,   884,   963,   878,   879,   880,   881,   882,
     883,   945,   946,   947,   948,   949,   950,   951,   952,   953,
     954,   955,   956,   957,   958,   959,   960,   961,   962,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     964,     0,     0,     0,     0,   965,     0,   966,   967,   968,
     969,     0,   970,   971,   472,   885,     0,   972,     0,   886,
     887,     0,     0,     0,     0,  1035,   974,  1149,     0,   835,
     836,   837,   838,   839,     0,     0,     0,     0,   844,   845,
     846,     0,     0,     0,     0,     0,     0,     0,   847,   848,
     849,   850,   851,   852,   853,   854,     0,   855,   856,   857,
     858,   859,   860,   861,   862,   863,   864,     0,   865,     0,
       0,     0,     0,     0,   867,   868,   869,   870,   871,   872,
     873,     0,     0,     0,     0,   876,   877,     0,     0,     0,
     878,   879,   880,   881,   882,   883,   945,   946,   947,   948,
     949,   950,   951,   952,   953,   954,   955,   956,   957,   958,
     959,   960,   961,   962,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   884,   963,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   964,     0,     0,     0,     0,   965,
       0,   966,   967,   968,   969,     0,   970,   971,   472,   885,
       0,   972,     0,   886,   887,     0,     0,     0,     0,  1035,
     974,  1175,     0,   835,   836,   837,   838,   839,     0,     0,
       0,     0,   844,   845,   846,     0,     0,     0,     0,     0,
       0,     0,   847,   848,   849,   850,   851,   852,   853,   854,
       0,   855,   856,   857,   858,   859,   860,   861,   862,   863,
     864,     0,   865,     0,     0,     0,     0,     0,   867,   868,
     869,   870,   871,   872,   873,     0,     0,     0,     0,   876,
     877,     0,   884,   963,   878,   879,   880,   881,   882,   883,
     945,   946,   947,   948,   949,   950,   951,   952,   953,   954,
     955,   956,   957,   958,   959,   960,   961,   962,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   964,
       0,     0,     0,     0,   965,     0,   966,   967,   968,   969,
       0,   970,   971,   472,   885,     0,   972,     0,   886,   887,
       0,     0,     0,     0,  1035,   974,  1209,     0,   835,   836,
     837,   838,   839,     0,     0,     0,     0,   844,   845,   846,
       0,     0,     0,     0,     0,     0,     0,   847,   848,   849,
     850,   851,   852,   853,   854,     0,   855,   856,   857,   858,
     859,   860,   861,   862,   863,   864,     0,   865,     0,     0,
       0,     0,     0,   867,   868,   869,   870,   871,   872,   873,
       0,     0,     0,     0,   876,   877,     0,     0,     0,   878,
     879,   880,   881,   882,   883,   945,   946,   947,   948,   949,
     950,   951,   952,   953,   954,   955,   956,   957,   958,   959,
     960,   961,   962,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   884,   963,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   964,     0,     0,     0,     0,   965,     0,
     966,   967,   968,   969,     0,   970,   971,   472,   885,     0,
     972,     0,   886,   887,     0,     0,     0,     0,  1035,   974,
    1153,     0,   835,   836,   837,   838,   839,     0,     0,     0,
       0,   844,   845,   846,     0,     0,     0,     0,     0,     0,
       0,   847,   848,   849,   850,   851,   852,   853,   854,     0,
     855,   856,   857,   858,   859,   860,   861,   862,   863,   864,
       0,   865,     0,     0,     0,     0,     0,   867,   868,   869,
     870,   871,   872,   873,     0,     0,     0,     0,   876,   877,
       0,   884,   963,   878,   879,   880,   881,   882,   883,   945,
     946,   947,   948,   949,   950,   951,   952,   953,   954,   955,
     956,   957,   958,   959,   960,   961,   962,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   964,     0,
       0,     0,     0,   965,     0,   966,   967,   968,   969,     0,
     970,   971,   472,  1210,     0,   972,     0,   886,   887,     0,
       0,     0,     0,  1035,   974,  1344,     0,   835,   836,   837,
     838,   839,     0,     0,     0,     0,   844,   845,   846,     0,
       0,     0,     0,     0,     0,     0,   847,   848,   849,   850,
     851,   852,   853,   854,     0,   855,   856,   857,   858,   859,
     860,   861,   862,   863,   864,     0,   865,     0,     0,     0,
       0,     0,   867,   868,   869,   870,   871,   872,   873,     0,
       0,     0,     0,   876,   877,     0,     0,     0,   878,   879,
     880,   881,   882,   883,   945,   946,   947,   948,   949,   950,
     951,   952,   953,   954,   955,   956,   957,   958,   959,   960,
     961,   962,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   884,   963,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   964,     0,     0,     0,     0,   965,     0,   966,
     967,   968,   969,     0,   970,   971,   472,   885,     0,   972,
       0,   886,   887,     0,     0,     0,     0,  1035,   974,  1366,
       0,   835,   836,   837,   838,   839,     0,     0,     0,     0,
     844,   845,   846,     0,     0,     0,     0,     0,     0,     0,
     847,   848,   849,   850,   851,   852,   853,   854,     0,   855,
     856,   857,   858,   859,   860,   861,   862,   863,   864,     0,
     865,     0,     0,     0,     0,     0,   867,   868,   869,   870,
     871,   872,   873,     0,     0,     0,     0,   876,   877,     0,
     884,   963,   878,   879,   880,   881,   882,   883,   945,   946,
     947,   948,   949,   950,   951,   952,   953,   954,   955,   956,
     957,   958,   959,   960,   961,   962,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   964,     0,     0,
       0,     0,   965,     0,   966,   967,   968,   969,     0,   970,
     971,   472,  1345,     0,   972,     0,   886,   887,     0,     0,
       0,     0,  1035,   974,  1368,     0,   835,   836,   837,   838,
     839,     0,     0,     0,     0,   844,   845,   846,     0,     0,
       0,     0,     0,     0,     0,   847,   848,   849,   850,   851,
     852,   853,   854,     0,   855,   856,   857,   858,   859,   860,
     861,   862,   863,   864,     0,   865,     0,     0,     0,     0,
       0,   867,   868,   869,   870,   871,   872,   873,     0,     0,
       0,     0,   876,   877,     0,     0,     0,   878,   879,   880,
     881,   882,   883,   945,   946,   947,   948,   949,   950,   951,
     952,   953,   954,   955,   956,   957,   958,   959,   960,   961,
     962,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   884,   963,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   964,     0,     0,     0,     0,   965,     0,   966,   967,
     968,   969,     0,   970,   971,   472,   885,     0,   972,     0,
     886,   887,     0,     0,     0,     0,  1035,   974,  1375,     0,
     835,   836,   837,   838,   839,     0,     0,     0,     0,   844,
     845,   846,     0,     0,     0,     0,     0,     0,     0,   847,
     848,   849,   850,   851,   852,   853,   854,     0,   855,   856,
     857,   858,   859,   860,   861,   862,   863,   864,     0,   865,
       0,     0,     0,     0,     0,   867,   868,   869,   870,   871,
     872,   873,     0,     0,     0,     0,   876,   877,     0,   884,
     963,   878,   879,   880,   881,   882,   883,   945,   946,   947,
     948,   949,   950,   951,   952,   953,   954,   955,   956,   957,
     958,   959,   960,  1376,   962,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   964,     0,     0,     0,
       0,   965,     0,   966,   967,   968,   969,     0,   970,   971,
     472,   885,     0,   972,     0,   886,   887,     0,     0,     0,
       0,  1035,   974,  1378,     0,   835,   836,   837,   838,   839,
       0,     0,     0,     0,   844,   845,   846,     0,     0,     0,
       0,     0,     0,     0,   847,   848,   849,   850,   851,   852,
     853,   854,     0,   855,   856,   857,   858,   859,   860,   861,
     862,   863,   864,     0,   865,     0,     0,     0,     0,     0,
     867,   868,   869,   870,   871,   872,   873,     0,     0,     0,
       0,   876,   877,     0,     0,     0,   878,   879,   880,   881,
     882,   883,   945,   946,   947,   948,   949,   950,   951,   952,
     953,   954,   955,   956,   957,   958,   959,   960,   961,   962,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   884,   963,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     964,     0,     0,     0,     0,   965,     0,   966,   967,   968,
     969,     0,   970,   971,   472,   885,     0,   972,     0,   886,
     887,     0,     0,     0,     0,  1035,   974,  1380,     0,   835,
     836,   837,   838,   839,     0,     0,     0,     0,   844,   845,
     846,     0,     0,     0,     0,     0,     0,     0,   847,   848,
     849,   850,   851,   852,   853,   854,     0,   855,   856,   857,
     858,   859,   860,   861,   862,   863,   864,     0,   865,     0,
       0,     0,     0,     0,   867,   868,   869,   870,   871,   872,
     873,     0,     0,     0,     0,   876,   877,     0,   884,   963,
     878,   879,   880,   881,   882,   883,   945,   946,   947,   948,
     949,   950,   951,   952,   953,   954,   955,   956,   957,   958,
     959,   960,   961,   962,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   964,     0,     0,     0,     0,
     965,     0,   966,   967,   968,   969,     0,   970,   971,   472,
     885,     0,   972,     0,   886,   887,     0,     0,     0,     0,
    1035,   974,  1391,     0,   835,   836,   837,   838,   839,     0,
       0,     0,     0,   844,   845,   846,     0,     0,     0,     0,
       0,     0,     0,   847,   848,   849,   850,   851,   852,   853,
     854,     0,   855,   856,   857,   858,   859,   860,   861,   862,
     863,   864,     0,   865,     0,     0,     0,     0,     0,   867,
     868,   869,   870,   871,   872,   873,     0,     0,     0,     0,
     876,   877,     0,     0,     0,   878,   879,   880,   881,   882,
     883,   945,   946,   947,   948,   949,   950,   951,   952,   953,
     954,   955,   956,   957,   958,   959,   960,   961,   962,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   884,   963,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   964,
       0,     0,     0,     0,   965,     0,   966,   967,   968,   969,
       0,   970,   971,   472,   885,     0,   972,     0,   886,   887,
       0,     0,     0,     0,  1035,   974,  1393,     0,   835,   836,
     837,   838,   839,     0,     0,     0,     0,   844,   845,   846,
       0,     0,     0,     0,     0,     0,     0,   847,   848,   849,
     850,   851,   852,   853,   854,     0,   855,   856,   857,   858,
     859,   860,   861,   862,   863,   864,     0,   865,     0,     0,
       0,     0,     0,   867,   868,   869,   870,   871,   872,   873,
       0,     0,     0,     0,   876,   877,     0,   884,   963,   878,
     879,   880,   881,   882,   883,   945,   946,   947,   948,   949,
     950,   951,   952,   953,   954,   955,   956,   957,   958,   959,
     960,   961,   962,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   964,     0,     0,     0,     0,   965,
       0,   966,   967,   968,   969,     0,   970,   971,   472,   885,
       0,   972,     0,   886,   887,     0,     0,     0,     0,  1035,
     974,  1395,     0,   835,   836,   837,   838,   839,     0,     0,
       0,     0,   844,   845,   846,     0,     0,     0,     0,     0,
       0,     0,   847,   848,   849,   850,   851,   852,   853,   854,
       0,   855,   856,   857,   858,   859,   860,   861,   862,   863,
     864,     0,   865,     0,     0,     0,     0,     0,   867,   868,
     869,   870,   871,   872,   873,     0,     0,     0,     0,   876,
     877,     0,     0,     0,   878,   879,   880,   881,   882,   883,
     945,   946,   947,   948,   949,   950,   951,   952,   953,   954,
     955,   956,   957,   958,   959,   960,   961,   962,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   884,   963,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   964,     0,
       0,     0,     0,   965,     0,   966,   967,   968,   969,     0,
     970,   971,   472,   885,     0,   972,     0,   886,   887,     0,
       0,     0,     0,  1035,   974,  1397,     0,   835,   836,   837,
     838,   839,     0,     0,     0,     0,   844,   845,   846,     0,
       0,     0,     0,     0,     0,     0,   847,   848,   849,   850,
     851,   852,   853,   854,     0,   855,   856,   857,   858,   859,
     860,   861,   862,   863,   864,     0,   865,     0,     0,     0,
       0,     0,   867,   868,   869,   870,   871,   872,   873,     0,
       0,     0,     0,   876,   877,     0,   884,   963,   878,   879,
     880,   881,   882,   883,   945,   946,   947,   948,   949,   950,
     951,   952,   953,   954,   955,   956,   957,   958,   959,   960,
     961,   962,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   964,     0,     0,     0,     0,   965,     0,
     966,   967,   968,   969,     0,   970,   971,   472,   885,     0,
     972,     0,   886,   887,     0,     0,     0,     0,  1035,   974,
    1402,     0,   835,   836,   837,   838,   839,     0,     0,     0,
       0,   844,   845,   846,     0,     0,     0,     0,     0,     0,
       0,   847,   848,   849,   850,   851,   852,   853,   854,     0,
     855,   856,   857,   858,   859,   860,   861,   862,   863,   864,
       0,   865,     0,     0,     0,     0,     0,   867,   868,   869,
     870,   871,   872,   873,     0,     0,     0,     0,   876,   877,
       0,     0,     0,   878,   879,   880,   881,   882,   883,   945,
     946,   947,   948,   949,   950,   951,   952,   953,   954,   955,
     956,   957,   958,   959,   960,   961,   962,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     884,   963,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   964,     0,     0,
       0,     0,   965,     0,   966,   967,   968,   969,     0,   970,
     971,   472,   885,     0,   972,     0,   886,   887,     0,     0,
       0,     0,  1035,   974,  1404,     0,   835,   836,   837,   838,
     839,     0,     0,     0,     0,   844,   845,   846,     0,     0,
       0,     0,     0,     0,     0,   847,   848,   849,   850,   851,
     852,   853,   854,     0,   855,   856,   857,   858,   859,   860,
     861,   862,   863,   864,     0,   865,     0,     0,     0,     0,
       0,   867,   868,   869,   870,   871,   872,   873,     0,     0,
       0,     0,   876,   877,     0,   884,   963,   878,   879,   880,
     881,   882,   883,   945,   946,   947,   948,   949,   950,   951,
     952,   953,   954,   955,   956,   957,   958,   959,   960,   961,
     962,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   964,     0,     0,     0,     0,   965,     0,   966,
     967,   968,   969,     0,   970,   971,   472,   885,     0,   972,
       0,   886,   887,     0,     0,     0,     0,  1035,   974,  1406,
       0,   835,   836,   837,   838,   839,     0,     0,     0,     0,
     844,   845,   846,     0,     0,     0,     0,     0,     0,     0,
     847,   848,   849,   850,   851,   852,   853,   854,     0,   855,
     856,   857,   858,   859,   860,   861,   862,   863,   864,     0,
     865,     0,     0,     0,     0,     0,   867,   868,   869,   870,
     871,   872,   873,     0,     0,     0,     0,   876,   877,     0,
       0,     0,   878,   879,   880,   881,   882,   883,   945,   946,
     947,   948,   949,   950,   951,   952,   953,   954,   955,   956,
     957,   958,   959,   960,   961,   962,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   884,
     963,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   964,     0,     0,     0,
       0,   965,     0,   966,   967,   968,   969,     0,   970,   971,
     472,   885,     0,   972,     0,   886,   887,     0,     0,     0,
       0,  1035,   974,  1408,     0,   835,   836,   837,   838,   839,
       0,     0,     0,     0,   844,   845,   846,     0,     0,     0,
       0,     0,     0,     0,   847,   848,   849,   850,   851,   852,
     853,   854,     0,   855,   856,   857,   858,   859,   860,   861,
     862,   863,   864,     0,   865,     0,     0,     0,     0,     0,
     867,   868,   869,   870,   871,   872,   873,     0,     0,     0,
       0,   876,   877,     0,   884,   963,   878,   879,   880,   881,
     882,   883,   945,   946,   947,   948,   949,   950,   951,   952,
     953,   954,   955,   956,   957,   958,   959,   960,   961,   962,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   964,     0,     0,     0,     0,   965,     0,   966,   967,
     968,   969,     0,   970,   971,   472,   885,     0,   972,     0,
     886,   887,     0,     0,     0,     0,  1035,   974,  1410,     0,
     835,   836,   837,   838,   839,     0,     0,     0,     0,   844,
     845,   846,     0,     0,     0,     0,     0,     0,     0,   847,
     848,   849,   850,   851,   852,   853,   854,     0,   855,   856,
     857,   858,   859,   860,   861,   862,   863,   864,     0,   865,
       0,     0,     0,     0,     0,   867,   868,   869,   870,   871,
     872,   873,     0,     0,     0,     0,   876,   877,     0,     0,
       0,   878,   879,   880,   881,   882,   883,   945,   946,   947,
     948,   949,   950,   951,   952,   953,   954,   955,   956,   957,
     958,   959,   960,   961,   962,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   884,   963,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   964,     0,     0,     0,     0,
     965,     0,   966,   967,   968,   969,     0,   970,   971,   472,
     885,     0,   972,     0,   886,   887,     0,     0,     0,     0,
    1035,   974,  1412,     0,   835,   836,   837,   838,   839,     0,
       0,     0,     0,   844,   845,   846,     0,     0,     0,     0,
       0,     0,     0,   847,   848,   849,   850,   851,   852,   853,
     854,     0,   855,   856,   857,   858,   859,   860,   861,   862,
     863,   864,     0,   865,     0,     0,     0,     0,     0,   867,
     868,   869,   870,   871,   872,   873,     0,     0,     0,     0,
     876,   877,     0,   884,   963,   878,   879,   880,   881,   882,
     883,   945,   946,   947,   948,   949,   950,   951,   952,   953,
     954,   955,   956,   957,   958,   959,   960,   961,   962,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     964,     0,     0,     0,     0,   965,     0,   966,   967,   968,
     969,     0,   970,   971,   472,   885,     0,   972,     0,   886,
     887,     0,     0,     0,     0,  1035,   974,  1414,     0,   835,
     836,   837,   838,   839,     0,     0,     0,     0,   844,   845,
     846,     0,     0,     0,     0,     0,     0,     0,   847,   848,
     849,   850,   851,   852,   853,   854,     0,   855,   856,   857,
     858,   859,   860,   861,   862,   863,   864,     0,   865,     0,
       0,     0,     0,     0,   867,   868,   869,   870,   871,   872,
     873,     0,     0,     0,     0,   876,   877,     0,     0,     0,
     878,   879,   880,   881,   882,   883,   945,   946,   947,   948,
     949,   950,   951,   952,   953,   954,   955,   956,   957,   958,
     959,   960,   961,   962,   835,   836,   837,   838,   839,   840,
     841,   842,   843,   844,   845,   846,     0,     0,     0,     0,
       0,     0,     0,   847,   848,   849,   850,   851,   852,   853,
     854,     0,   855,   856,   857,   858,   859,   860,   861,   862,
     863,   864,     0,   865,     0,     0,     0,   866,     0,   867,
     868,   869,   870,   871,   872,   873,   874,   884,   963,   875,
     876,   877,     0,     0,     0,   878,   879,   880,   881,   882,
     883,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   964,     0,     0,     0,     0,   965,
       0,   966,   967,   968,   969,     0,   970,   971,   472,   885,
       0,   972,     0,   886,   887,     0,     0,     0,     0,  1035,
     974,  1600,     0,   835,   836,   837,   838,   839,     0,     0,
       0,     0,   844,   845,   846,     0,     0,     0,     0,     0,
       0,     0,   847,   848,   849,   850,   851,   852,   853,   854,
       0,   855,   856,   857,   858,   859,   860,   861,   862,   863,
     864,     0,   865,     0,     0,     0,     0,     0,   867,   868,
     869,   870,   871,   872,   873,     0,     0,     0,     0,   876,
     877,     0,   884,   963,   878,   879,   880,   881,   882,   883,
     945,   946,   947,   948,   949,   950,   951,   952,   953,   954,
     955,   956,   957,   958,   959,   960,   961,   962,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   964,
       0,     0,     0,     0,   965,     0,   966,   967,   968,   969,
       0,   970,   971,   472,   885,     0,   972,     0,   886,   887,
       0,     0,     0,     0,  1035,   974,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   884,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1177,  1178,  1179,  1180,
    1181,  1182,  1183,  1184,  1185,  1186,  1187,  1188,  1189,  1190,
    1191,  1192,  1193,  1194,  1195,  1196,  1197,  1198,  1199,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   885,
       0,     0,     0,   886,   887,     0,     0,   888,     0,     0,
    1246,     0,   835,   836,   837,   838,   839,     0,     0,     0,
       0,   844,   845,   846,     0,     0,     0,     0,     0,     0,
       0,   847,   848,   849,   850,   851,   852,   853,   854,     0,
     855,   856,   857,   858,   859,   860,   861,   862,   863,   864,
       0,   865,     0,     0,     0,     0,     0,   867,   868,   869,
     870,   871,   872,   873,     0,     0,   884,   963,   876,   877,
       0,     0,     0,   878,   879,   880,   881,   882,   883,   945,
     946,   947,   948,   949,   950,   951,   952,   953,   954,   955,
     956,   957,   958,   959,   960,   961,   962,     0,     0,     0,
       0,     0,     0,   964,     0,     0,     0,     0,   965,     0,
     966,   967,   968,   969,     0,   970,   971,   472,   885,     0,
     972,     0,   886,   887,     0,     0,     0,     0,  1035,   974,
     835,   836,   837,   838,   839,     0,     0,     0,     0,   844,
     845,   846,     0,     0,     0,     0,     0,     0,     0,   847,
     848,   849,   850,   851,   852,   853,   854,     0,   855,   856,
     857,   858,   859,   860,   861,   862,   863,   864,     0,   865,
       0,     0,     0,     0,     0,   867,   868,   869,   870,   871,
     872,   873,     0,     0,     0,     0,   876,   877,     0,     0,
       0,   878,   879,   880,   881,   882,   883,   945,   946,   947,
     948,   949,   950,   951,   952,   953,   954,   955,   956,   957,
     958,   959,   960,   961,   962,     0,   835,   836,   837,   838,
     839,     0,     0,     0,     0,   844,   845,   846,     0,     0,
       0,     0,     0,     0,     0,   847,   848,   849,   850,   851,
     852,   853,   854,     0,   855,   856,   857,   858,   859,   860,
     861,   862,   863,   864,     0,   865,     0,     0,     0,     0,
       0,   867,   868,   869,   870,   871,   872,   873,     0,     0,
       0,     0,   876,   877,     0,   884,   963,   878,   879,   880,
     881,   882,   883,   945,   946,   947,   948,   949,   950,   951,
     952,   953,   954,   955,   956,   957,   958,   959,   960,   961,
     962,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   964,     0,     0,     0,     0,   965,     0,   966,
     967,   968,   969,     0,   970,   971,   472,   885,     0,   972,
       0,   886,   887,     0,     0,     0,     0,   973,   974,   835,
     836,   837,   838,   839,     0,     0,     0,     0,   844,   845,
     846,     0,     0,     0,     0,     0,     0,     0,   847,   848,
     849,   850,   851,   852,   853,   854,     0,   855,   856,   857,
     858,   859,   860,   861,   862,   863,   864,     0,   865,     0,
       0,     0,     0,     0,   867,   868,   869,   870,   871,   872,
     873,     0,     0,   884,   963,   876,   877,     0,     0,     0,
     878,   879,   880,   881,   882,   883,   945,   946,   947,   948,
     949,   950,   951,   952,   953,   954,   955,   956,   957,   958,
     959,   960,   961,   962,     0,     0,     0,     0,     0,     0,
     964,     0,     0,     0,     0,   965,     0,   966,   967,   968,
     969,     0,   970,   971,   472,   885,     0,   972,     0,   886,
     887,     0,     0,     0,     0,   994,   974,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   884,
     963,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   964,     0,     0,     0,
       0,   965,     0,   966,   967,   968,   969,     0,   970,   971,
     472,   885,     0,   972,     0,   886,   887,     0,     0,     0,
       0,   996,   974,   835,   836,   837,   838,   839,     0,     0,
       0,     0,   844,   845,   846,     0,     0,     0,     0,     0,
       0,     0,   847,   848,   849,   850,   851,   852,   853,   854,
       0,   855,   856,   857,   858,   859,   860,   861,   862,   863,
     864,     0,   865,     0,     0,     0,     0,     0,   867,   868,
     869,   870,   871,   872,   873,     0,     0,     0,     0,   876,
     877,     0,   884,   963,   878,   879,   880,   881,   882,   883,
     945,   946,   947,   948,   949,   950,   951,   952,   953,   954,
     955,   956,   957,   958,   959,   960,   961,   962,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   964,
       0,     0,     0,     0,   965,     0,   966,   967,   968,   969,
       0,   970,   971,   472,   885,     0,   972,     0,   886,   887,
       0,     0,     0,     0,  1035,   974,   835,   836,   837,   838,
     839,   840,   841,   842,   843,   844,   845,   846,     0,     0,
       0,     0,     0,     0,     0,   847,   848,   849,   850,   851,
     852,   853,   854,     0,   855,   856,   857,   858,   859,   860,
     861,   862,   863,   864,     0,   865,     0,     0,     0,   866,
       0,   867,   868,   869,   870,   871,   872,   873,   874,     0,
       0,   875,   876,   877,     0,     0,     0,   878,   879,   880,
     881,   882,   883,  1161,     0,   835,   836,   837,   838,   839,
     840,   841,   842,   843,   844,   845,   846,     0,     0,     0,
       0,     0,     0,     0,   847,   848,   849,   850,   851,   852,
     853,   854,     0,   855,   856,   857,   858,   859,   860,   861,
     862,   863,   864,     0,   865,     0,     0,     0,   866,     0,
     867,   868,   869,   870,   871,   872,   873,   874,     0,     0,
     875,   876,   877,     0,     0,     0,   878,   879,   880,   881,
     882,   883,     0,     0,     0,     0,   884,   963,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   964,     0,     0,     0,     0,   965,     0,
     966,   967,   968,   969,     0,   970,   971,  1550,   885,     0,
     972,     0,   886,   887,     0,     0,     0,     0,  1035,   974,
     835,   836,   837,   838,   839,   840,   841,   842,   843,   844,
     845,   846,     0,     0,     0,     0,     0,     0,     0,   847,
     848,   849,   850,   851,   852,   853,   854,     0,   855,   856,
     857,   858,   859,   860,   861,   862,   863,   864,     0,   865,
       0,     0,     0,   866,     0,   867,   868,   869,   870,   871,
     872,   873,   874,     0,     0,   875,   876,   877,     0,   884,
       0,   878,   879,   880,   881,   882,   883,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   885,     0,     0,     0,   886,   887,     0,     0,   888,
       0,     0,  1246,     0,     0,     0,     0,     0,   884,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     885,     0,     0,     0,   886,   887,     0,     0,   888,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   884,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   885,     0,     0,     0,   886,
     887,     0,     0,   888
};

#define yypact_value_is_default(yystate) \
  ((yystate) == (-1095))

#define yytable_value_is_error(yytable_value) \
  YYID (0)

static const yytype_int16 yycheck[] =
{
     210,   176,   388,   213,   209,  1049,   803,  1101,   805,   452,
       1,   808,     1,   936,   811,   938,     1,   940,     1,   942,
     817,   944,   232,     1,   234,     1,   236,     1,   238,   840,
     841,   842,   803,     1,   805,     1,   890,   808,   284,     1,
     811,    57,    56,    57,   984,   957,   817,   959,     1,   961,
       1,     1,   906,     1,   908,   866,   910,     1,     1,   284,
     803,   915,   805,   874,   875,   808,   978,     1,   811,   303,
       1,   303,   284,     1,   817,     1,     1,     1,    56,    57,
       1,     1,   314,   317,   307,   284,   296,   297,   298,   299,
     300,   301,     1,   890,   317,     1,     1,   284,     1,     1,
       1,     1,     1,     1,   317,     1,     1,   320,     1,   906,
       1,   908,   498,   910,   324,   325,   326,   303,   915,   890,
       1,     1,   284,     1,     1,   973,     1,     1,     1,     1,
     284,   317,     1,   314,   320,   906,     1,   908,     1,   910,
      61,     1,   828,   829,   915,     1,   994,   890,   996,   284,
     331,     1,   284,     1,     1,     1,   967,   968,   969,   284,
       1,    61,   284,   906,   303,   908,   376,   910,   805,     1,
       1,   808,   915,   383,   811,     1,   973,   974,   317,     1,
     817,   992,  1036,    88,    89,    90,    91,  1035,   284,     1,
       1,     1,  1003,   332,     1,  1049,     1,   994,     1,   996,
       1,     1,   973,   974,     1,     1,   284,     1,   976,   284,
       1,     1,   980,    61,   284,    88,    89,    90,    91,     1,
      61,   284,   303,   994,   284,   996,     1,     1,    14,    15,
     973,   974,     1,   314,   318,    61,   320,     1,  1035,  1036,
     284,     1,     1,   284,   284,    62,     1,     1,     1,   284,
    1173,   994,  1049,   996,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,  1035,  1036,     1,     1,     1,     1,
    1081,     1,     1,     1,   317,   318,     1,   320,  1049,     1,
     284,   284,     1,     1,   284,     1,     1,  1084,   221,   325,
     284,   327,  1035,  1036,   203,   204,   205,   206,     1,   284,
       1,  1098,   318,     1,     1,     1,  1049,  1104,  1162,     1,
       1,     1,   303,  1084,     1,     1,   330,   284,     0,    88,
      89,    90,    91,     1,     1,     1,   317,  1098,  1139,  1140,
    1141,    16,   321,  1104,   317,   320,   327,   974,   321,  1279,
    1151,  1152,   331,   317,   318,   319,   320,   321,   331,   284,
     326,   317,   330,  1164,   320,  1098,   318,   331,   320,  1170,
    1171,  1104,  1173,   331,  1458,  1162,  1177,  1178,  1179,  1180,
    1181,  1182,  1183,   317,   317,   318,   329,   328,   331,   329,
     328,   331,   284,   327,  1195,  1196,  1197,  1198,  1199,  1200,
    1201,  1162,   318,     1,   320,   329,   317,   318,   329,   320,
     321,   329,   307,   331,   329,   329,   327,   331,  1452,   329,
     331,   331,   317,   318,   319,   320,   321,   317,   318,  1162,
     320,   321,   328,   328,   327,   328,   331,   328,   284,   328,
     328,   331,   328,   328,   307,   328,  1290,   328,   318,   320,
     320,   827,  1296,   317,   317,   318,   319,   320,   321,  1246,
     328,   328,   803,   328,   805,   328,   328,   808,   331,   328,
     811,  1098,  1273,   328,  1376,   328,   817,  1104,   328,   317,
     318,  1383,   320,   321,     1,  1246,   317,   318,   328,   320,
     321,   328,   328,   331,     1,     1,  1283,  1284,  1285,  1286,
     331,   317,   318,  1290,   320,   321,   328,   328,   320,  1296,
     317,     1,     1,  1246,  1598,   331,   317,   318,   319,   320,
     321,   266,  1283,  1284,  1285,  1286,   328,   320,   328,  1290,
     331,   328,     1,   328,   318,  1296,   320,   328,   328,   320,
     320,   328,   328,   919,     1,   317,   318,   319,   307,   890,
    1283,  1284,  1285,  1286,   318,   320,   320,  1290,   317,   318,
     319,   320,   321,  1296,   318,   906,   320,   908,   318,   910,
     320,   320,   331,   317,   915,   320,   320,   320,   323,   284,
     503,   318,     1,   320,   320,   320,   320,   320,   320,   320,
     320,   320,   320,     1,     1,   320,   320,   320,   320,   317,
     320,   320,   317,   318,   319,   284,   318,  1451,  1452,   318,
     318,   317,   303,     1,   307,   303,   303,   303,     1,  1246,
    1533,   303,   303,   303,   317,     1,   317,   303,   793,   317,
     317,   317,   973,   974,     1,   317,   317,   317,     1,   307,
     317,   317,  1486,  1487,  1488,  1489,    62,     1,     1,   317,
     317,   317,     1,   994,     1,   996,  1283,  1284,  1285,  1286,
     284,  1462,  1038,  1096,  1451,  1452,  1042,  1468,     1,     1,
       1,   284,   284,     1,     1,   803,     1,   805,     1,   284,
     808,    62,     1,   811,     1,    62,   284,   284,     1,   817,
    1451,  1452,     1,     1,  1035,  1036,   303,   284,    62,  1486,
    1487,  1488,  1489,     1,   801,   305,   306,   307,  1049,   806,
     317,   284,   809,   320,   284,   812,     1,     1,  1451,  1452,
       1,   284,     1,     1,     1,  1486,  1487,  1488,  1489,   325,
     284,   327,   292,   293,     1,     1,     1,   297,   298,   317,
     318,   284,   320,  1544,     1,     1,     1,     1,     1,     1,
       1,  1552,     1,  1486,  1487,  1488,  1489,  1098,     1,  1603,
    1547,     1,   890,  1104,     1,     1,     1,   329,     1,  1613,
       1,     1,     1,  1617,  1618,  1619,     1,     1,   906,     1,
     908,     1,   910,     1,     1,     1,  1547,   915,     1,   284,
       1,     1,     1,     1,   284,   284,   303,   303,     1,     1,
     317,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     317,   317,  1599,     1,  1547,  1602,  1603,     1,     1,     1,
    1020,  1162,     1,     1,     1,     1,  1613,  1614,  1615,     1,
    1617,  1618,  1619,     1,   303,     1,     1,     1,  1599,  1034,
       1,  1602,  1603,     1,     1,     1,   974,  1042,   317,     1,
       1,     1,  1613,  1614,  1615,     1,  1617,  1618,  1619,   803,
     317,   805,     1,     1,   808,     1,  1599,   811,     1,  1602,
    1603,     1,     1,   817,   284,     1,     1,     1,     1,     1,
    1613,  1614,  1615,     1,  1617,  1618,  1619,     1,     1,     1,
    1055,     1,  1057,     1,  1059,   303,   303,     1,   317,     1,
       1,   317,     1,  1103,   284,  1246,     1,   320,  1036,   317,
     317,   317,   318,     1,   320,     1,     1,     1,     1,     1,
    1547,  1049,   317,   318,   284,   320,     1,     1,     1,   317,
      19,   284,   284,   284,   317,     1,   317,   284,     1,     1,
     317,   317,  1283,  1284,  1285,  1286,   890,     1,   284,  1290,
     317,     1,     1,   317,   317,  1296,  1084,   284,   284,   284,
     284,   284,   906,   317,   908,   284,   910,   284,   317,   284,
    1098,   915,  1599,   284,   284,  1602,  1104,   284,    88,    89,
      90,    91,     1,   284,   317,   317,   317,  1614,  1615,   317,
       1,   284,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,   317,   284,   284,   284,   317,   317,
     284,    22,    23,    24,    25,    26,    27,    28,    29,   317,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
     974,    42,   317,   317,  1162,    46,   317,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
     317,   317,   317,    64,    65,    66,    67,    68,    69,   284,
     317,   317,   317,   317,   317,   317,   317,    20,   317,    88,
      89,    90,    91,    21,   317,   317,   317,   317,   284,   284,
     317,   317,   317,  1459,   317,   284,   317,   317,   317,   317,
     317,   317,  1036,   317,   284,   317,   317,   317,   284,   317,
     317,   317,   317,   284,   317,  1049,   317,   317,   317,   317,
    1451,  1452,   284,   284,   317,   317,   317,   317,  1246,   317,
     317,   317,   317,   317,   317,   317,   317,   284,   317,   317,
     284,   292,   293,   317,   317,   317,   297,   298,   317,   317,
     317,   317,   284,   284,   284,  1486,  1487,  1488,  1489,   317,
     284,   317,   317,   317,  1098,  1283,  1284,  1285,  1286,   317,
    1104,   317,  1290,   284,   284,   317,   317,   317,  1296,   284,
     317,   317,    88,    89,    90,    91,   284,   284,   317,   317,
     284,   317,   284,   284,   317,   284,   284,   317,   317,   284,
    1390,   317,   317,   317,   317,   317,   284,   307,   284,   317,
     284,   284,   284,   317,   317,   317,  1547,   292,   293,   284,
     284,   317,   297,   298,   299,   300,   301,   302,  1162,   292,
     293,   284,   284,   296,   297,   298,   292,   293,   284,   284,
     296,   297,   298,   284,   284,   284,   284,   284,   292,   293,
     317,   284,   296,   297,   298,   325,   938,   327,   940,   325,
     942,   327,   944,   284,   325,   266,   327,   284,  1599,     1,
     317,  1602,  1603,   268,   269,   270,   271,   272,   273,   274,
     275,   276,  1613,  1614,  1615,   303,  1617,  1618,  1619,   303,
     284,   325,   303,   327,   284,   325,   314,   327,   307,   325,
     314,   327,   317,   314,   303,   284,   325,   325,   327,   327,
     284,   325,  1246,   327,   325,   314,   327,   318,   325,   284,
     327,   322,   323,   318,   284,   326,   325,  1482,   327,   330,
    1485,   284,   284,  1451,  1452,   284,   303,  1527,   284,    71,
      72,    73,    74,   325,    76,   327,    78,   314,    80,  1283,
    1284,  1285,  1286,   325,   284,   327,  1290,   325,   325,   327,
     327,   284,  1296,   303,   304,   305,   306,   307,  1486,  1487,
    1488,  1489,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   317,   318,   319,   320,   321,
     325,   307,   327,   284,   284,   325,   328,   327,   325,   331,
     327,   317,   318,   319,   320,   321,   329,   325,   284,   327,
     284,   284,   328,   284,   284,   331,   284,   284,   284,  1547,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   327,   317,   318,   319,   320,   321,   284,   284,
     284,  1599,   284,   284,  1602,  1603,   284,   331,   284,   284,
     284,  1173,   284,   284,   284,  1613,  1614,  1615,   284,  1617,
    1618,  1619,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   284,   284,   284,   284,   284,   284,  1451,  1452,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   284,   284,   284,   284,   284,   284,   284,   284,
     284,   284,  1486,  1487,  1488,  1489,   284,   284,   284,   284,
     317,   327,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   334,   317,   317,   317,   332,
     334,   102,   284,   317,   284,   317,   317,   317,   317,   317,
       0,     1,   317,   317,   327,   317,   317,   320,   317,   317,
     317,   317,   317,  1547,    14,    15,    16,    17,    18,    19,
      20,    21,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,    38,   325,
     325,    41,    42,    43,    44,    45,   329,   314,   317,   317,
     321,   325,   334,   317,   332,   317,   332,    57,   324,   320,
     325,   334,   334,   258,   327,  1599,   314,   326,  1602,  1603,
     328,   328,   332,   328,   328,   328,   328,   328,   328,  1613,
    1614,  1615,   328,  1617,  1618,  1619,   328,   328,   326,   332,
     314,   325,   332,   332,    94,    95,    96,    97,    98,    99,
     100,   101,   332,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   329,   329,   328,   328,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   320,   259,
     260,   261,   262,   263,   264,   265,   327,   327,   327,   327,
     327,   327,   327,   327,   327,   314,   328,   258,   278,   279,
     280,   281,   282,   283,   331,   329,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   329,
     329,   329,   317,   317,   327,   327,   327,   327,   318,   327,
     318,   327,   284,   284,   284,   284,   326,   330,   327,   331,
     327,   327,     1,   333,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,   325,   327,   325,   327,
      47,   327,   327,    22,    23,    24,    25,    26,    27,    28,
      29,   327,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,   327,    42,   327,   327,   327,    46,   327,    48,
      49,    50,    51,    52,    53,    54,    55,   327,   327,    58,
      59,    60,   327,   327,   327,    64,    65,    66,    67,    68,
      69,     1,   327,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,   327,   327,   327,   327,   327,
     327,   327,    22,    23,    24,    25,    26,    27,    28,    29,
     327,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,   327,    42,   327,   327,   327,    46,   327,    48,    49,
      50,    51,    52,    53,    54,    55,   327,   327,    58,    59,
      60,   327,   327,   327,    64,    65,    66,    67,    68,    69,
       1,   327,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,   334,   334,   327,   327,   325,   327,
     332,    22,    23,    24,    25,    26,    27,    28,    29,   327,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
     327,    42,   327,   327,   327,    46,   327,    48,    49,    50,
      51,    52,    53,    54,    55,   327,   318,    58,    59,    60,
     325,   320,   320,    64,    65,    66,    67,    68,    69,   284,
     314,     1,   327,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,   327,   317,   317,   317,   317,
     317,   317,    22,    23,    24,    25,    26,    27,    28,    29,
     317,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,   317,    42,   317,   317,   317,    46,   317,    48,    49,
      50,    51,    52,    53,    54,    55,   317,   266,    58,    59,
      60,   317,   317,   331,    64,    65,    66,    67,    68,    69,
     314,   306,   320,   327,   327,   320,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   330,
     334,   317,   327,   327,   327,   314,   327,   327,   327,   318,
     327,   187,   327,   322,   323,   327,   325,   326,   327,   328,
     329,   327,   327,   327,   327,   334,   266,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   327,   327,
     327,   327,   327,   327,   327,   327,   327,   327,   318,   327,
     327,   327,   322,   323,   327,   325,   326,   327,   328,   329,
     332,   327,   327,   334,   334,   266,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   334,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   334,   327,   327,
     332,   332,   919,   825,   334,  1141,   793,   318,   334,   331,
     791,   322,   323,   499,   325,   326,   327,   332,   329,  1544,
    1274,  1528,  1552,   334,  1466,    -1,   266,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,  1143,  1143,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   318,    -1,
      -1,    -1,   322,   323,     1,   325,   326,   327,    -1,   329,
      -1,    -1,    -1,    -1,   334,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    38,    -1,    -1,    41,    42,    43,    44,    45,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      57,    -1,    -1,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   327,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,    -1,    -1,    -1,    -1,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,    -1,   259,   260,   261,   262,   263,   264,   265,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   278,   279,   280,   281,   282,   283,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       1,   318,     3,     4,     5,     6,     7,    -1,    -1,   326,
      -1,    12,    13,    14,    -1,    -1,   333,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,     1,    -1,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    -1,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    -1,    -1,    -1,
      64,    65,    66,    67,    68,    69,     1,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    46,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   266,   267,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   303,    -1,    -1,    -1,    -1,   308,    -1,   310,
     311,   312,   313,    -1,   315,   316,   317,   318,    -1,   320,
     321,   322,   323,    -1,    -1,    -1,    -1,   328,   329,    -1,
     331,    -1,     1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,   266,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    -1,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    -1,    -1,    -1,    64,    65,    66,    67,    68,
      69,    -1,    -1,    -1,   318,    -1,    -1,    -1,   322,   323,
      -1,    -1,   326,    -1,    -1,    -1,   330,    -1,    -1,    -1,
      -1,   266,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   318,    -1,    -1,    -1,   322,   323,    -1,
      -1,   326,    -1,    -1,     1,   330,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,    46,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    -1,    -1,    -1,    64,    65,    66,
      67,    68,    69,     1,    -1,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    -1,   266,    46,    -1,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    -1,    -1,    64,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   318,
      -1,    -1,    -1,   322,   323,    -1,    -1,   326,    -1,    -1,
       1,   330,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    46,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    -1,    -1,    58,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,     1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,   266,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    46,    -1,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    -1,    58,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,    -1,    -1,
      -1,   318,    -1,    -1,    -1,   322,   323,    -1,    -1,   326,
      -1,    -1,    -1,   330,    -1,    -1,    -1,    -1,   266,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     318,    -1,    -1,    -1,   322,   323,    -1,    -1,   326,    -1,
      -1,     1,   330,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    -1,   266,    46,    -1,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    -1,    58,    59,
      60,    -1,    -1,    -1,    64,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   318,    -1,    -1,
      -1,   322,   323,    -1,    -1,   326,    -1,    -1,    -1,   330,
      -1,    -1,    -1,    -1,   266,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   318,    -1,    -1,    -1,
     322,   323,    -1,    -1,   326,    -1,    -1,     1,   330,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    -1,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    -1,    -1,    58,    59,    60,    -1,    -1,    -1,
      64,    65,    66,    67,    68,    69,     1,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,   266,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    46,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    -1,    -1,    58,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,    -1,    -1,    -1,   318,    -1,
      -1,    -1,   322,   323,    -1,    -1,   326,    -1,    -1,     1,
     330,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    46,    -1,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    -1,    58,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,     1,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    -1,   266,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    -1,    -1,    58,    59,    60,    -1,    -1,
      -1,    64,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   318,    -1,    -1,    -1,   322,   323,
      -1,    -1,   326,    -1,    -1,    -1,   330,    -1,    -1,    -1,
      -1,   266,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   318,    -1,    -1,    -1,   322,   323,    -1,
      -1,   326,    -1,    -1,     1,   330,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,   266,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,    46,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    -1,
      -1,    58,    59,    60,    -1,    -1,    -1,    64,    65,    66,
      67,    68,    69,    -1,    -1,    -1,   318,    -1,    -1,    -1,
     322,   323,    -1,    -1,   326,    -1,    -1,    -1,   330,    -1,
      -1,    -1,    -1,   266,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   318,    -1,    -1,    -1,   322,
     323,    -1,    -1,   326,    -1,    -1,     1,   330,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    46,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    -1,    -1,    58,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,     1,    -1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    -1,    -1,   266,
      46,    -1,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    -1,    58,    59,    60,    -1,    -1,    -1,    64,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   318,    -1,    -1,    -1,   322,   323,    -1,    -1,   326,
      -1,    -1,     1,   330,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    -1,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    -1,    -1,    58,
      59,    60,    -1,    -1,    -1,    64,    65,    66,    67,    68,
      69,     1,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,   266,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    -1,    46,    -1,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    -1,    58,    59,
      60,    -1,    -1,    -1,    64,    65,    66,    67,    68,    69,
      -1,    -1,    -1,   318,    -1,    -1,    -1,   322,   323,    -1,
      -1,   326,    -1,    -1,    -1,   330,    -1,    -1,    -1,    -1,
     266,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   318,    -1,    -1,    -1,   322,   323,    -1,    -1,
     326,    -1,    -1,     1,   330,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    -1,   266,    46,    -1,
      48,    49,    50,    51,    52,    53,    54,    55,    -1,    -1,
      58,    59,    60,    -1,    -1,    -1,    64,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   318,
      -1,    -1,    -1,   322,   323,    -1,    -1,   326,    -1,    -1,
      -1,   330,    -1,    -1,    -1,    -1,   266,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   318,    -1,
      -1,    -1,   322,   323,    -1,    -1,   326,    -1,    -1,    -1,
     330,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,    59,    60,    -1,    -1,   266,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     318,    -1,    -1,    -1,   322,   323,    -1,    -1,   326,    -1,
      -1,     1,   330,     3,     4,     5,     6,     7,    -1,    -1,
      -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,
      50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,
      60,    -1,    -1,    -1,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   266,   267,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   303,    -1,
      -1,    -1,   307,   308,    -1,   310,   311,   312,   313,    -1,
     315,   316,   317,   318,    -1,   320,    -1,   322,   323,    -1,
      -1,    -1,    -1,   328,   329,     1,    -1,     3,     4,     5,
       6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,
      -1,    -1,    48,    49,    50,    51,    52,    53,    54,    -1,
      -1,    -1,    -1,    59,    60,    -1,   266,   267,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   303,    -1,    -1,    -1,   307,   308,    -1,
     310,   311,   312,   313,    -1,   315,   316,   317,   318,    -1,
     320,    -1,   322,   323,    -1,    -1,    -1,    -1,   328,   329,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     266,   267,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   303,    -1,    -1,
      -1,    -1,   308,    -1,   310,   311,   312,   313,    -1,   315,
     316,   317,   318,    -1,   320,    -1,   322,   323,    -1,    -1,
      -1,   327,   328,   329,     1,    -1,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,
      -1,    48,    49,    50,    51,    52,    53,    54,    -1,    -1,
      -1,    -1,    59,    60,    -1,   266,   267,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   303,    -1,    -1,    -1,    -1,   308,    -1,   310,
     311,   312,   313,    -1,   315,   316,   317,   318,    -1,   320,
      -1,   322,   323,    -1,    -1,    -1,   327,   328,   329,     1,
      -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,
      52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   266,
     267,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   303,    -1,    -1,    -1,
      -1,   308,    -1,   310,   311,   312,   313,    -1,   315,   316,
     317,   318,    -1,   320,    -1,   322,   323,    -1,    -1,    -1,
     327,   328,   329,     1,    -1,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,
      48,    49,    50,    51,    52,    53,    54,    -1,    -1,    -1,
      -1,    59,    60,    -1,   266,   267,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   303,    -1,    -1,   306,    -1,   308,    -1,   310,   311,
     312,   313,    -1,   315,   316,   317,   318,    -1,   320,    -1,
     322,   323,    -1,    -1,    -1,    -1,   328,   329,     1,    -1,
       3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,
      53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,    -1,
      -1,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   266,   267,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   303,    -1,    -1,    -1,    -1,
     308,    -1,   310,   311,   312,   313,    -1,   315,   316,   317,
     318,    -1,   320,    -1,   322,   323,    -1,    -1,    -1,    -1,
     328,   329,     1,    -1,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    48,
      49,    50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,
      59,    60,    -1,   266,   267,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     303,    -1,    -1,    -1,    -1,   308,    -1,   310,   311,   312,
     313,    -1,   315,   316,   317,   318,    -1,   320,    -1,   322,
     323,    -1,    -1,    -1,    -1,   328,   329,     1,    -1,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,    53,
      54,    -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   266,   267,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   303,    -1,    -1,    -1,    -1,   308,
      -1,   310,   311,   312,   313,    -1,   315,   316,   317,   318,
      -1,   320,    -1,   322,   323,    -1,    -1,    -1,    -1,   328,
     329,     1,    -1,     3,     4,     5,     6,     7,    -1,    -1,
      -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,
      50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,
      60,    -1,   266,   267,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   303,
      -1,    -1,    -1,    -1,   308,    -1,   310,   311,   312,   313,
      -1,   315,   316,   317,   318,    -1,   320,    -1,   322,   323,
      -1,    -1,    -1,    -1,   328,   329,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   266,   267,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   303,    -1,    -1,    -1,    -1,   308,    -1,
     310,   311,   312,   313,    -1,   315,   316,   317,   318,    -1,
     320,    -1,   322,   323,    -1,    -1,    -1,    -1,   328,   329,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,
      -1,   266,   267,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   303,    -1,
      -1,    -1,    -1,   308,    -1,   310,   311,   312,   313,    -1,
     315,   316,   317,   318,    -1,   320,    -1,   322,   323,    -1,
      -1,    -1,    -1,   328,   329,     1,    -1,     3,     4,     5,
       6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,
      -1,    -1,    48,    49,    50,    51,    52,    53,    54,    -1,
      -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   266,   267,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   303,    -1,    -1,    -1,    -1,   308,    -1,   310,
     311,   312,   313,    -1,   315,   316,   317,   318,    -1,   320,
      -1,   322,   323,    -1,    -1,    -1,    -1,   328,   329,     1,
      -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,
      52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,
     266,   267,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   303,    -1,    -1,
      -1,    -1,   308,    -1,   310,   311,   312,   313,    -1,   315,
     316,   317,   318,    -1,   320,    -1,   322,   323,    -1,    -1,
      -1,    -1,   328,   329,     1,    -1,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,
      -1,    48,    49,    50,    51,    52,    53,    54,    -1,    -1,
      -1,    -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   266,   267,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   303,    -1,    -1,    -1,    -1,   308,    -1,   310,   311,
     312,   313,    -1,   315,   316,   317,   318,    -1,   320,    -1,
     322,   323,    -1,    -1,    -1,    -1,   328,   329,     1,    -1,
       3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,
      53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,   266,
     267,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   303,    -1,    -1,    -1,
      -1,   308,    -1,   310,   311,   312,   313,    -1,   315,   316,
     317,   318,    -1,   320,    -1,   322,   323,    -1,    -1,    -1,
      -1,   328,   329,     1,    -1,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,
      48,    49,    50,    51,    52,    53,    54,    -1,    -1,    -1,
      -1,    59,    60,    -1,    -1,    -1,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   266,   267,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     303,    -1,    -1,    -1,    -1,   308,    -1,   310,   311,   312,
     313,    -1,   315,   316,   317,   318,    -1,   320,    -1,   322,
     323,    -1,    -1,    -1,    -1,   328,   329,     1,    -1,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,    53,
      54,    -1,    -1,    -1,    -1,    59,    60,    -1,   266,   267,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   303,    -1,    -1,    -1,    -1,
     308,    -1,   310,   311,   312,   313,    -1,   315,   316,   317,
     318,    -1,   320,    -1,   322,   323,    -1,    -1,    -1,    -1,
     328,   329,     1,    -1,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    48,
      49,    50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,
      59,    60,    -1,    -1,    -1,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   266,   267,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   303,
      -1,    -1,    -1,    -1,   308,    -1,   310,   311,   312,   313,
      -1,   315,   316,   317,   318,    -1,   320,    -1,   322,   323,
      -1,    -1,    -1,    -1,   328,   329,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,    59,    60,    -1,   266,   267,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   303,    -1,    -1,    -1,    -1,   308,
      -1,   310,   311,   312,   313,    -1,   315,   316,   317,   318,
      -1,   320,    -1,   322,   323,    -1,    -1,    -1,    -1,   328,
     329,     1,    -1,     3,     4,     5,     6,     7,    -1,    -1,
      -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,
      50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,
      60,    -1,    -1,    -1,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   266,   267,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   303,    -1,
      -1,    -1,    -1,   308,    -1,   310,   311,   312,   313,    -1,
     315,   316,   317,   318,    -1,   320,    -1,   322,   323,    -1,
      -1,    -1,    -1,   328,   329,     1,    -1,     3,     4,     5,
       6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,
      -1,    -1,    48,    49,    50,    51,    52,    53,    54,    -1,
      -1,    -1,    -1,    59,    60,    -1,   266,   267,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   303,    -1,    -1,    -1,    -1,   308,    -1,
     310,   311,   312,   313,    -1,   315,   316,   317,   318,    -1,
     320,    -1,   322,   323,    -1,    -1,    -1,    -1,   328,   329,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     266,   267,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   303,    -1,    -1,
      -1,    -1,   308,    -1,   310,   311,   312,   313,    -1,   315,
     316,   317,   318,    -1,   320,    -1,   322,   323,    -1,    -1,
      -1,    -1,   328,   329,     1,    -1,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,
      -1,    48,    49,    50,    51,    52,    53,    54,    -1,    -1,
      -1,    -1,    59,    60,    -1,   266,   267,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   303,    -1,    -1,    -1,    -1,   308,    -1,   310,
     311,   312,   313,    -1,   315,   316,   317,   318,    -1,   320,
      -1,   322,   323,    -1,    -1,    -1,    -1,   328,   329,     1,
      -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,
      52,    53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,
      -1,    -1,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   266,
     267,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   303,    -1,    -1,    -1,
      -1,   308,    -1,   310,   311,   312,   313,    -1,   315,   316,
     317,   318,    -1,   320,    -1,   322,   323,    -1,    -1,    -1,
      -1,   328,   329,     1,    -1,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,
      48,    49,    50,    51,    52,    53,    54,    -1,    -1,    -1,
      -1,    59,    60,    -1,   266,   267,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   303,    -1,    -1,    -1,    -1,   308,    -1,   310,   311,
     312,   313,    -1,   315,   316,   317,   318,    -1,   320,    -1,
     322,   323,    -1,    -1,    -1,    -1,   328,   329,     1,    -1,
       3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,
      53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,    -1,
      -1,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   266,   267,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   303,    -1,    -1,    -1,    -1,
     308,    -1,   310,   311,   312,   313,    -1,   315,   316,   317,
     318,    -1,   320,    -1,   322,   323,    -1,    -1,    -1,    -1,
     328,   329,     1,    -1,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    48,
      49,    50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,
      59,    60,    -1,   266,   267,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     303,    -1,    -1,    -1,    -1,   308,    -1,   310,   311,   312,
     313,    -1,   315,   316,   317,   318,    -1,   320,    -1,   322,
     323,    -1,    -1,    -1,    -1,   328,   329,     1,    -1,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,    53,
      54,    -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    -1,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,   266,   267,    58,
      59,    60,    -1,    -1,    -1,    64,    65,    66,    67,    68,
      69,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   303,    -1,    -1,    -1,    -1,   308,
      -1,   310,   311,   312,   313,    -1,   315,   316,   317,   318,
      -1,   320,    -1,   322,   323,    -1,    -1,    -1,    -1,   328,
     329,     1,    -1,     3,     4,     5,     6,     7,    -1,    -1,
      -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,
      50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,
      60,    -1,   266,   267,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   303,
      -1,    -1,    -1,    -1,   308,    -1,   310,   311,   312,   313,
      -1,   315,   316,   317,   318,    -1,   320,    -1,   322,   323,
      -1,    -1,    -1,    -1,   328,   329,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   266,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   318,
      -1,    -1,    -1,   322,   323,    -1,    -1,   326,    -1,    -1,
     329,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,   266,   267,    59,    60,
      -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,   303,    -1,    -1,    -1,    -1,   308,    -1,
     310,   311,   312,   313,    -1,   315,   316,   317,   318,    -1,
     320,    -1,   322,   323,    -1,    -1,    -1,    -1,   328,   329,
       3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,
      53,    54,    -1,    -1,    -1,    -1,    59,    60,    -1,    -1,
      -1,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    -1,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,    -1,
      -1,    48,    49,    50,    51,    52,    53,    54,    -1,    -1,
      -1,    -1,    59,    60,    -1,   266,   267,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   303,    -1,    -1,    -1,    -1,   308,    -1,   310,
     311,   312,   313,    -1,   315,   316,   317,   318,    -1,   320,
      -1,   322,   323,    -1,    -1,    -1,    -1,   328,   329,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    -1,    -1,    -1,    48,    49,    50,    51,    52,    53,
      54,    -1,    -1,   266,   267,    59,    60,    -1,    -1,    -1,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
     303,    -1,    -1,    -1,    -1,   308,    -1,   310,   311,   312,
     313,    -1,   315,   316,   317,   318,    -1,   320,    -1,   322,
     323,    -1,    -1,    -1,    -1,   328,   329,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   266,
     267,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   303,    -1,    -1,    -1,
      -1,   308,    -1,   310,   311,   312,   313,    -1,   315,   316,
     317,   318,    -1,   320,    -1,   322,   323,    -1,    -1,    -1,
      -1,   328,   329,     3,     4,     5,     6,     7,    -1,    -1,
      -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    48,    49,
      50,    51,    52,    53,    54,    -1,    -1,    -1,    -1,    59,
      60,    -1,   266,   267,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   303,
      -1,    -1,    -1,    -1,   308,    -1,   310,   311,   312,   313,
      -1,   315,   316,   317,   318,    -1,   320,    -1,   322,   323,
      -1,    -1,    -1,    -1,   328,   329,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    -1,    46,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    -1,
      -1,    58,    59,    60,    -1,    -1,    -1,    64,    65,    66,
      67,    68,    69,     1,    -1,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    -1,    46,    -1,
      48,    49,    50,    51,    52,    53,    54,    55,    -1,    -1,
      58,    59,    60,    -1,    -1,    -1,    64,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    -1,   266,   267,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   303,    -1,    -1,    -1,    -1,   308,    -1,
     310,   311,   312,   313,    -1,   315,   316,   317,   318,    -1,
     320,    -1,   322,   323,    -1,    -1,    -1,    -1,   328,   329,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    -1,    -1,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    -1,    -1,    58,    59,    60,    -1,   266,
      -1,    64,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   318,    -1,    -1,    -1,   322,   323,    -1,    -1,   326,
      -1,    -1,   329,    -1,    -1,    -1,    -1,    -1,   266,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     318,    -1,    -1,    -1,   322,   323,    -1,    -1,   326,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   266,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   318,    -1,    -1,    -1,   322,
     323,    -1,    -1,   326
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     1,    17,    18,    38,    41,    42,    43,    44,    45,
      57,    94,    95,    96,    97,    98,    99,   100,   101,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     259,   260,   261,   262,   263,   264,   265,   278,   279,   280,
     281,   282,   283,   318,   326,   333,   336,   337,   338,   339,
     340,   341,   342,   343,   354,   358,   361,   362,   363,   364,
     373,   374,   380,   284,     1,   331,     1,   284,   284,   284,
     284,   284,   284,   284,   284,   284,   284,   284,   284,   284,
     284,   284,   284,   284,   284,     1,   284,     1,   284,     1,
     284,     1,   284,     1,   284,     1,   284,     1,   284,     1,
     284,     1,   284,     1,   284,     1,   284,     1,   284,     1,
     284,     1,   284,     1,   284,     1,   284,     1,   284,     1,
     284,     1,   284,     1,   284,     1,   284,     1,   284,     1,
     284,     1,   284,     1,   284,     1,   284,     1,   284,     1,
     284,     1,   284,     1,   284,     1,   284,     1,   284,   284,
     284,   284,   284,   284,   284,   284,   284,   284,   284,   284,
     284,   284,   284,   284,   284,   284,   284,     1,   320,     1,
     284,   320,     1,   328,   284,   284,   284,   284,   284,   284,
     284,   284,   284,   284,   284,   284,   284,   284,   284,   284,
     284,   284,   284,   284,   284,     1,   284,     1,   284,     1,
     284,     1,   284,   284,   284,   284,   284,   284,   284,   284,
     284,   284,   284,   284,   284,   284,   284,   284,   284,   284,
     284,   284,   284,   284,   284,   284,   284,   284,   284,   284,
     284,   284,   284,   284,   284,   284,   284,   284,   284,   284,
     284,   284,   284,   284,   284,   284,   284,   284,   284,   284,
     284,   284,   284,   284,   284,   284,   284,   284,   284,   284,
     284,   284,   284,   284,   284,     1,   284,   284,   284,   284,
     284,   284,   284,   284,   284,   284,   284,   284,     1,   318,
     320,   355,   356,   357,     1,   357,   359,   360,   284,   284,
     284,     1,   320,     1,   320,     1,   320,     0,     1,   338,
      14,    15,   370,   371,    16,   372,    19,   377,    20,   378,
      21,   379,   314,   331,   329,   317,   318,   320,   369,     1,
     317,     1,   317,     1,    88,    89,    90,    91,   307,   347,
       1,   303,   317,   353,     1,   317,     1,   317,     1,   353,
       1,   317,     1,   317,     1,   317,     1,   318,     1,   320,
       1,   317,     1,   317,   318,   319,   320,   321,   328,   331,
     344,   346,   347,   351,   352,   365,   366,   367,   368,   394,
     395,     1,   352,     1,   317,     1,   317,     1,   317,   317,
     317,   317,   353,   353,   353,   353,   317,   317,   317,   317,
     317,   317,   317,   317,   317,   317,   317,   317,   317,   317,
     317,   317,   317,   317,   317,   317,   317,   317,   317,   317,
     317,     1,   317,   320,     1,   317,     1,   317,     1,   317,
       1,   317,     1,   317,     1,   353,     1,   353,     1,   353,
       1,   353,     1,   353,     1,   353,     1,   317,     1,   317,
       1,   320,     1,   320,     1,   317,     1,   320,   320,     1,
     317,     1,   317,     1,   318,   320,     1,   318,   320,     1,
     318,   320,     1,   318,   320,     1,   317,     1,   317,     1,
     317,     1,   317,     1,   353,     1,   353,     1,   353,     1,
     318,   320,     1,   317,     1,   317,     1,   317,     1,   317,
     366,     1,   368,     1,   317,     1,   317,   317,   317,   317,
     317,     1,   317,     1,   317,     1,   317,     1,   317,     1,
     317,     1,   317,     1,   317,     1,   317,     1,   317,     1,
     317,     1,   317,     1,   317,     1,   317,     1,   317,     1,
     317,     1,   203,   204,   205,   206,     1,   317,     1,   317,
       1,   317,     1,   317,     1,   320,     1,   320,     1,   320,
       1,   317,     1,   317,     1,   317,     1,   317,     1,   317,
       1,   317,     1,   317,     1,   317,     1,   317,     1,   317,
       1,   353,     1,   317,     1,   317,     1,   317,     1,   317,
       1,   317,     1,   317,     1,   353,     1,   317,     1,   317,
       1,   317,     1,   317,     1,   344,     1,   317,     1,   317,
       1,   317,     1,   317,     1,   317,     1,   317,     1,   317,
       1,   317,     1,   317,     1,   317,     1,   317,     1,   317,
       1,   317,     1,   317,     1,   317,     1,   317,   318,   317,
       1,   317,     1,   317,     1,   317,     1,   317,     1,   317,
       1,   320,   317,     1,   317,     1,   317,     1,   317,     1,
     317,   325,   334,   325,     1,   317,     1,   317,     1,   317,
       1,   331,     1,   329,     1,   329,   331,     1,   329,   331,
       1,   329,   331,     1,   331,   362,   317,   375,   332,   317,
     314,   344,   345,   367,   334,   334,   352,   102,   303,   314,
     325,   355,   317,   359,   369,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    22,    23,    24,
      25,    26,    27,    28,    29,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    42,    46,    48,    49,    50,
      51,    52,    53,    54,    55,    58,    59,    60,    64,    65,
      66,    67,    68,    69,   266,   318,   322,   323,   326,   396,
     398,   399,   400,   404,   405,   413,   414,   416,   417,   420,
     421,   423,   427,   428,   429,   433,   398,   369,   398,   369,
     398,   369,   324,   284,   332,   398,     1,   376,   317,   325,
     327,   332,     1,   307,   317,   349,   346,   344,     1,   317,
     394,     1,   394,   320,   332,     1,   328,     1,   328,     1,
     328,     1,   328,     1,   328,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,   267,   303,   308,   310,   311,   312,   313,
     315,   316,   320,   328,   329,   353,   386,   387,   388,   389,
     390,   391,   396,   408,   413,   414,   415,   416,   418,   420,
     421,   424,   425,   426,   328,   426,   328,   426,     1,   328,
       1,   328,     1,   328,   328,     1,   328,     1,   328,     1,
     328,     1,   328,     1,   328,     1,   328,     1,   328,     1,
     328,   328,     1,   328,     1,   328,     1,   328,     1,   328,
     328,   328,   328,   328,   328,   328,   426,     1,   328,     1,
     328,     1,   328,   328,   328,   328,   328,     1,   426,   426,
       1,   328,     1,   328,     1,   328,     1,   328,     1,   328,
       1,   430,     1,   326,     1,   330,   399,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   318,   410,   411,   412,
     284,   422,   326,     1,   328,   326,   330,   332,   330,   332,
     330,   332,   332,     1,   317,   320,   314,   330,   329,   314,
     345,   334,   334,   325,   329,     1,    61,   318,   320,   327,
     365,   393,     1,    61,   320,   365,   393,     1,    61,   320,
     365,   393,     1,    61,   320,   365,   393,     1,    61,   320,
     365,   393,     1,   292,   293,   296,   297,   298,   381,   383,
     381,   381,     1,   381,   409,     1,   426,     1,   426,     1,
     426,   328,   328,     1,   327,   414,   416,   420,   421,   426,
     427,     1,   398,     1,   383,     1,   299,   300,   301,   302,
     381,   382,     1,   383,   412,     1,   426,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     384,   385,   327,   327,     1,   317,   320,     1,   320,     1,
     318,   426,   320,     1,   320,     1,   320,     1,   320,     1,
     320,     1,   317,     1,   317,   327,     1,   327,   353,   327,
       1,   320,     1,   320,     1,   320,     1,   320,   327,   327,
     327,     1,   317,   327,     1,   347,   329,   397,   399,     1,
     344,     1,   317,     1,   344,   347,   350,   327,   327,   327,
     327,   329,   397,     1,   320,     1,   320,   317,   357,   317,
     357,   317,   357,   328,   314,   331,   426,     1,   320,   413,
     414,   419,   421,   329,   329,   329,   329,   258,   258,   362,
     398,   317,   349,   317,   320,   353,   398,   327,   325,   327,
     325,   327,   325,   327,   303,   314,   325,   327,   327,   325,
     327,   325,   327,   325,   327,   325,   327,   327,   325,   327,
     325,   327,   325,   327,   325,   327,   327,   325,   327,   325,
     327,   325,   327,   325,   327,   327,   325,   327,   325,   327,
     325,   327,   325,   327,     1,   318,   426,     1,    88,    89,
      90,    91,    92,    93,   307,   348,   426,     1,   348,   426,
       1,   386,   390,   318,   406,   407,     1,   426,     1,   426,
     327,   327,   327,   330,   330,     1,    86,   426,     1,   426,
       1,   426,     1,    86,   317,   318,   365,   392,   393,   426,
     331,     1,   426,     1,   426,     1,   426,     1,   426,   426,
     426,   426,     1,   426,     1,   426,     1,   426,     1,   426,
       1,   426,     1,   426,     1,   426,   327,   325,   327,   327,
     325,   327,   327,   327,   327,   327,   327,   327,   327,   327,
     327,   327,   327,   327,   327,   327,   327,   327,   327,   327,
     327,   327,   327,   327,   327,   327,   327,   327,   327,   327,
     327,   398,    47,   327,   327,   327,   327,   327,   334,   334,
     327,     1,    56,    57,   330,   402,   403,   327,   325,   327,
     327,   327,   327,   327,   327,   327,   327,   426,   431,   432,
     411,   332,   325,   327,   412,   325,   398,   398,   398,   398,
     320,   320,   284,   330,   314,   327,   327,   330,    62,   317,
     317,   317,     1,   318,     1,   318,   317,    62,   317,   317,
     317,   317,    62,   317,   317,   317,   317,    62,   317,   317,
     317,   317,    62,   317,   317,   317,   317,   331,   314,   327,
     327,   327,   327,   306,   353,   320,   320,   330,   397,     1,
     349,   344,   330,     1,   306,   401,   426,   334,   330,   402,
     317,   426,   325,   327,   357,     1,   357,   330,   330,   330,
     330,   317,   320,   317,   327,   327,   327,   327,   327,   327,
     327,   327,   327,   327,   327,   327,   327,   327,   327,   327,
     327,   327,   327,   327,   327,   327,   327,   327,   327,   320,
     353,   406,     1,   317,   365,   332,   327,   327,   334,   334,
       1,   401,   334,   398,   327,   327,   432,   327,   327,   327,
     332,   332,   349,   398,   334,   334,     1,   398,   398,   398
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* This macro is provided for backward compatibility. */

#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  YYSIZE_T yysize1;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = 0;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                yysize1 = yysize + yytnamerr (0, yytname[yyx]);
                if (! (yysize <= yysize1
                       && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                  return 2;
                yysize = yysize1;
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  yysize1 = yysize + yystrlen (yyformat);
  if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
    return 2;
  yysize = yysize1;

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:

/* Line 1806 of yacc.c  */
#line 696 "cfg.y"
    {}
    break;

  case 4:

/* Line 1806 of yacc.c  */
#line 697 "cfg.y"
    {}
    break;

  case 5:

/* Line 1806 of yacc.c  */
#line 698 "cfg.y"
    { yyerror(""); YYABORT;}
    break;

  case 11:

/* Line 1806 of yacc.c  */
#line 706 "cfg.y"
    {rt=REQUEST_ROUTE;}
    break;

  case 13:

/* Line 1806 of yacc.c  */
#line 707 "cfg.y"
    {rt=FAILURE_ROUTE;}
    break;

  case 16:

/* Line 1806 of yacc.c  */
#line 709 "cfg.y"
    {rt=BRANCH_ROUTE;}
    break;

  case 18:

/* Line 1806 of yacc.c  */
#line 710 "cfg.y"
    {rt=ONSEND_ROUTE;}
    break;

  case 20:

/* Line 1806 of yacc.c  */
#line 711 "cfg.y"
    {rt=EVENT_ROUTE;}
    break;

  case 24:

/* Line 1806 of yacc.c  */
#line 716 "cfg.y"
    {
		if ((yyvsp[(1) - (1)].ipaddr)){
			tmp=ip_addr2a((yyvsp[(1) - (1)].ipaddr));
			if (tmp==0) {
				LOG(L_CRIT, "ERROR: cfg. parser: bad ip "
						"address.\n");
				(yyval.strval)=0;
			} else {
				(yyval.strval)=pkg_malloc(strlen(tmp)+1);
				if ((yyval.strval)==0) {
					LOG(L_CRIT, "ERROR: cfg. parser: out of "
							"memory.\n");
				} else {
					strncpy((yyval.strval), tmp, strlen(tmp)+1);
				}
			}
		}
	}
    break;

  case 25:

/* Line 1806 of yacc.c  */
#line 734 "cfg.y"
    {
		(yyval.strval)=pkg_malloc(strlen((yyvsp[(1) - (1)].strval))+1);
		if ((yyval.strval)==0) {
				LOG(L_CRIT, "ERROR: cfg. parser: out of "
						"memory.\n");
		} else {
				strncpy((yyval.strval), (yyvsp[(1) - (1)].strval), strlen((yyvsp[(1) - (1)].strval))+1);
		}
	}
    break;

  case 26:

/* Line 1806 of yacc.c  */
#line 743 "cfg.y"
    {
		if ((yyvsp[(1) - (1)].strval)){
			(yyval.strval)=pkg_malloc(strlen((yyvsp[(1) - (1)].strval))+1);
			if ((yyval.strval)==0) {
					LOG(L_CRIT, "ERROR: cfg. parser: out of "
							"memory.\n");
			} else {
					strncpy((yyval.strval), (yyvsp[(1) - (1)].strval), strlen((yyvsp[(1) - (1)].strval))+1);
			}
		}
	}
    break;

  case 27:

/* Line 1806 of yacc.c  */
#line 758 "cfg.y"
    { (yyval.name_l)=mk_name_lst((yyvsp[(1) - (1)].strval), SI_IS_MHOMED); }
    break;

  case 28:

/* Line 1806 of yacc.c  */
#line 759 "cfg.y"
    { (yyval.name_l)=mk_name_lst((yyvsp[(1) - (3)].strval), SI_IS_MHOMED); 
										if ((yyval.name_l)) (yyval.name_l)->next=(yyvsp[(3) - (3)].name_l);
									}
    break;

  case 29:

/* Line 1806 of yacc.c  */
#line 765 "cfg.y"
    { (yyval.name_l)=(yyvsp[(2) - (3)].name_l); }
    break;

  case 30:

/* Line 1806 of yacc.c  */
#line 766 "cfg.y"
    { (yyval.name_l)=mk_name_lst((yyvsp[(1) - (1)].strval), 0); }
    break;

  case 31:

/* Line 1806 of yacc.c  */
#line 770 "cfg.y"
    { (yyval.intval)=PROTO_UDP; }
    break;

  case 32:

/* Line 1806 of yacc.c  */
#line 771 "cfg.y"
    { (yyval.intval)=PROTO_TCP; }
    break;

  case 33:

/* Line 1806 of yacc.c  */
#line 772 "cfg.y"
    { (yyval.intval)=PROTO_TLS; }
    break;

  case 34:

/* Line 1806 of yacc.c  */
#line 773 "cfg.y"
    { (yyval.intval)=PROTO_SCTP; }
    break;

  case 35:

/* Line 1806 of yacc.c  */
#line 774 "cfg.y"
    { (yyval.intval)=0; }
    break;

  case 36:

/* Line 1806 of yacc.c  */
#line 777 "cfg.y"
    { (yyval.intval)=PROTO_UDP; }
    break;

  case 37:

/* Line 1806 of yacc.c  */
#line 778 "cfg.y"
    { (yyval.intval)=PROTO_TCP; }
    break;

  case 38:

/* Line 1806 of yacc.c  */
#line 779 "cfg.y"
    { (yyval.intval)=PROTO_TLS; }
    break;

  case 39:

/* Line 1806 of yacc.c  */
#line 780 "cfg.y"
    { (yyval.intval)=PROTO_SCTP; }
    break;

  case 40:

/* Line 1806 of yacc.c  */
#line 781 "cfg.y"
    { (yyval.intval)=PROTO_WS; }
    break;

  case 41:

/* Line 1806 of yacc.c  */
#line 782 "cfg.y"
    { (yyval.intval)=PROTO_WSS; }
    break;

  case 42:

/* Line 1806 of yacc.c  */
#line 783 "cfg.y"
    { (yyval.intval)=0; }
    break;

  case 43:

/* Line 1806 of yacc.c  */
#line 786 "cfg.y"
    { (yyval.intval)=(yyvsp[(1) - (1)].intval); }
    break;

  case 44:

/* Line 1806 of yacc.c  */
#line 787 "cfg.y"
    { (yyval.intval)=0; }
    break;

  case 45:

/* Line 1806 of yacc.c  */
#line 790 "cfg.y"
    { (yyval.sockid)=mk_listen_id((yyvsp[(1) - (1)].strval), 0, 0); }
    break;

  case 46:

/* Line 1806 of yacc.c  */
#line 791 "cfg.y"
    { (yyval.sockid)=mk_listen_id((yyvsp[(1) - (3)].strval), 0, (yyvsp[(3) - (3)].intval)); }
    break;

  case 47:

/* Line 1806 of yacc.c  */
#line 792 "cfg.y"
    { (yyval.sockid)=mk_listen_id((yyvsp[(3) - (3)].strval), (yyvsp[(1) - (3)].intval), 0); }
    break;

  case 48:

/* Line 1806 of yacc.c  */
#line 793 "cfg.y"
    { (yyval.sockid)=mk_listen_id((yyvsp[(3) - (5)].strval), (yyvsp[(1) - (5)].intval), (yyvsp[(5) - (5)].intval));}
    break;

  case 49:

/* Line 1806 of yacc.c  */
#line 794 "cfg.y"
    { (yyval.sockid)=0; yyerror(" port number expected"); }
    break;

  case 50:

/* Line 1806 of yacc.c  */
#line 798 "cfg.y"
    { (yyval.sockid)=mk_listen_id2((yyvsp[(1) - (1)].name_l), 0, 0); }
    break;

  case 51:

/* Line 1806 of yacc.c  */
#line 799 "cfg.y"
    { (yyval.sockid)=mk_listen_id2((yyvsp[(1) - (3)].name_l), 0, (yyvsp[(3) - (3)].intval)); }
    break;

  case 52:

/* Line 1806 of yacc.c  */
#line 800 "cfg.y"
    { (yyval.sockid)=mk_listen_id2((yyvsp[(3) - (3)].name_l), (yyvsp[(1) - (3)].intval), 0); }
    break;

  case 53:

/* Line 1806 of yacc.c  */
#line 801 "cfg.y"
    { (yyval.sockid)=mk_listen_id2((yyvsp[(3) - (5)].name_l), (yyvsp[(1) - (5)].intval), (yyvsp[(5) - (5)].intval));}
    break;

  case 54:

/* Line 1806 of yacc.c  */
#line 802 "cfg.y"
    { (yyval.sockid)=0; yyerror(" port number expected"); }
    break;

  case 55:

/* Line 1806 of yacc.c  */
#line 806 "cfg.y"
    {  (yyval.sockid)=(yyvsp[(1) - (1)].sockid) ; }
    break;

  case 56:

/* Line 1806 of yacc.c  */
#line 807 "cfg.y"
    { (yyval.sockid)=(yyvsp[(1) - (2)].sockid);  if ((yyval.sockid)) (yyval.sockid)->next=(yyvsp[(2) - (2)].sockid); }
    break;

  case 58:

/* Line 1806 of yacc.c  */
#line 811 "cfg.y"
    { (yyval.intval)=-(yyvsp[(2) - (2)].intval); }
    break;

  case 60:

/* Line 1806 of yacc.c  */
#line 815 "cfg.y"
    { yyerror("flag list expected\n"); }
    break;

  case 63:

/* Line 1806 of yacc.c  */
#line 821 "cfg.y"
    { if (register_flag((yyvsp[(1) - (1)].strval),-1)<0)
								yyerror("register flag failed");
						}
    break;

  case 64:

/* Line 1806 of yacc.c  */
#line 824 "cfg.y"
    {
						if (register_flag((yyvsp[(1) - (3)].strval), (yyvsp[(3) - (3)].intval))<0)
								yyerror("register flag failed");
										}
    break;

  case 65:

/* Line 1806 of yacc.c  */
#line 830 "cfg.y"
    { (yyval.strval)=(yyvsp[(1) - (1)].strval); }
    break;

  case 66:

/* Line 1806 of yacc.c  */
#line 831 "cfg.y"
    { (yyval.strval)=(yyvsp[(1) - (1)].strval); }
    break;

  case 68:

/* Line 1806 of yacc.c  */
#line 836 "cfg.y"
    { yyerror("avpflag list expected\n"); }
    break;

  case 71:

/* Line 1806 of yacc.c  */
#line 843 "cfg.y"
    {
		if (register_avpflag((yyvsp[(1) - (1)].strval))==0)
			yyerror("cannot declare avpflag");
	}
    break;

  case 72:

/* Line 1806 of yacc.c  */
#line 849 "cfg.y"
    { default_core_cfg.debug=(yyvsp[(3) - (3)].intval); }
    break;

  case 73:

/* Line 1806 of yacc.c  */
#line 850 "cfg.y"
    { yyerror("number  expected"); }
    break;

  case 74:

/* Line 1806 of yacc.c  */
#line 851 "cfg.y"
    { dont_fork= ! (yyvsp[(3) - (3)].intval); }
    break;

  case 75:

/* Line 1806 of yacc.c  */
#line 852 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 76:

/* Line 1806 of yacc.c  */
#line 853 "cfg.y"
    { set_fork_delay((yyvsp[(3) - (3)].intval)); }
    break;

  case 77:

/* Line 1806 of yacc.c  */
#line 854 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 78:

/* Line 1806 of yacc.c  */
#line 855 "cfg.y"
    { if (!config_check)  /* if set from cmd line, don't overwrite from yyparse()*/ 
					if(log_stderr == 0) log_stderr=(yyvsp[(3) - (3)].intval); 
				   }
    break;

  case 79:

/* Line 1806 of yacc.c  */
#line 858 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 80:

/* Line 1806 of yacc.c  */
#line 859 "cfg.y"
    {
		if ( (i_tmp=str2facility((yyvsp[(3) - (3)].strval)))==-1)
			yyerror("bad facility (see syslog(3) man page)");
		if (!config_check)
			default_core_cfg.log_facility=i_tmp;
	}
    break;

  case 81:

/* Line 1806 of yacc.c  */
#line 865 "cfg.y"
    { yyerror("ID expected"); }
    break;

  case 82:

/* Line 1806 of yacc.c  */
#line 866 "cfg.y"
    { log_name=(yyvsp[(3) - (3)].strval); }
    break;

  case 83:

/* Line 1806 of yacc.c  */
#line 867 "cfg.y"
    { yyerror("string value expected"); }
    break;

  case 84:

/* Line 1806 of yacc.c  */
#line 868 "cfg.y"
    { log_color=(yyvsp[(3) - (3)].intval); }
    break;

  case 85:

/* Line 1806 of yacc.c  */
#line 869 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 86:

/* Line 1806 of yacc.c  */
#line 870 "cfg.y"
    { received_dns|= ((yyvsp[(3) - (3)].intval))?DO_DNS:0; }
    break;

  case 87:

/* Line 1806 of yacc.c  */
#line 871 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 88:

/* Line 1806 of yacc.c  */
#line 872 "cfg.y"
    { received_dns|= ((yyvsp[(3) - (3)].intval))?DO_REV_DNS:0; }
    break;

  case 89:

/* Line 1806 of yacc.c  */
#line 873 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 90:

/* Line 1806 of yacc.c  */
#line 874 "cfg.y"
    { default_core_cfg.dns_try_ipv6=(yyvsp[(3) - (3)].intval); }
    break;

  case 91:

/* Line 1806 of yacc.c  */
#line 875 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 92:

/* Line 1806 of yacc.c  */
#line 876 "cfg.y"
    { IF_NAPTR(default_core_cfg.dns_try_naptr=(yyvsp[(3) - (3)].intval)); }
    break;

  case 93:

/* Line 1806 of yacc.c  */
#line 877 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 94:

/* Line 1806 of yacc.c  */
#line 878 "cfg.y"
    { IF_DNS_FAILOVER(default_core_cfg.dns_srv_lb=(yyvsp[(3) - (3)].intval)); }
    break;

  case 95:

/* Line 1806 of yacc.c  */
#line 879 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 96:

/* Line 1806 of yacc.c  */
#line 880 "cfg.y"
    { IF_NAPTR(default_core_cfg.dns_udp_pref=(yyvsp[(3) - (3)].intval));}
    break;

  case 97:

/* Line 1806 of yacc.c  */
#line 881 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 98:

/* Line 1806 of yacc.c  */
#line 882 "cfg.y"
    { IF_NAPTR(default_core_cfg.dns_tcp_pref=(yyvsp[(3) - (3)].intval));}
    break;

  case 99:

/* Line 1806 of yacc.c  */
#line 883 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 100:

/* Line 1806 of yacc.c  */
#line 884 "cfg.y"
    { IF_NAPTR(default_core_cfg.dns_tls_pref=(yyvsp[(3) - (3)].intval));}
    break;

  case 101:

/* Line 1806 of yacc.c  */
#line 885 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 102:

/* Line 1806 of yacc.c  */
#line 886 "cfg.y"
    { 
								IF_NAPTR(default_core_cfg.dns_sctp_pref=(yyvsp[(3) - (3)].intval)); }
    break;

  case 103:

/* Line 1806 of yacc.c  */
#line 888 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 104:

/* Line 1806 of yacc.c  */
#line 889 "cfg.y"
    { default_core_cfg.dns_retr_time=(yyvsp[(3) - (3)].intval); }
    break;

  case 105:

/* Line 1806 of yacc.c  */
#line 890 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 106:

/* Line 1806 of yacc.c  */
#line 891 "cfg.y"
    { default_core_cfg.dns_retr_no=(yyvsp[(3) - (3)].intval); }
    break;

  case 107:

/* Line 1806 of yacc.c  */
#line 892 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 108:

/* Line 1806 of yacc.c  */
#line 893 "cfg.y"
    { default_core_cfg.dns_servers_no=(yyvsp[(3) - (3)].intval); }
    break;

  case 109:

/* Line 1806 of yacc.c  */
#line 894 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 110:

/* Line 1806 of yacc.c  */
#line 895 "cfg.y"
    { default_core_cfg.dns_search_list=(yyvsp[(3) - (3)].intval); }
    break;

  case 111:

/* Line 1806 of yacc.c  */
#line 896 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 112:

/* Line 1806 of yacc.c  */
#line 897 "cfg.y"
    { default_core_cfg.dns_search_fmatch=(yyvsp[(3) - (3)].intval); }
    break;

  case 113:

/* Line 1806 of yacc.c  */
#line 898 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 114:

/* Line 1806 of yacc.c  */
#line 899 "cfg.y"
    { IF_DNS_CACHE(dns_cache_init=(yyvsp[(3) - (3)].intval)); }
    break;

  case 115:

/* Line 1806 of yacc.c  */
#line 900 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 116:

/* Line 1806 of yacc.c  */
#line 901 "cfg.y"
    { IF_DNS_CACHE(default_core_cfg.use_dns_cache=(yyvsp[(3) - (3)].intval)); }
    break;

  case 117:

/* Line 1806 of yacc.c  */
#line 902 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 118:

/* Line 1806 of yacc.c  */
#line 903 "cfg.y"
    { IF_DNS_FAILOVER(default_core_cfg.use_dns_failover=(yyvsp[(3) - (3)].intval));}
    break;

  case 119:

/* Line 1806 of yacc.c  */
#line 904 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 120:

/* Line 1806 of yacc.c  */
#line 905 "cfg.y"
    { IF_DNS_CACHE(default_core_cfg.dns_cache_flags=(yyvsp[(3) - (3)].intval)); }
    break;

  case 121:

/* Line 1806 of yacc.c  */
#line 906 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 122:

/* Line 1806 of yacc.c  */
#line 907 "cfg.y"
    { IF_DNS_CACHE(default_core_cfg.dns_neg_cache_ttl=(yyvsp[(3) - (3)].intval)); }
    break;

  case 123:

/* Line 1806 of yacc.c  */
#line 908 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 124:

/* Line 1806 of yacc.c  */
#line 909 "cfg.y"
    { IF_DNS_CACHE(default_core_cfg.dns_cache_max_ttl=(yyvsp[(3) - (3)].intval)); }
    break;

  case 125:

/* Line 1806 of yacc.c  */
#line 910 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 126:

/* Line 1806 of yacc.c  */
#line 911 "cfg.y"
    { IF_DNS_CACHE(default_core_cfg.dns_cache_min_ttl=(yyvsp[(3) - (3)].intval)); }
    break;

  case 127:

/* Line 1806 of yacc.c  */
#line 912 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 128:

/* Line 1806 of yacc.c  */
#line 913 "cfg.y"
    { IF_DNS_CACHE(default_core_cfg.dns_cache_max_mem=(yyvsp[(3) - (3)].intval)); }
    break;

  case 129:

/* Line 1806 of yacc.c  */
#line 914 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 130:

/* Line 1806 of yacc.c  */
#line 915 "cfg.y"
    { IF_DNS_CACHE(dns_timer_interval=(yyvsp[(3) - (3)].intval)); }
    break;

  case 131:

/* Line 1806 of yacc.c  */
#line 916 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 132:

/* Line 1806 of yacc.c  */
#line 917 "cfg.y"
    { IF_DNS_CACHE(default_core_cfg.dns_cache_del_nonexp=(yyvsp[(3) - (3)].intval)); }
    break;

  case 133:

/* Line 1806 of yacc.c  */
#line 918 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 134:

/* Line 1806 of yacc.c  */
#line 919 "cfg.y"
    {IF_AUTO_BIND_IPV6(auto_bind_ipv6 = (yyvsp[(3) - (3)].intval));}
    break;

  case 135:

/* Line 1806 of yacc.c  */
#line 920 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 136:

/* Line 1806 of yacc.c  */
#line 921 "cfg.y"
    { IF_DST_BLACKLIST(dst_blacklist_init=(yyvsp[(3) - (3)].intval)); }
    break;

  case 137:

/* Line 1806 of yacc.c  */
#line 922 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 138:

/* Line 1806 of yacc.c  */
#line 923 "cfg.y"
    {
		IF_DST_BLACKLIST(default_core_cfg.use_dst_blacklist=(yyvsp[(3) - (3)].intval));
	}
    break;

  case 139:

/* Line 1806 of yacc.c  */
#line 926 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 140:

/* Line 1806 of yacc.c  */
#line 927 "cfg.y"
    {
		IF_DST_BLACKLIST(default_core_cfg.blst_max_mem=(yyvsp[(3) - (3)].intval)); 
	}
    break;

  case 141:

/* Line 1806 of yacc.c  */
#line 930 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 142:

/* Line 1806 of yacc.c  */
#line 931 "cfg.y"
    {
		IF_DST_BLACKLIST(default_core_cfg.blst_timeout=(yyvsp[(3) - (3)].intval));
	}
    break;

  case 143:

/* Line 1806 of yacc.c  */
#line 934 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 144:

/* Line 1806 of yacc.c  */
#line 935 "cfg.y"
    { IF_DST_BLACKLIST(blst_timer_interval=(yyvsp[(3) - (3)].intval));}
    break;

  case 145:

/* Line 1806 of yacc.c  */
#line 936 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 146:

/* Line 1806 of yacc.c  */
#line 937 "cfg.y"
    {
		IF_DST_BLACKLIST(default_core_cfg.blst_udp_imask=(yyvsp[(3) - (3)].intval));
	}
    break;

  case 147:

/* Line 1806 of yacc.c  */
#line 940 "cfg.y"
    { yyerror("number(flags) expected"); }
    break;

  case 148:

/* Line 1806 of yacc.c  */
#line 941 "cfg.y"
    {
		IF_DST_BLACKLIST(default_core_cfg.blst_tcp_imask=(yyvsp[(3) - (3)].intval));
	}
    break;

  case 149:

/* Line 1806 of yacc.c  */
#line 944 "cfg.y"
    { yyerror("number(flags) expected"); }
    break;

  case 150:

/* Line 1806 of yacc.c  */
#line 945 "cfg.y"
    {
		IF_DST_BLACKLIST(default_core_cfg.blst_tls_imask=(yyvsp[(3) - (3)].intval));
	}
    break;

  case 151:

/* Line 1806 of yacc.c  */
#line 948 "cfg.y"
    { yyerror("number(flags) expected"); }
    break;

  case 152:

/* Line 1806 of yacc.c  */
#line 949 "cfg.y"
    {
		IF_DST_BLACKLIST(default_core_cfg.blst_sctp_imask=(yyvsp[(3) - (3)].intval));
	}
    break;

  case 153:

/* Line 1806 of yacc.c  */
#line 952 "cfg.y"
    { yyerror("number(flags) expected"); }
    break;

  case 154:

/* Line 1806 of yacc.c  */
#line 953 "cfg.y"
    { port_no=(yyvsp[(3) - (3)].intval); }
    break;

  case 155:

/* Line 1806 of yacc.c  */
#line 954 "cfg.y"
    {
		#ifdef STATS
				stat_file=(yyvsp[(3) - (3)].strval);
		#endif
	}
    break;

  case 156:

/* Line 1806 of yacc.c  */
#line 959 "cfg.y"
    { maxbuffer=(yyvsp[(3) - (3)].intval); }
    break;

  case 157:

/* Line 1806 of yacc.c  */
#line 960 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 158:

/* Line 1806 of yacc.c  */
#line 961 "cfg.y"
    { sql_buffer_size=(yyvsp[(3) - (3)].intval); }
    break;

  case 159:

/* Line 1806 of yacc.c  */
#line 962 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 160:

/* Line 1806 of yacc.c  */
#line 963 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 161:

/* Line 1806 of yacc.c  */
#line 964 "cfg.y"
    { children_no=(yyvsp[(3) - (3)].intval); }
    break;

  case 162:

/* Line 1806 of yacc.c  */
#line 965 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 163:

/* Line 1806 of yacc.c  */
#line 966 "cfg.y"
    { socket_workers=(yyvsp[(3) - (3)].intval); }
    break;

  case 164:

/* Line 1806 of yacc.c  */
#line 967 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 165:

/* Line 1806 of yacc.c  */
#line 968 "cfg.y"
    { check_via=(yyvsp[(3) - (3)].intval); }
    break;

  case 166:

/* Line 1806 of yacc.c  */
#line 969 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 167:

/* Line 1806 of yacc.c  */
#line 970 "cfg.y"
    { phone2tel=(yyvsp[(3) - (3)].intval); }
    break;

  case 168:

/* Line 1806 of yacc.c  */
#line 971 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 169:

/* Line 1806 of yacc.c  */
#line 972 "cfg.y"
    { syn_branch=(yyvsp[(3) - (3)].intval); }
    break;

  case 170:

/* Line 1806 of yacc.c  */
#line 973 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 171:

/* Line 1806 of yacc.c  */
#line 974 "cfg.y"
    { default_core_cfg.memlog=(yyvsp[(3) - (3)].intval); }
    break;

  case 172:

/* Line 1806 of yacc.c  */
#line 975 "cfg.y"
    { yyerror("int value expected"); }
    break;

  case 173:

/* Line 1806 of yacc.c  */
#line 976 "cfg.y"
    { default_core_cfg.memdbg=(yyvsp[(3) - (3)].intval); }
    break;

  case 174:

/* Line 1806 of yacc.c  */
#line 977 "cfg.y"
    { yyerror("int value expected"); }
    break;

  case 175:

/* Line 1806 of yacc.c  */
#line 978 "cfg.y"
    { default_core_cfg.mem_summary=(yyvsp[(3) - (3)].intval); }
    break;

  case 176:

/* Line 1806 of yacc.c  */
#line 979 "cfg.y"
    { yyerror("int value expected"); }
    break;

  case 177:

/* Line 1806 of yacc.c  */
#line 980 "cfg.y"
    { default_core_cfg.mem_safety=(yyvsp[(3) - (3)].intval); }
    break;

  case 178:

/* Line 1806 of yacc.c  */
#line 981 "cfg.y"
    { yyerror("int value expected"); }
    break;

  case 179:

/* Line 1806 of yacc.c  */
#line 982 "cfg.y"
    { default_core_cfg.mem_join=(yyvsp[(3) - (3)].intval); }
    break;

  case 180:

/* Line 1806 of yacc.c  */
#line 983 "cfg.y"
    { yyerror("int value expected"); }
    break;

  case 181:

/* Line 1806 of yacc.c  */
#line 984 "cfg.y"
    { default_core_cfg.corelog=(yyvsp[(3) - (3)].intval); }
    break;

  case 182:

/* Line 1806 of yacc.c  */
#line 985 "cfg.y"
    { yyerror("int value expected"); }
    break;

  case 183:

/* Line 1806 of yacc.c  */
#line 986 "cfg.y"
    { sip_warning=(yyvsp[(3) - (3)].intval); }
    break;

  case 184:

/* Line 1806 of yacc.c  */
#line 987 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 185:

/* Line 1806 of yacc.c  */
#line 988 "cfg.y"
    { version_table.s=(yyvsp[(3) - (3)].strval);
			version_table.len=strlen(version_table.s);
	}
    break;

  case 186:

/* Line 1806 of yacc.c  */
#line 991 "cfg.y"
    { yyerror("string value expected"); }
    break;

  case 187:

/* Line 1806 of yacc.c  */
#line 992 "cfg.y"
    {
		if (shm_initialized())
			yyerror("user must be before any modparam or the"
					" route blocks");
		else if (user==0)
			user=(yyvsp[(3) - (3)].strval); 
	}
    break;

  case 188:

/* Line 1806 of yacc.c  */
#line 999 "cfg.y"
    {
		if (shm_initialized())
			yyerror("user must be before any modparam or the"
					" route blocks");
		else if (user==0)
			user=(yyvsp[(3) - (3)].strval);
	}
    break;

  case 189:

/* Line 1806 of yacc.c  */
#line 1006 "cfg.y"
    { yyerror("string value expected"); }
    break;

  case 190:

/* Line 1806 of yacc.c  */
#line 1007 "cfg.y"
    { group=(yyvsp[(3) - (3)].strval); }
    break;

  case 191:

/* Line 1806 of yacc.c  */
#line 1008 "cfg.y"
    { group=(yyvsp[(3) - (3)].strval); }
    break;

  case 192:

/* Line 1806 of yacc.c  */
#line 1009 "cfg.y"
    { yyerror("string value expected"); }
    break;

  case 193:

/* Line 1806 of yacc.c  */
#line 1010 "cfg.y"
    { chroot_dir=(yyvsp[(3) - (3)].strval); }
    break;

  case 194:

/* Line 1806 of yacc.c  */
#line 1011 "cfg.y"
    { chroot_dir=(yyvsp[(3) - (3)].strval); }
    break;

  case 195:

/* Line 1806 of yacc.c  */
#line 1012 "cfg.y"
    { yyerror("string value expected"); }
    break;

  case 196:

/* Line 1806 of yacc.c  */
#line 1013 "cfg.y"
    { working_dir=(yyvsp[(3) - (3)].strval); }
    break;

  case 197:

/* Line 1806 of yacc.c  */
#line 1014 "cfg.y"
    { working_dir=(yyvsp[(3) - (3)].strval); }
    break;

  case 198:

/* Line 1806 of yacc.c  */
#line 1015 "cfg.y"
    { yyerror("string value expected"); }
    break;

  case 199:

/* Line 1806 of yacc.c  */
#line 1016 "cfg.y"
    { mhomed=(yyvsp[(3) - (3)].intval); }
    break;

  case 200:

/* Line 1806 of yacc.c  */
#line 1017 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 201:

/* Line 1806 of yacc.c  */
#line 1018 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_disable=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
    break;

  case 202:

/* Line 1806 of yacc.c  */
#line 1025 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 203:

/* Line 1806 of yacc.c  */
#line 1026 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.accept_aliases=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
    break;

  case 204:

/* Line 1806 of yacc.c  */
#line 1033 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 205:

/* Line 1806 of yacc.c  */
#line 1034 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_cfg_children_no=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
    break;

  case 206:

/* Line 1806 of yacc.c  */
#line 1041 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 207:

/* Line 1806 of yacc.c  */
#line 1042 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.connect_timeout_s=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
    break;

  case 208:

/* Line 1806 of yacc.c  */
#line 1049 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 209:

/* Line 1806 of yacc.c  */
#line 1050 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.send_timeout=S_TO_TICKS((yyvsp[(3) - (3)].intval));
		#else
			warn("tcp support not compiled in");
		#endif
	}
    break;

  case 210:

/* Line 1806 of yacc.c  */
#line 1057 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 211:

/* Line 1806 of yacc.c  */
#line 1058 "cfg.y"
    {
		#ifdef USE_TCP
			if ((yyvsp[(3) - (3)].intval)<0)
				tcp_default_cfg.con_lifetime=-1;
			else
				tcp_default_cfg.con_lifetime=S_TO_TICKS((yyvsp[(3) - (3)].intval));
		#else
			warn("tcp support not compiled in");
		#endif
	}
    break;

  case 212:

/* Line 1806 of yacc.c  */
#line 1068 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 213:

/* Line 1806 of yacc.c  */
#line 1069 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_poll_method=get_poll_type((yyvsp[(3) - (3)].strval));
			if (tcp_poll_method==POLL_NONE) {
				LOG(L_CRIT, "bad poll method name:"
						" %s\n, try one of %s.\n",
						(yyvsp[(3) - (3)].strval), poll_support);
				yyerror("bad tcp_poll_method "
						"value");
			}
		#else
			warn("tcp support not compiled in");
		#endif
	}
    break;

  case 214:

/* Line 1806 of yacc.c  */
#line 1083 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_poll_method=get_poll_type((yyvsp[(3) - (3)].strval));
			if (tcp_poll_method==POLL_NONE) {
				LOG(L_CRIT, "bad poll method name:"
						" %s\n, try one of %s.\n",
						(yyvsp[(3) - (3)].strval), poll_support);
				yyerror("bad tcp_poll_method "
						"value");
			}
		#else
			warn("tcp support not compiled in");
		#endif
	}
    break;

  case 215:

/* Line 1806 of yacc.c  */
#line 1097 "cfg.y"
    { yyerror("poll method name expected"); }
    break;

  case 216:

/* Line 1806 of yacc.c  */
#line 1098 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_max_connections=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
    break;

  case 217:

/* Line 1806 of yacc.c  */
#line 1105 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 218:

/* Line 1806 of yacc.c  */
#line 1106 "cfg.y"
    {
		#ifdef USE_TLS
			tls_max_connections=(yyvsp[(3) - (3)].intval);
		#else
			warn("tls support not compiled in");
		#endif
	}
    break;

  case 219:

/* Line 1806 of yacc.c  */
#line 1113 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 220:

/* Line 1806 of yacc.c  */
#line 1114 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.no_connect=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
    break;

  case 221:

/* Line 1806 of yacc.c  */
#line 1121 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 222:

/* Line 1806 of yacc.c  */
#line 1122 "cfg.y"
    {
		#ifdef USE_TCP
			if (tcp_set_src_addr((yyvsp[(3) - (3)].ipaddr))<0)
				warn("tcp_source_ipv4 failed");
		#else
			warn("tcp support not compiled in");
		#endif
		pkg_free((yyvsp[(3) - (3)].ipaddr));
	}
    break;

  case 223:

/* Line 1806 of yacc.c  */
#line 1131 "cfg.y"
    { yyerror("IPv4 address expected"); }
    break;

  case 224:

/* Line 1806 of yacc.c  */
#line 1132 "cfg.y"
    {
		#ifdef USE_TCP
			#ifdef USE_IPV6
				if (tcp_set_src_addr((yyvsp[(3) - (3)].ipaddr))<0)
					warn("tcp_source_ipv6 failed");
			#else
				warn("IPv6 support not compiled in");
			#endif
		#else
			warn("tcp support not compiled in");
		#endif
		pkg_free((yyvsp[(3) - (3)].ipaddr));
	}
    break;

  case 225:

/* Line 1806 of yacc.c  */
#line 1145 "cfg.y"
    { yyerror("IPv6 address expected"); }
    break;

  case 226:

/* Line 1806 of yacc.c  */
#line 1146 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.fd_cache=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
    break;

  case 227:

/* Line 1806 of yacc.c  */
#line 1153 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 228:

/* Line 1806 of yacc.c  */
#line 1154 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.async=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
    break;

  case 229:

/* Line 1806 of yacc.c  */
#line 1161 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 230:

/* Line 1806 of yacc.c  */
#line 1162 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.tcpconn_wq_max=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
    break;

  case 231:

/* Line 1806 of yacc.c  */
#line 1169 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 232:

/* Line 1806 of yacc.c  */
#line 1170 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.tcp_wq_max=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
    break;

  case 233:

/* Line 1806 of yacc.c  */
#line 1177 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 234:

/* Line 1806 of yacc.c  */
#line 1178 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.rd_buf_size=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
    break;

  case 235:

/* Line 1806 of yacc.c  */
#line 1185 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 236:

/* Line 1806 of yacc.c  */
#line 1186 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.wq_blk_size=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
    break;

  case 237:

/* Line 1806 of yacc.c  */
#line 1193 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 238:

/* Line 1806 of yacc.c  */
#line 1194 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.defer_accept=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
    break;

  case 239:

/* Line 1806 of yacc.c  */
#line 1201 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 240:

/* Line 1806 of yacc.c  */
#line 1202 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.delayed_ack=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
    break;

  case 241:

/* Line 1806 of yacc.c  */
#line 1209 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 242:

/* Line 1806 of yacc.c  */
#line 1210 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.syncnt=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
    break;

  case 243:

/* Line 1806 of yacc.c  */
#line 1217 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 244:

/* Line 1806 of yacc.c  */
#line 1218 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.linger2=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
    break;

  case 245:

/* Line 1806 of yacc.c  */
#line 1225 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 246:

/* Line 1806 of yacc.c  */
#line 1226 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.keepalive=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
    break;

  case 247:

/* Line 1806 of yacc.c  */
#line 1233 "cfg.y"
    { yyerror("boolean value expected");}
    break;

  case 248:

/* Line 1806 of yacc.c  */
#line 1234 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.keepidle=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
    break;

  case 249:

/* Line 1806 of yacc.c  */
#line 1241 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 250:

/* Line 1806 of yacc.c  */
#line 1242 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.keepintvl=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
    break;

  case 251:

/* Line 1806 of yacc.c  */
#line 1249 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 252:

/* Line 1806 of yacc.c  */
#line 1250 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.keepcnt=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
    break;

  case 253:

/* Line 1806 of yacc.c  */
#line 1257 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 254:

/* Line 1806 of yacc.c  */
#line 1258 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.crlf_ping=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
    break;

  case 255:

/* Line 1806 of yacc.c  */
#line 1265 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 256:

/* Line 1806 of yacc.c  */
#line 1266 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_default_cfg.accept_no_cl=(yyvsp[(3) - (3)].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
    break;

  case 257:

/* Line 1806 of yacc.c  */
#line 1273 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 258:

/* Line 1806 of yacc.c  */
#line 1274 "cfg.y"
    {
		#ifdef USE_TCP
			tcp_set_clone_rcvbuf((yyvsp[(3) - (3)].intval));
		#else
			warn("tcp support not compiled in");
		#endif
	}
    break;

  case 259:

/* Line 1806 of yacc.c  */
#line 1281 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 260:

/* Line 1806 of yacc.c  */
#line 1282 "cfg.y"
    {
		#ifdef USE_TLS
			tls_disable=(yyvsp[(3) - (3)].intval);
		#else
			warn("tls support not compiled in");
		#endif
	}
    break;

  case 261:

/* Line 1806 of yacc.c  */
#line 1289 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 262:

/* Line 1806 of yacc.c  */
#line 1290 "cfg.y"
    {
		#ifdef USE_TLS
			tls_disable=!((yyvsp[(3) - (3)].intval));
		#else
			warn("tls support not compiled in");
		#endif
	}
    break;

  case 263:

/* Line 1806 of yacc.c  */
#line 1297 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 264:

/* Line 1806 of yacc.c  */
#line 1298 "cfg.y"
    {
		#ifdef CORE_TLS
			tls_log=(yyvsp[(3) - (3)].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
    break;

  case 265:

/* Line 1806 of yacc.c  */
#line 1305 "cfg.y"
    { yyerror("int value expected"); }
    break;

  case 266:

/* Line 1806 of yacc.c  */
#line 1306 "cfg.y"
    {
		#ifdef USE_TLS
			tls_port_no=(yyvsp[(3) - (3)].intval);
		#else
			warn("tls support not compiled in");
		#endif
	}
    break;

  case 267:

/* Line 1806 of yacc.c  */
#line 1313 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 268:

/* Line 1806 of yacc.c  */
#line 1314 "cfg.y"
    {
		#ifdef CORE_TLS
			tls_method=TLS_USE_SSLv23;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
    break;

  case 269:

/* Line 1806 of yacc.c  */
#line 1321 "cfg.y"
    {
		#ifdef CORE_TLS
			tls_method=TLS_USE_SSLv2;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
    break;

  case 270:

/* Line 1806 of yacc.c  */
#line 1328 "cfg.y"
    {
		#ifdef CORE_TLS
			tls_method=TLS_USE_SSLv3;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
    break;

  case 271:

/* Line 1806 of yacc.c  */
#line 1335 "cfg.y"
    {
		#ifdef CORE_TLS
			tls_method=TLS_USE_TLSv1;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
    break;

  case 272:

/* Line 1806 of yacc.c  */
#line 1342 "cfg.y"
    {
		#ifdef CORE_TLS
			yyerror("SSLv23, SSLv2, SSLv3 or TLSv1 expected");
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
    break;

  case 273:

/* Line 1806 of yacc.c  */
#line 1349 "cfg.y"
    {
		#ifdef CORE_TLS
			tls_verify_cert=(yyvsp[(3) - (3)].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
    break;

  case 274:

/* Line 1806 of yacc.c  */
#line 1356 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 275:

/* Line 1806 of yacc.c  */
#line 1357 "cfg.y"
    {
		#ifdef CORE_TLS
			tls_require_cert=(yyvsp[(3) - (3)].intval);
		#else
			warn( "tls-in-core support not compiled in");
		#endif
	}
    break;

  case 276:

/* Line 1806 of yacc.c  */
#line 1364 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 277:

/* Line 1806 of yacc.c  */
#line 1365 "cfg.y"
    {
		#ifdef CORE_TLS
			tls_cert_file=(yyvsp[(3) - (3)].strval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
    break;

  case 278:

/* Line 1806 of yacc.c  */
#line 1372 "cfg.y"
    { yyerror("string value expected"); }
    break;

  case 279:

/* Line 1806 of yacc.c  */
#line 1373 "cfg.y"
    {
		#ifdef CORE_TLS
			tls_pkey_file=(yyvsp[(3) - (3)].strval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
    break;

  case 280:

/* Line 1806 of yacc.c  */
#line 1380 "cfg.y"
    { yyerror("string value expected"); }
    break;

  case 281:

/* Line 1806 of yacc.c  */
#line 1381 "cfg.y"
    {
		#ifdef CORE_TLS
			tls_ca_file=(yyvsp[(3) - (3)].strval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
    break;

  case 282:

/* Line 1806 of yacc.c  */
#line 1388 "cfg.y"
    { yyerror("string value expected"); }
    break;

  case 283:

/* Line 1806 of yacc.c  */
#line 1389 "cfg.y"
    {
		#ifdef CORE_TLS
			tls_handshake_timeout=(yyvsp[(3) - (3)].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
    break;

  case 284:

/* Line 1806 of yacc.c  */
#line 1396 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 285:

/* Line 1806 of yacc.c  */
#line 1397 "cfg.y"
    {
		#ifdef CORE_TLS
			tls_send_timeout=(yyvsp[(3) - (3)].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
    break;

  case 286:

/* Line 1806 of yacc.c  */
#line 1404 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 287:

/* Line 1806 of yacc.c  */
#line 1405 "cfg.y"
    {
		#ifdef USE_SCTP
			sctp_disable=(yyvsp[(3) - (3)].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	}
    break;

  case 288:

/* Line 1806 of yacc.c  */
#line 1412 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 289:

/* Line 1806 of yacc.c  */
#line 1413 "cfg.y"
    {
		#ifdef USE_SCTP
			sctp_disable=((yyvsp[(3) - (3)].intval)<=1)?!(yyvsp[(3) - (3)].intval):(yyvsp[(3) - (3)].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	}
    break;

  case 290:

/* Line 1806 of yacc.c  */
#line 1420 "cfg.y"
    { yyerror("boolean or number expected"); }
    break;

  case 291:

/* Line 1806 of yacc.c  */
#line 1421 "cfg.y"
    {
		#ifdef USE_SCTP
			sctp_children_no=(yyvsp[(3) - (3)].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	}
    break;

  case 292:

/* Line 1806 of yacc.c  */
#line 1428 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 293:

/* Line 1806 of yacc.c  */
#line 1429 "cfg.y"
    {
		#ifdef USE_SCTP
			sctp_default_cfg.so_rcvbuf=(yyvsp[(3) - (3)].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	}
    break;

  case 294:

/* Line 1806 of yacc.c  */
#line 1436 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 295:

/* Line 1806 of yacc.c  */
#line 1437 "cfg.y"
    {
		#ifdef USE_SCTP
			sctp_default_cfg.so_sndbuf=(yyvsp[(3) - (3)].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	}
    break;

  case 296:

/* Line 1806 of yacc.c  */
#line 1444 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 297:

/* Line 1806 of yacc.c  */
#line 1445 "cfg.y"
    {
		#ifdef USE_SCTP
			sctp_default_cfg.autoclose=(yyvsp[(3) - (3)].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	}
    break;

  case 298:

/* Line 1806 of yacc.c  */
#line 1452 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 299:

/* Line 1806 of yacc.c  */
#line 1453 "cfg.y"
    {
		#ifdef USE_SCTP
			sctp_default_cfg.send_ttl=(yyvsp[(3) - (3)].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	}
    break;

  case 300:

/* Line 1806 of yacc.c  */
#line 1460 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 301:

/* Line 1806 of yacc.c  */
#line 1461 "cfg.y"
    {
		#ifdef USE_SCTP
			sctp_default_cfg.send_retries=(yyvsp[(3) - (3)].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	}
    break;

  case 302:

/* Line 1806 of yacc.c  */
#line 1468 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 303:

/* Line 1806 of yacc.c  */
#line 1469 "cfg.y"
    {
		#ifdef USE_SCTP
			#ifdef SCTP_CONN_REUSE
				sctp_default_cfg.assoc_tracking=(yyvsp[(3) - (3)].intval);
			#else
				if ((yyvsp[(3) - (3)].intval))
					warn("sctp association tracking/reuse (SCTP_CONN_REUSE) "
							"support not compiled in");
			#endif /* SCTP_CONN_REUSE */
		#else
			warn("sctp support not compiled in");
		#endif /* USE_SCTP */
	}
    break;

  case 304:

/* Line 1806 of yacc.c  */
#line 1482 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 305:

/* Line 1806 of yacc.c  */
#line 1483 "cfg.y"
    {
		#ifdef USE_SCTP
			#ifdef SCTP_CONN_REUSE
				sctp_default_cfg.assoc_reuse=(yyvsp[(3) - (3)].intval);
			#else
				if ((yyvsp[(3) - (3)].intval))
					warn("sctp association reuse (SCTP_CONN_REUSE) support"
							" not compiled in");
			#endif /* SCTP_CONN_REUSE */
		#else
			warn("sctp support not compiled in");
		#endif /* USE_SCTP */
	}
    break;

  case 306:

/* Line 1806 of yacc.c  */
#line 1496 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 307:

/* Line 1806 of yacc.c  */
#line 1497 "cfg.y"
    {
			IF_SCTP(sctp_default_cfg.max_assocs=(yyvsp[(3) - (3)].intval));
	}
    break;

  case 308:

/* Line 1806 of yacc.c  */
#line 1500 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 309:

/* Line 1806 of yacc.c  */
#line 1501 "cfg.y"
    {
			IF_SCTP(sctp_default_cfg.srto_initial=(yyvsp[(3) - (3)].intval));
	}
    break;

  case 310:

/* Line 1806 of yacc.c  */
#line 1504 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 311:

/* Line 1806 of yacc.c  */
#line 1505 "cfg.y"
    {
			IF_SCTP(sctp_default_cfg.srto_max=(yyvsp[(3) - (3)].intval));
	}
    break;

  case 312:

/* Line 1806 of yacc.c  */
#line 1508 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 313:

/* Line 1806 of yacc.c  */
#line 1509 "cfg.y"
    {
			IF_SCTP(sctp_default_cfg.srto_min=(yyvsp[(3) - (3)].intval));
	}
    break;

  case 314:

/* Line 1806 of yacc.c  */
#line 1512 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 315:

/* Line 1806 of yacc.c  */
#line 1513 "cfg.y"
    {
			IF_SCTP(sctp_default_cfg.asocmaxrxt=(yyvsp[(3) - (3)].intval));
	}
    break;

  case 316:

/* Line 1806 of yacc.c  */
#line 1516 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 317:

/* Line 1806 of yacc.c  */
#line 1517 "cfg.y"
    {
			IF_SCTP(sctp_default_cfg.init_max_attempts=(yyvsp[(3) - (3)].intval));
	}
    break;

  case 318:

/* Line 1806 of yacc.c  */
#line 1520 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 319:

/* Line 1806 of yacc.c  */
#line 1521 "cfg.y"
    {
			IF_SCTP(sctp_default_cfg.init_max_timeo=(yyvsp[(3) - (3)].intval));
	}
    break;

  case 320:

/* Line 1806 of yacc.c  */
#line 1524 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 321:

/* Line 1806 of yacc.c  */
#line 1525 "cfg.y"
    {
			IF_SCTP(sctp_default_cfg.hbinterval=(yyvsp[(3) - (3)].intval));
	}
    break;

  case 322:

/* Line 1806 of yacc.c  */
#line 1528 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 323:

/* Line 1806 of yacc.c  */
#line 1529 "cfg.y"
    {
			IF_SCTP(sctp_default_cfg.pathmaxrxt=(yyvsp[(3) - (3)].intval));
	}
    break;

  case 324:

/* Line 1806 of yacc.c  */
#line 1532 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 325:

/* Line 1806 of yacc.c  */
#line 1533 "cfg.y"
    {
			IF_SCTP(sctp_default_cfg.sack_delay=(yyvsp[(3) - (3)].intval));
	}
    break;

  case 326:

/* Line 1806 of yacc.c  */
#line 1536 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 327:

/* Line 1806 of yacc.c  */
#line 1537 "cfg.y"
    {
			IF_SCTP(sctp_default_cfg.sack_freq=(yyvsp[(3) - (3)].intval));
	}
    break;

  case 328:

/* Line 1806 of yacc.c  */
#line 1540 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 329:

/* Line 1806 of yacc.c  */
#line 1541 "cfg.y"
    {
			IF_SCTP(sctp_default_cfg.max_burst=(yyvsp[(3) - (3)].intval));
	}
    break;

  case 330:

/* Line 1806 of yacc.c  */
#line 1544 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 331:

/* Line 1806 of yacc.c  */
#line 1545 "cfg.y"
    { server_signature=(yyvsp[(3) - (3)].intval); }
    break;

  case 332:

/* Line 1806 of yacc.c  */
#line 1546 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 333:

/* Line 1806 of yacc.c  */
#line 1547 "cfg.y"
    { server_hdr.s=(yyvsp[(3) - (3)].strval);
			server_hdr.len=strlen(server_hdr.s);
	}
    break;

  case 334:

/* Line 1806 of yacc.c  */
#line 1550 "cfg.y"
    { yyerror("string value expected"); }
    break;

  case 335:

/* Line 1806 of yacc.c  */
#line 1551 "cfg.y"
    { user_agent_hdr.s=(yyvsp[(3) - (3)].strval);
			user_agent_hdr.len=strlen(user_agent_hdr.s);
	}
    break;

  case 336:

/* Line 1806 of yacc.c  */
#line 1554 "cfg.y"
    { yyerror("string value expected"); }
    break;

  case 337:

/* Line 1806 of yacc.c  */
#line 1555 "cfg.y"
    { reply_to_via=(yyvsp[(3) - (3)].intval); }
    break;

  case 338:

/* Line 1806 of yacc.c  */
#line 1556 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 339:

/* Line 1806 of yacc.c  */
#line 1557 "cfg.y"
    {
		for(lst_tmp=(yyvsp[(3) - (3)].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_iface(	lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									lst_tmp->flags)!=0) {
				LOG(L_CRIT,  "ERROR: cfg. parser: failed to add listen"
								" address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[(3) - (3)].sockid));
	}
    break;

  case 340:

/* Line 1806 of yacc.c  */
#line 1570 "cfg.y"
    {
		for(lst_tmp=(yyvsp[(3) - (7)].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_advertise_iface(	lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									(yyvsp[(5) - (7)].strval), (yyvsp[(7) - (7)].intval),
									lst_tmp->flags)!=0) {
				LOG(L_CRIT,  "ERROR: cfg. parser: failed to add listen"
								" address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[(3) - (7)].sockid));
	}
    break;

  case 341:

/* Line 1806 of yacc.c  */
#line 1584 "cfg.y"
    { yyerror("ip address, interface name or"
									" hostname expected"); }
    break;

  case 342:

/* Line 1806 of yacc.c  */
#line 1586 "cfg.y"
    {
		for(lst_tmp=(yyvsp[(3) - (3)].sockid); lst_tmp; lst_tmp=lst_tmp->next){
			add_alias(	lst_tmp->addr_lst->name,
						strlen(lst_tmp->addr_lst->name),
						lst_tmp->port, lst_tmp->proto);
			for (nl_tmp=lst_tmp->addr_lst->next; nl_tmp; nl_tmp=nl_tmp->next)
				add_alias(nl_tmp->name, strlen(nl_tmp->name),
							lst_tmp->port, lst_tmp->proto);
		}
		free_socket_id_lst((yyvsp[(3) - (3)].sockid));
	}
    break;

  case 343:

/* Line 1806 of yacc.c  */
#line 1597 "cfg.y"
    { yyerror(" hostname expected"); }
    break;

  case 344:

/* Line 1806 of yacc.c  */
#line 1598 "cfg.y"
    { sr_auto_aliases=(yyvsp[(3) - (3)].intval); }
    break;

  case 345:

/* Line 1806 of yacc.c  */
#line 1599 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 346:

/* Line 1806 of yacc.c  */
#line 1600 "cfg.y"
    {
		if ((yyvsp[(3) - (3)].strval)){
			default_global_address.s=(yyvsp[(3) - (3)].strval);
			default_global_address.len=strlen((yyvsp[(3) - (3)].strval));
		}
	}
    break;

  case 347:

/* Line 1806 of yacc.c  */
#line 1606 "cfg.y"
    {yyerror("ip address or hostname expected"); }
    break;

  case 348:

/* Line 1806 of yacc.c  */
#line 1607 "cfg.y"
    {
		tmp=int2str((yyvsp[(3) - (3)].intval), &i_tmp);
		if ((default_global_port.s=pkg_malloc(i_tmp))==0) {
			LOG(L_CRIT, "ERROR: cfg. parser: out of memory.\n");
			default_global_port.len=0;
		} else {
			default_global_port.len=i_tmp;
			memcpy(default_global_port.s, tmp, default_global_port.len);
		};
	}
    break;

  case 349:

/* Line 1806 of yacc.c  */
#line 1617 "cfg.y"
    {yyerror("ip address or hostname expected"); }
    break;

  case 350:

/* Line 1806 of yacc.c  */
#line 1618 "cfg.y"
    { disable_core_dump=(yyvsp[(3) - (3)].intval); }
    break;

  case 351:

/* Line 1806 of yacc.c  */
#line 1619 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 352:

/* Line 1806 of yacc.c  */
#line 1620 "cfg.y"
    { open_files_limit=(yyvsp[(3) - (3)].intval); }
    break;

  case 353:

/* Line 1806 of yacc.c  */
#line 1621 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 354:

/* Line 1806 of yacc.c  */
#line 1622 "cfg.y"
    {
		if (shm_initialized())
			yyerror("shm/shm_mem_size must be before any modparam or the"
					" route blocks");
		else if (shm_mem_size == 0)
			shm_mem_size=(yyvsp[(3) - (3)].intval) * 1024 * 1024;
	}
    break;

  case 355:

/* Line 1806 of yacc.c  */
#line 1629 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 356:

/* Line 1806 of yacc.c  */
#line 1630 "cfg.y"
    {
		if (shm_initialized())
			yyerror("shm_force_alloc must be before any modparam or the"
					" route blocks");
		else
			shm_force_alloc=(yyvsp[(3) - (3)].intval);
	}
    break;

  case 357:

/* Line 1806 of yacc.c  */
#line 1637 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 358:

/* Line 1806 of yacc.c  */
#line 1638 "cfg.y"
    { mlock_pages=(yyvsp[(3) - (3)].intval); }
    break;

  case 359:

/* Line 1806 of yacc.c  */
#line 1639 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 360:

/* Line 1806 of yacc.c  */
#line 1640 "cfg.y"
    { real_time=(yyvsp[(3) - (3)].intval); }
    break;

  case 361:

/* Line 1806 of yacc.c  */
#line 1641 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 362:

/* Line 1806 of yacc.c  */
#line 1642 "cfg.y"
    { rt_prio=(yyvsp[(3) - (3)].intval); }
    break;

  case 363:

/* Line 1806 of yacc.c  */
#line 1643 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 364:

/* Line 1806 of yacc.c  */
#line 1644 "cfg.y"
    { rt_policy=(yyvsp[(3) - (3)].intval); }
    break;

  case 365:

/* Line 1806 of yacc.c  */
#line 1645 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 366:

/* Line 1806 of yacc.c  */
#line 1646 "cfg.y"
    { rt_timer1_prio=(yyvsp[(3) - (3)].intval); }
    break;

  case 367:

/* Line 1806 of yacc.c  */
#line 1647 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 368:

/* Line 1806 of yacc.c  */
#line 1648 "cfg.y"
    { rt_timer1_policy=(yyvsp[(3) - (3)].intval); }
    break;

  case 369:

/* Line 1806 of yacc.c  */
#line 1649 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 370:

/* Line 1806 of yacc.c  */
#line 1650 "cfg.y"
    { rt_timer2_prio=(yyvsp[(3) - (3)].intval); }
    break;

  case 371:

/* Line 1806 of yacc.c  */
#line 1651 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 372:

/* Line 1806 of yacc.c  */
#line 1652 "cfg.y"
    { rt_timer2_policy=(yyvsp[(3) - (3)].intval); }
    break;

  case 373:

/* Line 1806 of yacc.c  */
#line 1653 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 374:

/* Line 1806 of yacc.c  */
#line 1654 "cfg.y"
    {
		#ifdef USE_MCAST
			mcast_loopback=(yyvsp[(3) - (3)].intval);
		#else
			warn("no multicast support compiled in");
		#endif
	}
    break;

  case 375:

/* Line 1806 of yacc.c  */
#line 1661 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 376:

/* Line 1806 of yacc.c  */
#line 1662 "cfg.y"
    {
		#ifdef USE_MCAST
			mcast_ttl=(yyvsp[(3) - (3)].intval);
		#else
			warn("no multicast support compiled in");
		#endif
	}
    break;

  case 377:

/* Line 1806 of yacc.c  */
#line 1669 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 378:

/* Line 1806 of yacc.c  */
#line 1670 "cfg.y"
    { tos=(yyvsp[(3) - (3)].intval); }
    break;

  case 379:

/* Line 1806 of yacc.c  */
#line 1671 "cfg.y"
    { if (strcasecmp((yyvsp[(3) - (3)].strval),"IPTOS_LOWDELAY")) {
			tos=IPTOS_LOWDELAY;
		} else if (strcasecmp((yyvsp[(3) - (3)].strval),"IPTOS_THROUGHPUT")) {
			tos=IPTOS_THROUGHPUT;
		} else if (strcasecmp((yyvsp[(3) - (3)].strval),"IPTOS_RELIABILITY")) {
			tos=IPTOS_RELIABILITY;
#if defined(IPTOS_MINCOST)
		} else if (strcasecmp((yyvsp[(3) - (3)].strval),"IPTOS_MINCOST")) {
			tos=IPTOS_MINCOST;
#endif
#if defined(IPTOS_LOWCOST)
		} else if (strcasecmp((yyvsp[(3) - (3)].strval),"IPTOS_LOWCOST")) {
			tos=IPTOS_LOWCOST;
#endif
		} else {
			yyerror("invalid tos value - allowed: "
				"IPTOS_LOWDELAY,IPTOS_THROUGHPUT,"
				"IPTOS_RELIABILITY"
#if defined(IPTOS_LOWCOST)
				",IPTOS_LOWCOST"
#endif
#if !defined(IPTOS_MINCOST)
				",IPTOS_MINCOST"
#endif
				"\n");
		}
	}
    break;

  case 380:

/* Line 1806 of yacc.c  */
#line 1698 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 381:

/* Line 1806 of yacc.c  */
#line 1699 "cfg.y"
    { pmtu_discovery=(yyvsp[(3) - (3)].intval); }
    break;

  case 382:

/* Line 1806 of yacc.c  */
#line 1700 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 383:

/* Line 1806 of yacc.c  */
#line 1701 "cfg.y"
    { ser_kill_timeout=(yyvsp[(3) - (3)].intval); }
    break;

  case 384:

/* Line 1806 of yacc.c  */
#line 1702 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 385:

/* Line 1806 of yacc.c  */
#line 1703 "cfg.y"
    { default_core_cfg.max_while_loops=(yyvsp[(3) - (3)].intval); }
    break;

  case 386:

/* Line 1806 of yacc.c  */
#line 1704 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 387:

/* Line 1806 of yacc.c  */
#line 1705 "cfg.y"
    { pv_set_buffer_size((yyvsp[(3) - (3)].intval)); }
    break;

  case 388:

/* Line 1806 of yacc.c  */
#line 1706 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 389:

/* Line 1806 of yacc.c  */
#line 1707 "cfg.y"
    { pv_set_buffer_slots((yyvsp[(3) - (3)].intval)); }
    break;

  case 390:

/* Line 1806 of yacc.c  */
#line 1708 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 391:

/* Line 1806 of yacc.c  */
#line 1709 "cfg.y"
    { http_reply_hack=(yyvsp[(3) - (3)].intval); }
    break;

  case 392:

/* Line 1806 of yacc.c  */
#line 1710 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 393:

/* Line 1806 of yacc.c  */
#line 1711 "cfg.y"
    { IF_STUN(stun_refresh_interval=(yyvsp[(3) - (3)].intval)); }
    break;

  case 394:

/* Line 1806 of yacc.c  */
#line 1712 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 395:

/* Line 1806 of yacc.c  */
#line 1713 "cfg.y"
    { IF_STUN(stun_allow_stun=(yyvsp[(3) - (3)].intval)); }
    break;

  case 396:

/* Line 1806 of yacc.c  */
#line 1714 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 397:

/* Line 1806 of yacc.c  */
#line 1715 "cfg.y"
    { IF_STUN(stun_allow_fp=(yyvsp[(3) - (3)].intval)) ; }
    break;

  case 398:

/* Line 1806 of yacc.c  */
#line 1716 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 399:

/* Line 1806 of yacc.c  */
#line 1717 "cfg.y"
    { server_id=(yyvsp[(3) - (3)].intval); }
    break;

  case 400:

/* Line 1806 of yacc.c  */
#line 1718 "cfg.y"
    { default_core_cfg.latency_log=(yyvsp[(3) - (3)].intval); }
    break;

  case 401:

/* Line 1806 of yacc.c  */
#line 1719 "cfg.y"
    { yyerror("number  expected"); }
    break;

  case 402:

/* Line 1806 of yacc.c  */
#line 1720 "cfg.y"
    { default_core_cfg.latency_limit_db=(yyvsp[(3) - (3)].intval); }
    break;

  case 403:

/* Line 1806 of yacc.c  */
#line 1721 "cfg.y"
    { yyerror("number  expected"); }
    break;

  case 404:

/* Line 1806 of yacc.c  */
#line 1722 "cfg.y"
    { default_core_cfg.latency_limit_action=(yyvsp[(3) - (3)].intval); }
    break;

  case 405:

/* Line 1806 of yacc.c  */
#line 1723 "cfg.y"
    { yyerror("number  expected"); }
    break;

  case 406:

/* Line 1806 of yacc.c  */
#line 1724 "cfg.y"
    { sr_msg_time=(yyvsp[(3) - (3)].intval); }
    break;

  case 407:

/* Line 1806 of yacc.c  */
#line 1725 "cfg.y"
    { yyerror("number  expected"); }
    break;

  case 408:

/* Line 1806 of yacc.c  */
#line 1726 "cfg.y"
    { default_core_cfg.udp_mtu=(yyvsp[(3) - (3)].intval); }
    break;

  case 409:

/* Line 1806 of yacc.c  */
#line 1727 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 410:

/* Line 1806 of yacc.c  */
#line 1729 "cfg.y"
    { default_core_cfg.force_rport=(yyvsp[(3) - (3)].intval); fix_global_req_flags(0, 0); }
    break;

  case 411:

/* Line 1806 of yacc.c  */
#line 1730 "cfg.y"
    { yyerror("boolean value expected"); }
    break;

  case 412:

/* Line 1806 of yacc.c  */
#line 1732 "cfg.y"
    { default_core_cfg.udp_mtu_try_proto=(yyvsp[(3) - (3)].intval); fix_global_req_flags(0, 0); }
    break;

  case 413:

/* Line 1806 of yacc.c  */
#line 1734 "cfg.y"
    { yyerror("TCP, TLS, SCTP or UDP expected"); }
    break;

  case 414:

/* Line 1806 of yacc.c  */
#line 1735 "cfg.y"
    { IF_RAW_SOCKS(default_core_cfg.udp4_raw=(yyvsp[(3) - (3)].intval)); }
    break;

  case 415:

/* Line 1806 of yacc.c  */
#line 1736 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 416:

/* Line 1806 of yacc.c  */
#line 1737 "cfg.y"
    {
		IF_RAW_SOCKS(default_core_cfg.udp4_raw_mtu=(yyvsp[(3) - (3)].intval));
	}
    break;

  case 417:

/* Line 1806 of yacc.c  */
#line 1740 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 418:

/* Line 1806 of yacc.c  */
#line 1741 "cfg.y"
    {
		IF_RAW_SOCKS(default_core_cfg.udp4_raw_ttl=(yyvsp[(3) - (3)].intval));
	}
    break;

  case 419:

/* Line 1806 of yacc.c  */
#line 1744 "cfg.y"
    { yyerror("number expected"); }
    break;

  case 421:

/* Line 1806 of yacc.c  */
#line 1746 "cfg.y"
    { yyerror("unknown config variable"); }
    break;

  case 423:

/* Line 1806 of yacc.c  */
#line 1750 "cfg.y"
    { (yyval.strval)="default" ; }
    break;

  case 424:

/* Line 1806 of yacc.c  */
#line 1754 "cfg.y"
    {
		if (cfg_declare_int((yyvsp[(1) - (5)].strval), (yyvsp[(3) - (5)].strval), (yyvsp[(5) - (5)].intval), 0, 0, NULL)) {
			yyerror("variable cannot be declared");
		}
	}
    break;

  case 425:

/* Line 1806 of yacc.c  */
#line 1759 "cfg.y"
    {
		if (cfg_declare_str((yyvsp[(1) - (5)].strval), (yyvsp[(3) - (5)].strval), (yyvsp[(5) - (5)].strval), NULL)) {
			yyerror("variable cannot be declared");
		}
	}
    break;

  case 426:

/* Line 1806 of yacc.c  */
#line 1764 "cfg.y"
    {
		if (cfg_declare_int((yyvsp[(1) - (7)].strval), (yyvsp[(3) - (7)].strval), (yyvsp[(5) - (7)].intval), 0, 0, (yyvsp[(7) - (7)].strval))) {
			yyerror("variable cannot be declared");
		}
	}
    break;

  case 427:

/* Line 1806 of yacc.c  */
#line 1769 "cfg.y"
    {
		if (cfg_declare_str((yyvsp[(1) - (7)].strval), (yyvsp[(3) - (7)].strval), (yyvsp[(5) - (7)].strval), (yyvsp[(7) - (7)].strval))) {
			yyerror("variable cannot be declared");
		}
	}
    break;

  case 428:

/* Line 1806 of yacc.c  */
#line 1774 "cfg.y"
    { 
		yyerror("number or string expected"); 
	}
    break;

  case 429:

/* Line 1806 of yacc.c  */
#line 1777 "cfg.y"
    {
		if (cfg_ginst_var_int((yyvsp[(1) - (8)].strval), (yyvsp[(3) - (8)].intval), (yyvsp[(6) - (8)].strval), (yyvsp[(8) - (8)].intval))) {
			yyerror("variable cannot be added to the group instance");
		}
	}
    break;

  case 430:

/* Line 1806 of yacc.c  */
#line 1782 "cfg.y"
    {
		if (cfg_ginst_var_string((yyvsp[(1) - (8)].strval), (yyvsp[(3) - (8)].intval), (yyvsp[(6) - (8)].strval), (yyvsp[(8) - (8)].strval))) {
			yyerror("variable cannot be added to the group instance");
		}
	}
    break;

  case 431:

/* Line 1806 of yacc.c  */
#line 1790 "cfg.y"
    {
		DBG("loading module %s\n", (yyvsp[(2) - (2)].strval));
			if (load_module((yyvsp[(2) - (2)].strval))!=0) {
				yyerror("failed to load module");
			}
	}
    break;

  case 432:

/* Line 1806 of yacc.c  */
#line 1796 "cfg.y"
    { yyerror("string expected"); }
    break;

  case 433:

/* Line 1806 of yacc.c  */
#line 1797 "cfg.y"
    {
		DBG("loading modules under %s\n", (yyvsp[(2) - (2)].strval));
		printf("loading modules under %s\n", (yyvsp[(2) - (2)].strval));
		mods_dir = (yyvsp[(2) - (2)].strval);
	}
    break;

  case 434:

/* Line 1806 of yacc.c  */
#line 1802 "cfg.y"
    { yyerror("string expected"); }
    break;

  case 435:

/* Line 1806 of yacc.c  */
#line 1803 "cfg.y"
    {
		DBG("loading modules under %s\n", (yyvsp[(3) - (3)].strval));
		printf("loading modules under %s\n", (yyvsp[(3) - (3)].strval));
		mods_dir = (yyvsp[(3) - (3)].strval);
	}
    break;

  case 436:

/* Line 1806 of yacc.c  */
#line 1808 "cfg.y"
    { yyerror("string expected"); }
    break;

  case 437:

/* Line 1806 of yacc.c  */
#line 1809 "cfg.y"
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		if (set_mod_param_regex((yyvsp[(3) - (8)].strval), (yyvsp[(5) - (8)].strval), PARAM_STRING, (yyvsp[(7) - (8)].strval)) != 0) {
			 yyerror("Can't set module parameter");
		}
	}
    break;

  case 438:

/* Line 1806 of yacc.c  */
#line 1820 "cfg.y"
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		if (set_mod_param_regex((yyvsp[(3) - (8)].strval), (yyvsp[(5) - (8)].strval), PARAM_INT, (void*)(yyvsp[(7) - (8)].intval)) != 0) {
			 yyerror("Can't set module parameter");
		}
	}
    break;

  case 439:

/* Line 1806 of yacc.c  */
#line 1831 "cfg.y"
    { yyerror("Invalid arguments"); }
    break;

  case 440:

/* Line 1806 of yacc.c  */
#line 1834 "cfg.y"
    { (yyval.ipaddr)=(yyvsp[(1) - (1)].ipaddr); }
    break;

  case 441:

/* Line 1806 of yacc.c  */
#line 1835 "cfg.y"
    { (yyval.ipaddr)=(yyvsp[(1) - (1)].ipaddr); }
    break;

  case 442:

/* Line 1806 of yacc.c  */
#line 1838 "cfg.y"
    {
		(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
		if ((yyval.ipaddr)==0) {
			LOG(L_CRIT, "ERROR: cfg. parser: out of memory.\n");
		} else {
			memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
			(yyval.ipaddr)->af=AF_INET;
			(yyval.ipaddr)->len=4;
			if (((yyvsp[(1) - (7)].intval)>255) || ((yyvsp[(1) - (7)].intval)<0) ||
				((yyvsp[(3) - (7)].intval)>255) || ((yyvsp[(3) - (7)].intval)<0) ||
				((yyvsp[(5) - (7)].intval)>255) || ((yyvsp[(5) - (7)].intval)<0) ||
				((yyvsp[(7) - (7)].intval)>255) || ((yyvsp[(7) - (7)].intval)<0)) {
				yyerror("invalid ipv4 address");
				(yyval.ipaddr)->u.addr32[0]=0;
				/* $$=0; */
			} else {
				(yyval.ipaddr)->u.addr[0]=(yyvsp[(1) - (7)].intval);
				(yyval.ipaddr)->u.addr[1]=(yyvsp[(3) - (7)].intval);
				(yyval.ipaddr)->u.addr[2]=(yyvsp[(5) - (7)].intval);
				(yyval.ipaddr)->u.addr[3]=(yyvsp[(7) - (7)].intval);
				/*
				$$=htonl( ($1<<24)|
				($3<<16)| ($5<<8)|$7 );
				*/
			}
		}
	}
    break;

  case 443:

/* Line 1806 of yacc.c  */
#line 1867 "cfg.y"
    {
		(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
		if ((yyval.ipaddr)==0) {
			LOG(L_CRIT, "ERROR: cfg. parser: out of memory.\n");
		} else {
		#ifdef USE_IPV6
			memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
			(yyval.ipaddr)->af=AF_INET6;
			(yyval.ipaddr)->len=16;
			if (inet_pton(AF_INET6, (yyvsp[(1) - (1)].strval), (yyval.ipaddr)->u.addr)<=0) {
				yyerror("bad ipv6 address");
			}
		#else
			yyerror("ipv6 address & no ipv6 support compiled in");
			YYABORT;
		#endif
		}
	}
    break;

  case 444:

/* Line 1806 of yacc.c  */
#line 1887 "cfg.y"
    { (yyval.ipaddr)=(yyvsp[(1) - (1)].ipaddr); }
    break;

  case 445:

/* Line 1806 of yacc.c  */
#line 1888 "cfg.y"
    {(yyval.ipaddr)=(yyvsp[(2) - (3)].ipaddr); }
    break;

  case 446:

/* Line 1806 of yacc.c  */
#line 1892 "cfg.y"
    {
					tmp=int2str((yyvsp[(1) - (1)].intval), &i_tmp);
					if (((yyval.strval)=pkg_malloc(i_tmp+1))==0) {
						yyerror("out of  memory");
						YYABORT;
					} else {
						memcpy((yyval.strval), tmp, i_tmp);
						(yyval.strval)[i_tmp]=0;
					}
						}
    break;

  case 447:

/* Line 1806 of yacc.c  */
#line 1902 "cfg.y"
    { (yyval.strval)=(yyvsp[(1) - (1)].strval); }
    break;

  case 448:

/* Line 1806 of yacc.c  */
#line 1903 "cfg.y"
    { (yyval.strval)=(yyvsp[(1) - (1)].strval); }
    break;

  case 449:

/* Line 1806 of yacc.c  */
#line 1907 "cfg.y"
    { ; }
    break;

  case 450:

/* Line 1806 of yacc.c  */
#line 1908 "cfg.y"
    { ; }
    break;

  case 451:

/* Line 1806 of yacc.c  */
#line 1912 "cfg.y"
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		push((yyvsp[(3) - (4)].action), &main_rt.rlist[DEFAULT_RT]);
	}
    break;

  case 452:

/* Line 1806 of yacc.c  */
#line 1921 "cfg.y"
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		i_tmp=route_get(&main_rt, (yyvsp[(3) - (7)].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (main_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[(6) - (7)].action), &main_rt.rlist[i_tmp]);
	}
    break;

  case 453:

/* Line 1806 of yacc.c  */
#line 1939 "cfg.y"
    { yyerror("invalid  route  statement"); }
    break;

  case 454:

/* Line 1806 of yacc.c  */
#line 1940 "cfg.y"
    { yyerror("invalid  request_route  statement"); }
    break;

  case 455:

/* Line 1806 of yacc.c  */
#line 1943 "cfg.y"
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		push((yyvsp[(3) - (4)].action), &failure_rt.rlist[DEFAULT_RT]);
	}
    break;

  case 456:

/* Line 1806 of yacc.c  */
#line 1952 "cfg.y"
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		i_tmp=route_get(&failure_rt, (yyvsp[(3) - (7)].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (failure_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[(6) - (7)].action), &failure_rt.rlist[i_tmp]);
	}
    break;

  case 457:

/* Line 1806 of yacc.c  */
#line 1970 "cfg.y"
    { yyerror("invalid failure_route statement"); }
    break;

  case 458:

/* Line 1806 of yacc.c  */
#line 1974 "cfg.y"
    { ; }
    break;

  case 459:

/* Line 1806 of yacc.c  */
#line 1975 "cfg.y"
    { ; }
    break;

  case 460:

/* Line 1806 of yacc.c  */
#line 1980 "cfg.y"
    {rt=CORE_ONREPLY_ROUTE;}
    break;

  case 461:

/* Line 1806 of yacc.c  */
#line 1980 "cfg.y"
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		push((yyvsp[(4) - (5)].action), &onreply_rt.rlist[DEFAULT_RT]);
	}
    break;

  case 462:

/* Line 1806 of yacc.c  */
#line 1989 "cfg.y"
    { yyerror("invalid onreply_route statement"); }
    break;

  case 463:

/* Line 1806 of yacc.c  */
#line 1990 "cfg.y"
    { yyerror("invalid onreply_route statement"); }
    break;

  case 464:

/* Line 1806 of yacc.c  */
#line 1992 "cfg.y"
    {rt=(*(yyvsp[(3) - (4)].strval)=='0' && (yyvsp[(3) - (4)].strval)[1]==0)?CORE_ONREPLY_ROUTE:TM_ONREPLY_ROUTE;}
    break;

  case 465:

/* Line 1806 of yacc.c  */
#line 1993 "cfg.y"
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		if (*(yyvsp[(3) - (8)].strval)=='0' && (yyvsp[(3) - (8)].strval)[1]==0){
			/* onreply_route[0] {} is equivalent with onreply_route {}*/
			push((yyvsp[(7) - (8)].action), &onreply_rt.rlist[DEFAULT_RT]);
		}else{
			i_tmp=route_get(&onreply_rt, (yyvsp[(3) - (8)].strval));
			if (i_tmp==-1){
				yyerror("internal error");
				YYABORT;
			}
			if (onreply_rt.rlist[i_tmp]){
				yyerror("duplicate route");
				YYABORT;
			}
			push((yyvsp[(7) - (8)].action), &onreply_rt.rlist[i_tmp]);
		}
	}
    break;

  case 466:

/* Line 1806 of yacc.c  */
#line 2016 "cfg.y"
    {
		yyerror("invalid onreply_route statement");
	}
    break;

  case 467:

/* Line 1806 of yacc.c  */
#line 2021 "cfg.y"
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		push((yyvsp[(3) - (4)].action), &branch_rt.rlist[DEFAULT_RT]);
	}
    break;

  case 468:

/* Line 1806 of yacc.c  */
#line 2030 "cfg.y"
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		i_tmp=route_get(&branch_rt, (yyvsp[(3) - (7)].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (branch_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[(6) - (7)].action), &branch_rt.rlist[i_tmp]);
	}
    break;

  case 469:

/* Line 1806 of yacc.c  */
#line 2048 "cfg.y"
    { yyerror("invalid branch_route statement"); }
    break;

  case 470:

/* Line 1806 of yacc.c  */
#line 2050 "cfg.y"
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		push((yyvsp[(3) - (4)].action), &onsend_rt.rlist[DEFAULT_RT]);
	}
    break;

  case 471:

/* Line 1806 of yacc.c  */
#line 2059 "cfg.y"
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		i_tmp=route_get(&onsend_rt, (yyvsp[(3) - (7)].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (onsend_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[(6) - (7)].action), &onsend_rt.rlist[i_tmp]);
	}
    break;

  case 472:

/* Line 1806 of yacc.c  */
#line 2077 "cfg.y"
    { yyerror("invalid onsend_route statement"); }
    break;

  case 473:

/* Line 1806 of yacc.c  */
#line 2079 "cfg.y"
    {
	#ifdef SHM_MEM
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
	#endif /* SHM_MEM */
		i_tmp=route_get(&event_rt, (yyvsp[(3) - (7)].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (event_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[(6) - (7)].action), &event_rt.rlist[i_tmp]);
	}
    break;

  case 474:

/* Line 1806 of yacc.c  */
#line 2098 "cfg.y"
    { yyerror("invalid event_route statement"); }
    break;

  case 475:

/* Line 1806 of yacc.c  */
#line 2101 "cfg.y"
    { if(pp_subst_add((yyvsp[(2) - (2)].strval))<0) YYERROR; }
    break;

  case 476:

/* Line 1806 of yacc.c  */
#line 2102 "cfg.y"
    { yyerror("invalid subst preprocess statement"); }
    break;

  case 477:

/* Line 1806 of yacc.c  */
#line 2103 "cfg.y"
    { if(pp_substdef_add((yyvsp[(2) - (2)].strval), 0)<0) YYERROR; }
    break;

  case 478:

/* Line 1806 of yacc.c  */
#line 2104 "cfg.y"
    { yyerror("invalid substdef preprocess statement"); }
    break;

  case 479:

/* Line 1806 of yacc.c  */
#line 2105 "cfg.y"
    { if(pp_substdef_add((yyvsp[(2) - (2)].strval), 1)<0) YYERROR; }
    break;

  case 480:

/* Line 1806 of yacc.c  */
#line 2106 "cfg.y"
    { yyerror("invalid substdefs preprocess statement"); }
    break;

  case 481:

/* Line 1806 of yacc.c  */
#line 2128 "cfg.y"
    {(yyval.intval)=EQUAL_OP; }
    break;

  case 482:

/* Line 1806 of yacc.c  */
#line 2129 "cfg.y"
    {(yyval.intval)=DIFF_OP; }
    break;

  case 483:

/* Line 1806 of yacc.c  */
#line 2130 "cfg.y"
    {(yyval.intval)=EQUAL_OP; }
    break;

  case 484:

/* Line 1806 of yacc.c  */
#line 2131 "cfg.y"
    {(yyval.intval)=DIFF_OP; }
    break;

  case 485:

/* Line 1806 of yacc.c  */
#line 2134 "cfg.y"
    {(yyval.intval)=GT_OP; }
    break;

  case 486:

/* Line 1806 of yacc.c  */
#line 2135 "cfg.y"
    {(yyval.intval)=LT_OP; }
    break;

  case 487:

/* Line 1806 of yacc.c  */
#line 2136 "cfg.y"
    {(yyval.intval)=GTE_OP; }
    break;

  case 488:

/* Line 1806 of yacc.c  */
#line 2137 "cfg.y"
    {(yyval.intval)=LTE_OP; }
    break;

  case 489:

/* Line 1806 of yacc.c  */
#line 2140 "cfg.y"
    {(yyval.intval)=(yyvsp[(1) - (1)].intval); }
    break;

  case 490:

/* Line 1806 of yacc.c  */
#line 2141 "cfg.y"
    {(yyval.intval)=MATCH_OP; }
    break;

  case 491:

/* Line 1806 of yacc.c  */
#line 2147 "cfg.y"
    {(yyval.intval)=RVE_EQ_OP; }
    break;

  case 492:

/* Line 1806 of yacc.c  */
#line 2148 "cfg.y"
    {(yyval.intval)=RVE_DIFF_OP; }
    break;

  case 493:

/* Line 1806 of yacc.c  */
#line 2149 "cfg.y"
    {(yyval.intval)=RVE_IEQ_OP; }
    break;

  case 494:

/* Line 1806 of yacc.c  */
#line 2150 "cfg.y"
    {(yyval.intval)=RVE_IDIFF_OP; }
    break;

  case 495:

/* Line 1806 of yacc.c  */
#line 2151 "cfg.y"
    {(yyval.intval)=RVE_STREQ_OP; }
    break;

  case 496:

/* Line 1806 of yacc.c  */
#line 2152 "cfg.y"
    {(yyval.intval)=RVE_STRDIFF_OP; }
    break;

  case 497:

/* Line 1806 of yacc.c  */
#line 2153 "cfg.y"
    {(yyval.intval)=RVE_MATCH_OP; }
    break;

  case 498:

/* Line 1806 of yacc.c  */
#line 2156 "cfg.y"
    {(yyval.intval)=RVE_GT_OP; }
    break;

  case 499:

/* Line 1806 of yacc.c  */
#line 2157 "cfg.y"
    {(yyval.intval)=RVE_LT_OP; }
    break;

  case 500:

/* Line 1806 of yacc.c  */
#line 2158 "cfg.y"
    {(yyval.intval)=RVE_GTE_OP; }
    break;

  case 501:

/* Line 1806 of yacc.c  */
#line 2159 "cfg.y"
    {(yyval.intval)=RVE_LTE_OP; }
    break;

  case 502:

/* Line 1806 of yacc.c  */
#line 2166 "cfg.y"
    {(yyval.intval)=URI_O;}
    break;

  case 503:

/* Line 1806 of yacc.c  */
#line 2167 "cfg.y"
    {(yyval.intval)=FROM_URI_O;}
    break;

  case 504:

/* Line 1806 of yacc.c  */
#line 2168 "cfg.y"
    {(yyval.intval)=TO_URI_O;}
    break;

  case 505:

/* Line 1806 of yacc.c  */
#line 2175 "cfg.y"
    { (yyval.intval)=SNDPORT_O; }
    break;

  case 506:

/* Line 1806 of yacc.c  */
#line 2176 "cfg.y"
    { (yyval.intval)=TOPORT_O; }
    break;

  case 507:

/* Line 1806 of yacc.c  */
#line 2177 "cfg.y"
    { (yyval.intval)=SNDAF_O; }
    break;

  case 508:

/* Line 1806 of yacc.c  */
#line 2181 "cfg.y"
    { (yyval.intval)=SRCPORT_O; }
    break;

  case 509:

/* Line 1806 of yacc.c  */
#line 2182 "cfg.y"
    { (yyval.intval)=DSTPORT_O; }
    break;

  case 510:

/* Line 1806 of yacc.c  */
#line 2183 "cfg.y"
    { (yyval.intval)=AF_O; }
    break;

  case 511:

/* Line 1806 of yacc.c  */
#line 2184 "cfg.y"
    { (yyval.intval)=MSGLEN_O; }
    break;

  case 513:

/* Line 1806 of yacc.c  */
#line 2190 "cfg.y"
    { onsend_check("snd_ip"); (yyval.intval)=SNDIP_O; }
    break;

  case 514:

/* Line 1806 of yacc.c  */
#line 2191 "cfg.y"
    { onsend_check("to_ip");  (yyval.intval)=TOIP_O; }
    break;

  case 515:

/* Line 1806 of yacc.c  */
#line 2194 "cfg.y"
    { (yyval.intval)=SRCIP_O; }
    break;

  case 516:

/* Line 1806 of yacc.c  */
#line 2195 "cfg.y"
    { (yyval.intval)=DSTIP_O; }
    break;

  case 518:

/* Line 1806 of yacc.c  */
#line 2203 "cfg.y"
    {(yyval.expr)= mk_elem((yyvsp[(2) - (3)].intval), METHOD_O, 0, RVE_ST, (yyvsp[(3) - (3)].rv_expr));}
    break;

  case 519:

/* Line 1806 of yacc.c  */
#line 2205 "cfg.y"
    {(yyval.expr) = mk_elem((yyvsp[(2) - (3)].intval), METHOD_O, 0, STRING_ST,(yyvsp[(3) - (3)].strval)); }
    break;

  case 520:

/* Line 1806 of yacc.c  */
#line 2206 "cfg.y"
    { (yyval.expr)=0; yyerror("string expected"); }
    break;

  case 521:

/* Line 1806 of yacc.c  */
#line 2208 "cfg.y"
    { (yyval.expr)=0; yyerror("invalid operator,== , !=, or =~ expected"); }
    break;

  case 522:

/* Line 1806 of yacc.c  */
#line 2210 "cfg.y"
    {(yyval.expr) = mk_elem((yyvsp[(2) - (3)].intval), (yyvsp[(1) - (3)].intval), 0, RVE_ST, (yyvsp[(3) - (3)].rv_expr)); }
    break;

  case 523:

/* Line 1806 of yacc.c  */
#line 2212 "cfg.y"
    {(yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), (yyvsp[(1) - (3)].intval), 0, MYSELF_ST, 0); }
    break;

  case 524:

/* Line 1806 of yacc.c  */
#line 2214 "cfg.y"
    { (yyval.expr)=0; yyerror("string or MYSELF expected"); }
    break;

  case 525:

/* Line 1806 of yacc.c  */
#line 2216 "cfg.y"
    { (yyval.expr)=0; yyerror("invalid operator, == , != or =~ expected"); }
    break;

  case 526:

/* Line 1806 of yacc.c  */
#line 2217 "cfg.y"
    { (yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), (yyvsp[(1) - (3)].intval), 0, RVE_ST, (yyvsp[(3) - (3)].rv_expr) ); }
    break;

  case 527:

/* Line 1806 of yacc.c  */
#line 2219 "cfg.y"
    { (yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), (yyvsp[(1) - (3)].intval), 0, RVE_ST, (yyvsp[(3) - (3)].rv_expr) ); }
    break;

  case 528:

/* Line 1806 of yacc.c  */
#line 2220 "cfg.y"
    { (yyval.expr)=0; yyerror("number expected"); }
    break;

  case 529:

/* Line 1806 of yacc.c  */
#line 2221 "cfg.y"
    { (yyval.expr)=0; yyerror("number expected"); }
    break;

  case 530:

/* Line 1806 of yacc.c  */
#line 2222 "cfg.y"
    { (yyval.expr)=0; yyerror("==, !=, <,>, >= or <=  expected"); }
    break;

  case 531:

/* Line 1806 of yacc.c  */
#line 2224 "cfg.y"
    { (yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), PROTO_O, 0, NUMBER_ST, (void*)(yyvsp[(3) - (3)].intval) ); }
    break;

  case 532:

/* Line 1806 of yacc.c  */
#line 2226 "cfg.y"
    { (yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), PROTO_O, 0, RVE_ST, (yyvsp[(3) - (3)].rv_expr) ); }
    break;

  case 533:

/* Line 1806 of yacc.c  */
#line 2228 "cfg.y"
    { (yyval.expr)=0; yyerror("protocol expected (udp, tcp, tls, sctp, ws, or wss)"); }
    break;

  case 534:

/* Line 1806 of yacc.c  */
#line 2230 "cfg.y"
    { (yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), SNDPROTO_O, 0, NUMBER_ST, (void*)(yyvsp[(3) - (3)].intval) ); }
    break;

  case 535:

/* Line 1806 of yacc.c  */
#line 2232 "cfg.y"
    { (yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), SNDPROTO_O, 0, RVE_ST, (yyvsp[(3) - (3)].rv_expr) ); }
    break;

  case 536:

/* Line 1806 of yacc.c  */
#line 2234 "cfg.y"
    { (yyval.expr)=0; yyerror("protocol expected (udp, tcp, tls, sctp, ws, or wss)"); }
    break;

  case 537:

/* Line 1806 of yacc.c  */
#line 2235 "cfg.y"
    { (yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), (yyvsp[(1) - (3)].intval), 0, NET_ST, (yyvsp[(3) - (3)].ipnet)); }
    break;

  case 538:

/* Line 1806 of yacc.c  */
#line 2236 "cfg.y"
    {
			s_tmp.s=0;
			(yyval.expr)=0;
			if (rve_is_constant((yyvsp[(3) - (3)].rv_expr))){
				i_tmp=rve_guess_type((yyvsp[(3) - (3)].rv_expr));
				if (i_tmp==RV_INT)
					yyerror("string expected");
				else if (i_tmp==RV_STR){
					if (((rval_tmp=rval_expr_eval(0, 0, (yyvsp[(3) - (3)].rv_expr)))==0) ||
								(rval_get_str(0, 0, &s_tmp, rval_tmp, 0)<0)){
						rval_destroy(rval_tmp);
						yyerror("bad rvalue expression");
					}else{
						rval_destroy(rval_tmp);
					}
				}else{
					yyerror("BUG: unexpected dynamic type");
				}
			}else{
					/* warn("non constant rvalue in ip comparison") */;
			}
			if (s_tmp.s){
				ip_tmp=str2ip(&s_tmp);
			#ifdef USE_IPV6
				if (ip_tmp==0)
					ip_tmp=str2ip6(&s_tmp);
			#endif
				pkg_free(s_tmp.s);
				if (ip_tmp) {
					(yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), (yyvsp[(1) - (3)].intval), 0, NET_ST, 
								mk_new_net_bitlen(ip_tmp, ip_tmp->len*8) );
				} else {
					(yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), (yyvsp[(1) - (3)].intval), 0, RVE_ST, (yyvsp[(3) - (3)].rv_expr));
				}
			}else{
				(yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), (yyvsp[(1) - (3)].intval), 0, RVE_ST, (yyvsp[(3) - (3)].rv_expr));
			}
		}
    break;

  case 539:

/* Line 1806 of yacc.c  */
#line 2275 "cfg.y"
    { (yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), (yyvsp[(1) - (3)].intval), 0, STRING_ST, (yyvsp[(3) - (3)].strval)); }
    break;

  case 540:

/* Line 1806 of yacc.c  */
#line 2277 "cfg.y"
    { (yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), (yyvsp[(1) - (3)].intval), 0, MYSELF_ST, 0); }
    break;

  case 541:

/* Line 1806 of yacc.c  */
#line 2279 "cfg.y"
    { (yyval.expr)=0; yyerror( "ip address or hostname expected" ); }
    break;

  case 542:

/* Line 1806 of yacc.c  */
#line 2281 "cfg.y"
    { (yyval.expr)=0; yyerror("invalid operator, ==, != or =~ expected");}
    break;

  case 543:

/* Line 1806 of yacc.c  */
#line 2284 "cfg.y"
    { (yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), (yyvsp[(3) - (3)].intval), 0, MYSELF_ST, 0); }
    break;

  case 544:

/* Line 1806 of yacc.c  */
#line 2286 "cfg.y"
    { (yyval.expr)=mk_elem((yyvsp[(2) - (3)].intval), (yyvsp[(3) - (3)].intval), 0, MYSELF_ST, 0); }
    break;

  case 545:

/* Line 1806 of yacc.c  */
#line 2288 "cfg.y"
    { (yyval.expr)=0; yyerror(" URI, SRCIP or DSTIP expected"); }
    break;

  case 546:

/* Line 1806 of yacc.c  */
#line 2289 "cfg.y"
    { (yyval.expr)=0; yyerror ("invalid operator, == or != expected"); }
    break;

  case 547:

/* Line 1806 of yacc.c  */
#line 2306 "cfg.y"
    { (yyval.ipnet)=mk_new_net((yyvsp[(1) - (3)].ipaddr), (yyvsp[(3) - (3)].ipaddr)); }
    break;

  case 548:

/* Line 1806 of yacc.c  */
#line 2307 "cfg.y"
    {
		if (((yyvsp[(3) - (3)].intval)<0) || ((yyvsp[(3) - (3)].intval)>(yyvsp[(1) - (3)].ipaddr)->len*8)) {
			yyerror("invalid bit number in netmask");
			(yyval.ipnet)=0;
		} else {
			(yyval.ipnet)=mk_new_net_bitlen((yyvsp[(1) - (3)].ipaddr), (yyvsp[(3) - (3)].intval));
		/*
			$$=mk_new_net($1, htonl( ($3)?~( (1<<(32-$3))-1 ):0 ) );
		*/
		}
	}
    break;

  case 549:

/* Line 1806 of yacc.c  */
#line 2318 "cfg.y"
    { (yyval.ipnet)=mk_new_net_bitlen((yyvsp[(1) - (1)].ipaddr), (yyvsp[(1) - (1)].ipaddr)->len*8); }
    break;

  case 550:

/* Line 1806 of yacc.c  */
#line 2319 "cfg.y"
    { (yyval.ipnet)=0; yyerror("netmask (eg:255.0.0.0 or 8) expected"); }
    break;

  case 551:

/* Line 1806 of yacc.c  */
#line 2323 "cfg.y"
    { (yyval.strval)=(yyvsp[(1) - (1)].strval); }
    break;

  case 552:

/* Line 1806 of yacc.c  */
#line 2324 "cfg.y"
    {
		if ((yyvsp[(1) - (3)].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[(1) - (3)].strval))+1+strlen((yyvsp[(3) - (3)].strval))+1);
			if ((yyval.strval)==0) {
				LOG(L_CRIT, "ERROR: cfg. parser: memory allocation"
							" failure while parsing host\n");
			} else {
				memcpy((yyval.strval), (yyvsp[(1) - (3)].strval), strlen((yyvsp[(1) - (3)].strval)));
				(yyval.strval)[strlen((yyvsp[(1) - (3)].strval))]='.';
				memcpy((yyval.strval)+strlen((yyvsp[(1) - (3)].strval))+1, (yyvsp[(3) - (3)].strval), strlen((yyvsp[(3) - (3)].strval)));
				(yyval.strval)[strlen((yyvsp[(1) - (3)].strval))+1+strlen((yyvsp[(3) - (3)].strval))]=0;
			}
			pkg_free((yyvsp[(1) - (3)].strval));
		}
		if ((yyvsp[(3) - (3)].strval)) pkg_free((yyvsp[(3) - (3)].strval));
	}
    break;

  case 553:

/* Line 1806 of yacc.c  */
#line 2340 "cfg.y"
    {
		if ((yyvsp[(1) - (3)].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[(1) - (3)].strval))+1+strlen((yyvsp[(3) - (3)].strval))+1);
			if ((yyval.strval)==0) {
				LOG(L_CRIT, "ERROR: cfg. parser: memory allocation"
							" failure while parsing host\n");
			} else {
				memcpy((yyval.strval), (yyvsp[(1) - (3)].strval), strlen((yyvsp[(1) - (3)].strval)));
				(yyval.strval)[strlen((yyvsp[(1) - (3)].strval))]='-';
				memcpy((yyval.strval)+strlen((yyvsp[(1) - (3)].strval))+1, (yyvsp[(3) - (3)].strval), strlen((yyvsp[(3) - (3)].strval)));
				(yyval.strval)[strlen((yyvsp[(1) - (3)].strval))+1+strlen((yyvsp[(3) - (3)].strval))]=0;
			}
			pkg_free((yyvsp[(1) - (3)].strval));
		}
		if ((yyvsp[(3) - (3)].strval)) pkg_free((yyvsp[(3) - (3)].strval));
	}
    break;

  case 554:

/* Line 1806 of yacc.c  */
#line 2356 "cfg.y"
    { (yyval.strval)=0; pkg_free((yyvsp[(1) - (3)].strval)); yyerror("invalid hostname"); }
    break;

  case 555:

/* Line 1806 of yacc.c  */
#line 2357 "cfg.y"
    { (yyval.strval)=0; pkg_free((yyvsp[(1) - (3)].strval)); yyerror("invalid hostname"); }
    break;

  case 558:

/* Line 1806 of yacc.c  */
#line 2362 "cfg.y"
    {
			/* get string version */
			(yyval.strval)=pkg_malloc(strlen(yy_number_str)+1);
			if ((yyval.strval))
				strcpy((yyval.strval), yy_number_str);
		}
    break;

  case 559:

/* Line 1806 of yacc.c  */
#line 2371 "cfg.y"
    { (yyval.strval)=(yyvsp[(1) - (1)].strval); }
    break;

  case 560:

/* Line 1806 of yacc.c  */
#line 2372 "cfg.y"
    {
		if ((yyvsp[(1) - (3)].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[(1) - (3)].strval))+1+strlen((yyvsp[(3) - (3)].strval))+1);
			if ((yyval.strval)==0) {
				LOG(L_CRIT, "ERROR: cfg. parser: memory allocation"
							" failure while parsing host/interface name\n");
			} else {
				memcpy((yyval.strval), (yyvsp[(1) - (3)].strval), strlen((yyvsp[(1) - (3)].strval)));
				(yyval.strval)[strlen((yyvsp[(1) - (3)].strval))]='.';
				memcpy((yyval.strval)+strlen((yyvsp[(1) - (3)].strval))+1, (yyvsp[(3) - (3)].strval), strlen((yyvsp[(3) - (3)].strval)));
				(yyval.strval)[strlen((yyvsp[(1) - (3)].strval))+1+strlen((yyvsp[(3) - (3)].strval))]=0;
			}
			pkg_free((yyvsp[(1) - (3)].strval));
		}
		if ((yyvsp[(3) - (3)].strval)) pkg_free((yyvsp[(3) - (3)].strval));
	}
    break;

  case 561:

/* Line 1806 of yacc.c  */
#line 2388 "cfg.y"
    {
		if ((yyvsp[(1) - (3)].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[(1) - (3)].strval))+1+strlen((yyvsp[(3) - (3)].strval))+1);
			if ((yyval.strval)==0) {
				LOG(L_CRIT, "ERROR: cfg. parser: memory allocation"
							" failure while parsing host/interface name\n");
			} else {
				memcpy((yyval.strval), (yyvsp[(1) - (3)].strval), strlen((yyvsp[(1) - (3)].strval)));
				(yyval.strval)[strlen((yyvsp[(1) - (3)].strval))]='-';
				memcpy((yyval.strval)+strlen((yyvsp[(1) - (3)].strval))+1, (yyvsp[(3) - (3)].strval), strlen((yyvsp[(3) - (3)].strval)));
				(yyval.strval)[strlen((yyvsp[(1) - (3)].strval))+1+strlen((yyvsp[(3) - (3)].strval))]=0;
			}
			pkg_free((yyvsp[(1) - (3)].strval));
		}
		if ((yyvsp[(3) - (3)].strval)) pkg_free((yyvsp[(3) - (3)].strval));
	}
    break;

  case 562:

/* Line 1806 of yacc.c  */
#line 2404 "cfg.y"
    { (yyval.strval)=0; pkg_free((yyvsp[(1) - (3)].strval));
								yyerror("invalid host or interface name"); }
    break;

  case 563:

/* Line 1806 of yacc.c  */
#line 2406 "cfg.y"
    { (yyval.strval)=0; pkg_free((yyvsp[(1) - (3)].strval));
								yyerror("invalid host or interface name"); }
    break;

  case 564:

/* Line 1806 of yacc.c  */
#line 2413 "cfg.y"
    {
		/* check if allowed */
		if ((yyvsp[(1) - (1)].action) && rt==ONSEND_ROUTE) {
			switch((yyvsp[(1) - (1)].action)->type) {
				case DROP_T:
				case LOG_T:
				case SETFLAG_T:
				case RESETFLAG_T:
				case ISFLAGSET_T:
				case IF_T:
				case MODULE0_T:
				case MODULE1_T:
				case MODULE2_T:
				case MODULE3_T:
				case MODULE4_T:
				case MODULE5_T:
				case MODULE6_T:
				case MODULEX_T:
				case SET_FWD_NO_CONNECT_T:
				case SET_RPL_NO_CONNECT_T:
				case SET_FWD_CLOSE_T:
				case SET_RPL_CLOSE_T:
					(yyval.action)=(yyvsp[(1) - (1)].action);
					break;
				default:
					(yyval.action)=0;
					yyerror("command not allowed in onsend_route\n");
			}
		} else {
			(yyval.action)=(yyvsp[(1) - (1)].action);
		}
	}
    break;

  case 565:

/* Line 1806 of yacc.c  */
#line 2455 "cfg.y"
    { (yyval.action)=(yyvsp[(1) - (1)].action); }
    break;

  case 566:

/* Line 1806 of yacc.c  */
#line 2456 "cfg.y"
    { (yyval.action)=(yyvsp[(2) - (3)].action); }
    break;

  case 567:

/* Line 1806 of yacc.c  */
#line 2459 "cfg.y"
    {(yyval.action)=append_action((yyvsp[(1) - (2)].action), (yyvsp[(2) - (2)].action)); }
    break;

  case 568:

/* Line 1806 of yacc.c  */
#line 2460 "cfg.y"
    {(yyval.action)=(yyvsp[(1) - (1)].action);}
    break;

  case 569:

/* Line 1806 of yacc.c  */
#line 2461 "cfg.y"
    { (yyval.action)=0; yyerror("bad command"); }
    break;

  case 570:

/* Line 1806 of yacc.c  */
#line 2464 "cfg.y"
    {(yyval.action)=(yyvsp[(1) - (2)].action);}
    break;

  case 571:

/* Line 1806 of yacc.c  */
#line 2465 "cfg.y"
    {(yyval.action)=(yyvsp[(1) - (1)].action);}
    break;

  case 572:

/* Line 1806 of yacc.c  */
#line 2466 "cfg.y"
    {(yyval.action)=(yyvsp[(1) - (1)].action);}
    break;

  case 573:

/* Line 1806 of yacc.c  */
#line 2467 "cfg.y"
    { (yyval.action)=(yyvsp[(1) - (1)].action); }
    break;

  case 574:

/* Line 1806 of yacc.c  */
#line 2468 "cfg.y"
    { (yyval.action)=(yyvsp[(1) - (2)].action); }
    break;

  case 575:

/* Line 1806 of yacc.c  */
#line 2469 "cfg.y"
    {(yyval.action)=(yyvsp[(1) - (2)].action);}
    break;

  case 576:

/* Line 1806 of yacc.c  */
#line 2470 "cfg.y"
    {(yyval.action)=0;}
    break;

  case 577:

/* Line 1806 of yacc.c  */
#line 2471 "cfg.y"
    { (yyval.action)=0; yyerror("bad command: missing ';'?"); }
    break;

  case 578:

/* Line 1806 of yacc.c  */
#line 2474 "cfg.y"
    {
		if ((yyvsp[(2) - (3)].rv_expr) && rval_expr_int_check((yyvsp[(2) - (3)].rv_expr))>=0){
			warn_ct_rve((yyvsp[(2) - (3)].rv_expr), "if");
			(yyval.action)=mk_action( IF_T, 3, RVE_ST, (yyvsp[(2) - (3)].rv_expr), ACTIONS_ST, (yyvsp[(3) - (3)].action), NOSUBTYPE, 0);
			set_cfg_pos((yyval.action));
		}else
			YYERROR;
	}
    break;

  case 579:

/* Line 1806 of yacc.c  */
#line 2482 "cfg.y"
    { 
		if ((yyvsp[(2) - (5)].rv_expr) && rval_expr_int_check((yyvsp[(2) - (5)].rv_expr))>=0){
			warn_ct_rve((yyvsp[(2) - (5)].rv_expr), "if");
			(yyval.action)=mk_action( IF_T, 3, RVE_ST, (yyvsp[(2) - (5)].rv_expr), ACTIONS_ST, (yyvsp[(3) - (5)].action), ACTIONS_ST, (yyvsp[(5) - (5)].action));
			set_cfg_pos((yyval.action));
		}else
			YYERROR;
	}
    break;

  case 580:

/* Line 1806 of yacc.c  */
#line 2492 "cfg.y"
    {
			(yyval.rv_expr)=0;
			if ((yyvsp[(1) - (1)].rv_expr) && !rve_is_constant((yyvsp[(1) - (1)].rv_expr))){
				yyerror("constant expected");
				YYERROR;
			/*
			} else if ($1 &&
						!rve_check_type((enum rval_type*)&i_tmp, $1, 0, 0 ,0)){
				yyerror("invalid expression (bad type)");
			}else if ($1 && i_tmp!=RV_INT){
				yyerror("invalid expression type, int expected\n");
			*/
			}else
				(yyval.rv_expr)=(yyvsp[(1) - (1)].rv_expr);
		}
    break;

  case 581:

/* Line 1806 of yacc.c  */
#line 2509 "cfg.y"
    {
		(yyval.case_stms)=0;
		if ((yyvsp[(2) - (4)].rv_expr)==0) { yyerror ("bad case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[(2) - (4)].rv_expr), 0, (yyvsp[(4) - (4)].action), &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
    break;

  case 582:

/* Line 1806 of yacc.c  */
#line 2516 "cfg.y"
    {
		(yyval.case_stms)=0;
		if ((yyvsp[(3) - (5)].rv_expr)==0) { yyerror ("bad case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[(3) - (5)].rv_expr), 1, (yyvsp[(5) - (5)].action), &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
    break;

  case 583:

/* Line 1806 of yacc.c  */
#line 2523 "cfg.y"
    {
		(yyval.case_stms)=0;
		if ((yyvsp[(2) - (3)].rv_expr)==0) { yyerror ("bad case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[(2) - (3)].rv_expr), 0, 0, &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
    break;

  case 584:

/* Line 1806 of yacc.c  */
#line 2530 "cfg.y"
    {
		(yyval.case_stms)=0;
		if ((yyvsp[(3) - (4)].rv_expr)==0) { yyerror ("bad regex case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[(3) - (4)].rv_expr), 1, 0, &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
    break;

  case 585:

/* Line 1806 of yacc.c  */
#line 2537 "cfg.y"
    {
		if ((((yyval.case_stms)=mk_case_stm(0, 0, (yyvsp[(3) - (3)].action), &i_tmp))==0) && (i_tmp=-10)){
				YYABORT;
		}
	}
    break;

  case 586:

/* Line 1806 of yacc.c  */
#line 2542 "cfg.y"
    {
		if ((((yyval.case_stms)=mk_case_stm(0, 0, 0, &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
    break;

  case 587:

/* Line 1806 of yacc.c  */
#line 2547 "cfg.y"
    { (yyval.case_stms)=0; yyerror("bad case label"); }
    break;

  case 588:

/* Line 1806 of yacc.c  */
#line 2548 "cfg.y"
    { (yyval.case_stms)=0; yyerror("bad case regex label"); }
    break;

  case 589:

/* Line 1806 of yacc.c  */
#line 2549 "cfg.y"
    { (yyval.case_stms)=0; yyerror("bad case label"); }
    break;

  case 590:

/* Line 1806 of yacc.c  */
#line 2550 "cfg.y"
    { (yyval.case_stms)=0; yyerror("bad case regex label"); }
    break;

  case 591:

/* Line 1806 of yacc.c  */
#line 2551 "cfg.y"
    { (yyval.case_stms)=0; yyerror ("bad case body"); }
    break;

  case 592:

/* Line 1806 of yacc.c  */
#line 2554 "cfg.y"
    {
		(yyval.case_stms)=(yyvsp[(1) - (2)].case_stms);
		if ((yyvsp[(2) - (2)].case_stms)==0) yyerror ("bad case");
		if ((yyval.case_stms)){
			*((yyval.case_stms)->append)=(yyvsp[(2) - (2)].case_stms);
			if (*((yyval.case_stms)->append)!=0)
				(yyval.case_stms)->append=&((*((yyval.case_stms)->append))->next);
		}
	}
    break;

  case 593:

/* Line 1806 of yacc.c  */
#line 2563 "cfg.y"
    {
		(yyval.case_stms)=(yyvsp[(1) - (1)].case_stms);
		if ((yyvsp[(1) - (1)].case_stms)==0) yyerror ("bad case");
		else (yyval.case_stms)->append=&((yyval.case_stms)->next);
	}
    break;

  case 594:

/* Line 1806 of yacc.c  */
#line 2570 "cfg.y"
    { 
		(yyval.action)=0;
		if ((yyvsp[(2) - (5)].rv_expr)==0){
			yyerror("bad expression in switch(...)");
			YYERROR;
		}else if ((yyvsp[(4) - (5)].case_stms)==0){
			yyerror ("bad switch body");
			YYERROR;
		}else if (case_check_default((yyvsp[(4) - (5)].case_stms))!=0){
			yyerror_at(&(yyvsp[(2) - (5)].rv_expr)->fpos, "bad switch(): too many "
							"\"default:\" labels\n");
			YYERROR;
		}else if (case_check_type((yyvsp[(4) - (5)].case_stms))!=0){
			yyerror_at(&(yyvsp[(2) - (5)].rv_expr)->fpos, "bad switch(): mixed integer and"
							" string/RE cases not allowed\n");
			YYERROR;
		}else{
			(yyval.action)=mk_action(SWITCH_T, 2, RVE_ST, (yyvsp[(2) - (5)].rv_expr), CASE_ST, (yyvsp[(4) - (5)].case_stms));
			if ((yyval.action)==0) {
				yyerror("internal error");
				YYABORT;
			}
			set_cfg_pos((yyval.action));
		}
	}
    break;

  case 595:

/* Line 1806 of yacc.c  */
#line 2595 "cfg.y"
    {
		(yyval.action)=0;
		warn("empty switch()");
		if ((yyvsp[(2) - (4)].rv_expr)==0){
			yyerror("bad expression in switch(...)");
			YYERROR;
		}else{
			/* it might have sideffects, so leave it for the optimizer */
			(yyval.action)=mk_action(SWITCH_T, 2, RVE_ST, (yyvsp[(2) - (4)].rv_expr), CASE_ST, 0);
			if ((yyval.action)==0) {
				yyerror("internal error");
				YYABORT;
			}
			set_cfg_pos((yyval.action));
		}
	}
    break;

  case 596:

/* Line 1806 of yacc.c  */
#line 2611 "cfg.y"
    { (yyval.action)=0; yyerror ("bad expression in switch(...)"); }
    break;

  case 597:

/* Line 1806 of yacc.c  */
#line 2613 "cfg.y"
    {(yyval.action)=0; yyerror ("bad switch body"); }
    break;

  case 598:

/* Line 1806 of yacc.c  */
#line 2617 "cfg.y"
    {
		if ((yyvsp[(2) - (3)].rv_expr) && rval_expr_int_check((yyvsp[(2) - (3)].rv_expr))>=0){
			warn_ct_rve((yyvsp[(2) - (3)].rv_expr), "while");
			(yyval.action)=mk_action( WHILE_T, 2, RVE_ST, (yyvsp[(2) - (3)].rv_expr), ACTIONS_ST, (yyvsp[(3) - (3)].action));
			set_cfg_pos((yyval.action));
		}else{
			yyerror_at(&(yyvsp[(2) - (3)].rv_expr)->fpos, "bad while(...) expression");
			YYERROR;
		}
	}
    break;

  case 599:

/* Line 1806 of yacc.c  */
#line 2636 "cfg.y"
    {
		if (sel.n >= MAX_SELECT_PARAMS-1) {
			yyerror("Select identifier too long\n");
		}
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[(1) - (1)].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[(1) - (1)].strval));
		sel.n++;
	}
    break;

  case 600:

/* Line 1806 of yacc.c  */
#line 2645 "cfg.y"
    {
		if (sel.n >= MAX_SELECT_PARAMS-2) {
			yyerror("Select identifier too long\n");
		}
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[(1) - (4)].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[(1) - (4)].strval));
		sel.n++;
		sel.params[sel.n].type = SEL_PARAM_INT;
		sel.params[sel.n].v.i = (yyvsp[(3) - (4)].intval);
		sel.n++;
	}
    break;

  case 601:

/* Line 1806 of yacc.c  */
#line 2657 "cfg.y"
    {
		if (sel.n >= MAX_SELECT_PARAMS-2) {
			yyerror("Select identifier too long\n");
		}
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[(1) - (4)].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[(1) - (4)].strval));
		sel.n++;
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[(3) - (4)].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[(3) - (4)].strval));
		sel.n++;
	}
    break;

  case 604:

/* Line 1806 of yacc.c  */
#line 2676 "cfg.y"
    { sel.n = 0; sel.f[0] = 0; }
    break;

  case 605:

/* Line 1806 of yacc.c  */
#line 2676 "cfg.y"
    {
		sel_ptr = (select_t*)pkg_malloc(sizeof(select_t));
		if (!sel_ptr) {
			yyerror("No memory left to allocate select structure\n");
		}
		memcpy(sel_ptr, &sel, sizeof(select_t));
		(yyval.select) = sel_ptr;
	}
    break;

  case 606:

/* Line 1806 of yacc.c  */
#line 2686 "cfg.y"
    { s_attr->type |= AVP_TRACK_FROM; }
    break;

  case 607:

/* Line 1806 of yacc.c  */
#line 2687 "cfg.y"
    { s_attr->type |= AVP_TRACK_TO; }
    break;

  case 608:

/* Line 1806 of yacc.c  */
#line 2688 "cfg.y"
    { s_attr->type |= AVP_TRACK_FROM | AVP_CLASS_URI; }
    break;

  case 609:

/* Line 1806 of yacc.c  */
#line 2689 "cfg.y"
    { s_attr->type |= AVP_TRACK_TO | AVP_CLASS_URI; }
    break;

  case 610:

/* Line 1806 of yacc.c  */
#line 2690 "cfg.y"
    { s_attr->type |= AVP_TRACK_FROM | AVP_CLASS_USER; }
    break;

  case 611:

/* Line 1806 of yacc.c  */
#line 2691 "cfg.y"
    { s_attr->type |= AVP_TRACK_TO | AVP_CLASS_USER; }
    break;

  case 612:

/* Line 1806 of yacc.c  */
#line 2692 "cfg.y"
    { s_attr->type |= AVP_TRACK_FROM | AVP_CLASS_DOMAIN; }
    break;

  case 613:

/* Line 1806 of yacc.c  */
#line 2693 "cfg.y"
    { s_attr->type |= AVP_TRACK_TO | AVP_CLASS_DOMAIN; }
    break;

  case 614:

/* Line 1806 of yacc.c  */
#line 2694 "cfg.y"
    { s_attr->type |= AVP_TRACK_ALL | AVP_CLASS_GLOBAL; }
    break;

  case 615:

/* Line 1806 of yacc.c  */
#line 2697 "cfg.y"
    { s_attr->type |= AVP_NAME_STR; s_attr->name.s.s = (yyvsp[(1) - (1)].strval); s_attr->name.s.len = strlen ((yyvsp[(1) - (1)].strval)); }
    break;

  case 618:

/* Line 1806 of yacc.c  */
#line 2704 "cfg.y"
    {
		s_attr = (struct avp_spec*)pkg_malloc(sizeof(struct avp_spec));
		if (!s_attr) { yyerror("No memory left"); YYABORT; }
		else s_attr->type = 0;
	}
    break;

  case 619:

/* Line 1806 of yacc.c  */
#line 2711 "cfg.y"
    { (yyval.attr) = s_attr; }
    break;

  case 620:

/* Line 1806 of yacc.c  */
#line 2714 "cfg.y"
    {
		s_attr->type|= (AVP_NAME_STR | ((yyvsp[(4) - (5)].intval)<0?AVP_INDEX_BACKWARD:AVP_INDEX_FORWARD));
		s_attr->index = ((yyvsp[(4) - (5)].intval)<0?-(yyvsp[(4) - (5)].intval):(yyvsp[(4) - (5)].intval));
		(yyval.attr) = s_attr;
	}
    break;

  case 621:

/* Line 1806 of yacc.c  */
#line 2721 "cfg.y"
    {
		s_attr->type|= AVP_INDEX_ALL;
		(yyval.attr) = s_attr;
	}
    break;

  case 628:

/* Line 1806 of yacc.c  */
#line 2743 "cfg.y"
    {
		if ((yyvsp[(1) - (1)].lval)->type==LV_AVP){
			s_attr = pkg_malloc(sizeof(struct avp_spec));
			if (!s_attr) { yyerror("No memory left"); YYABORT; }
			else{
				*s_attr=(yyvsp[(1) - (1)].lval)->lv.avps;
			}
			(yyval.attr)=s_attr;
		}else
			(yyval.attr)=0; /* not an avp, a pvar */
		pkg_free((yyvsp[(1) - (1)].lval));
	}
    break;

  case 629:

/* Line 1806 of yacc.c  */
#line 2755 "cfg.y"
    {
		avp_spec_t *avp_spec;
		str s;
		int type, idx;
		avp_spec = pkg_malloc(sizeof(*avp_spec));
		if (!avp_spec) {
			yyerror("Not enough memory");
			YYABORT;
		}
		s.s = (yyvsp[(1) - (1)].strval);
		if (s.s[0] == '$')
			s.s++;
		s.len = strlen(s.s);
		if (parse_avp_name(&s, &type, &avp_spec->name, &idx)) {
			yyerror("error when parsing AVP");
			pkg_free(avp_spec);
			YYABORT;
		}
		avp_spec->type = type;
		avp_spec->index = idx;
		(yyval.attr) = avp_spec;
	}
    break;

  case 630:

/* Line 1806 of yacc.c  */
#line 2779 "cfg.y"
    {
			pv_spec=pkg_malloc(sizeof(*pv_spec));
			if (!pv_spec) {
				yyerror("Not enough memory");
				YYABORT;
			}
			memset(pv_spec, 0, sizeof(*pv_spec));
			s_tmp.s=(yyvsp[(1) - (1)].strval); s_tmp.len=strlen((yyvsp[(1) - (1)].strval));
			if (pv_parse_spec(&s_tmp, pv_spec)==0){
				yyerror("unknown script pseudo variable %s", (yyvsp[(1) - (1)].strval) );
				pkg_free(pv_spec);
				pv_spec=0;
				YYABORT;
			}
			(yyval.pvar)=pv_spec;
		}
    break;

  case 631:

/* Line 1806 of yacc.c  */
#line 2797 "cfg.y"
    {
				lval_tmp=pkg_malloc(sizeof(*lval_tmp));
				if (!lval_tmp) {
					yyerror("Not enough memory");
					YYABORT;
				}
				memset(lval_tmp, 0, sizeof(*lval_tmp));
				s_tmp.s=(yyvsp[(1) - (1)].strval); s_tmp.len=strlen(s_tmp.s);
				if (pv_parse_spec2(&s_tmp, &lval_tmp->lv.pvs, 1)==0){
					/* not a pvar, try avps */
					/* lval_tmp might be partially filled by the failed
					   pv_parse_spec2() (especially if the avp name is the
					   same as a pv class) => clean it again */
					memset(lval_tmp, 0, sizeof(*lval_tmp));
					lval_tmp->lv.avps.type|= AVP_NAME_STR;
					lval_tmp->lv.avps.name.s.s = s_tmp.s+1;
					lval_tmp->lv.avps.name.s.len = s_tmp.len-1;
					lval_tmp->type=LV_AVP;
				}else{
					lval_tmp->type=LV_PVAR;
				}
				(yyval.lval) = lval_tmp;
				DBG("parsed ambigous avp/pvar \"%.*s\" to %d\n",
							s_tmp.len, s_tmp.s, lval_tmp->type);
			}
    break;

  case 632:

/* Line 1806 of yacc.c  */
#line 2832 "cfg.y"
    { (yyval.intval) = ASSIGN_T; }
    break;

  case 633:

/* Line 1806 of yacc.c  */
#line 2836 "cfg.y"
    {
					lval_tmp=pkg_malloc(sizeof(*lval_tmp));
					if (!lval_tmp) {
						yyerror("Not enough memory");
						YYABORT;
					}
					lval_tmp->type=LV_AVP; lval_tmp->lv.avps=*(yyvsp[(1) - (1)].attr);
					pkg_free((yyvsp[(1) - (1)].attr)); /* free the avp spec we just copied */
					(yyval.lval)=lval_tmp;
				}
    break;

  case 634:

/* Line 1806 of yacc.c  */
#line 2846 "cfg.y"
    {
					if (!pv_is_w((yyvsp[(1) - (1)].pvar)))
						yyerror("read only pvar in assignment left side");
					if ((yyvsp[(1) - (1)].pvar)->trans!=0)
						yyerror("pvar with transformations in assignment"
								" left side");
					lval_tmp=pkg_malloc(sizeof(*lval_tmp));
					if (!lval_tmp) {
						yyerror("Not enough memory");
						YYABORT;
					}
					lval_tmp->type=LV_PVAR; lval_tmp->lv.pvs=*((yyvsp[(1) - (1)].pvar));
					pkg_free((yyvsp[(1) - (1)].pvar)); /* free the pvar spec we just copied */
					(yyval.lval)=lval_tmp;
				}
    break;

  case 635:

/* Line 1806 of yacc.c  */
#line 2861 "cfg.y"
    {
					if (((yyvsp[(1) - (1)].lval))->type==LV_PVAR){
						if (!pv_is_w(&((yyvsp[(1) - (1)].lval))->lv.pvs))
							yyerror("read only pvar in assignment left side");
						if ((yyvsp[(1) - (1)].lval)->lv.pvs.trans!=0)
							yyerror("pvar with transformations in assignment"
									" left side");
					}
					(yyval.lval)=(yyvsp[(1) - (1)].lval);
				}
    break;

  case 636:

/* Line 1806 of yacc.c  */
#line 2873 "cfg.y"
    {(yyval.rv_expr)=mk_rve_rval(RV_INT, (void*)(yyvsp[(1) - (1)].intval)); }
    break;

  case 637:

/* Line 1806 of yacc.c  */
#line 2874 "cfg.y"
    {	s_tmp.s=(yyvsp[(1) - (1)].strval); s_tmp.len=strlen((yyvsp[(1) - (1)].strval));
							(yyval.rv_expr)=mk_rve_rval(RV_STR, &s_tmp); }
    break;

  case 638:

/* Line 1806 of yacc.c  */
#line 2876 "cfg.y"
    {(yyval.rv_expr)=mk_rve_rval(RV_AVP, (yyvsp[(1) - (1)].attr)); pkg_free((yyvsp[(1) - (1)].attr)); }
    break;

  case 639:

/* Line 1806 of yacc.c  */
#line 2877 "cfg.y"
    {(yyval.rv_expr)=mk_rve_rval(RV_PVAR, (yyvsp[(1) - (1)].pvar)); pkg_free((yyvsp[(1) - (1)].pvar)); }
    break;

  case 640:

/* Line 1806 of yacc.c  */
#line 2878 "cfg.y"
    {
							switch((yyvsp[(1) - (1)].lval)->type){
								case LV_AVP:
									(yyval.rv_expr)=mk_rve_rval(RV_AVP, &(yyvsp[(1) - (1)].lval)->lv.avps);
									break;
								case LV_PVAR:
									(yyval.rv_expr)=mk_rve_rval(RV_PVAR, &(yyvsp[(1) - (1)].lval)->lv.pvs);
									break;
								default:
									yyerror("BUG: invalid lvalue type ");
									YYABORT;
							}
							pkg_free((yyvsp[(1) - (1)].lval)); /* not needed anymore */
						}
    break;

  case 641:

/* Line 1806 of yacc.c  */
#line 2892 "cfg.y"
    {(yyval.rv_expr)=mk_rve_rval(RV_SEL, (yyvsp[(1) - (1)].select)); pkg_free((yyvsp[(1) - (1)].select)); }
    break;

  case 642:

/* Line 1806 of yacc.c  */
#line 2893 "cfg.y"
    {(yyval.rv_expr)=mk_rve_rval(RV_ACTION_ST, (yyvsp[(1) - (1)].action)); }
    break;

  case 643:

/* Line 1806 of yacc.c  */
#line 2894 "cfg.y"
    { (yyval.rv_expr)=mk_rve_rval(RV_BEXPR, (yyvsp[(1) - (1)].expr)); }
    break;

  case 644:

/* Line 1806 of yacc.c  */
#line 2895 "cfg.y"
    {(yyval.rv_expr)=mk_rve_rval(RV_ACTION_ST, (yyvsp[(2) - (3)].action)); }
    break;

  case 645:

/* Line 1806 of yacc.c  */
#line 2896 "cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad command block"); }
    break;

  case 646:

/* Line 1806 of yacc.c  */
#line 2897 "cfg.y"
    {(yyval.rv_expr)=mk_rve_rval(RV_ACTION_ST, (yyvsp[(2) - (3)].action)); }
    break;

  case 647:

/* Line 1806 of yacc.c  */
#line 2898 "cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
    break;

  case 648:

/* Line 1806 of yacc.c  */
#line 2902 "cfg.y"
    { (yyval.intval)=RVE_LNOT_OP; }
    break;

  case 649:

/* Line 1806 of yacc.c  */
#line 2903 "cfg.y"
    { (yyval.intval)=RVE_BNOT_OP; }
    break;

  case 650:

/* Line 1806 of yacc.c  */
#line 2904 "cfg.y"
    { (yyval.intval)=RVE_UMINUS_OP; }
    break;

  case 651:

/* Line 1806 of yacc.c  */
#line 2917 "cfg.y"
    { (yyval.rv_expr)=(yyvsp[(1) - (1)].rv_expr);
										if ((yyval.rv_expr)==0){
											/*yyerror("out of memory\n");*/
											YYERROR;
										}
									}
    break;

  case 652:

/* Line 1806 of yacc.c  */
#line 2923 "cfg.y"
    {(yyval.rv_expr)=mk_rve1((yyvsp[(1) - (2)].intval), (yyvsp[(2) - (2)].rv_expr)); }
    break;

  case 653:

/* Line 1806 of yacc.c  */
#line 2924 "cfg.y"
    {(yyval.rv_expr)=mk_rve1(RVE_INT_OP, (yyvsp[(2) - (2)].rv_expr)); }
    break;

  case 654:

/* Line 1806 of yacc.c  */
#line 2925 "cfg.y"
    {(yyval.rv_expr)=mk_rve1(RVE_STR_OP, (yyvsp[(2) - (2)].rv_expr)); }
    break;

  case 655:

/* Line 1806 of yacc.c  */
#line 2926 "cfg.y"
    {(yyval.rv_expr)=mk_rve2(RVE_PLUS_OP, (yyvsp[(1) - (3)].rv_expr), (yyvsp[(3) - (3)].rv_expr)); }
    break;

  case 656:

/* Line 1806 of yacc.c  */
#line 2927 "cfg.y"
    {(yyval.rv_expr)=mk_rve2(RVE_MINUS_OP, (yyvsp[(1) - (3)].rv_expr), (yyvsp[(3) - (3)].rv_expr)); }
    break;

  case 657:

/* Line 1806 of yacc.c  */
#line 2928 "cfg.y"
    {(yyval.rv_expr)=mk_rve2(RVE_MUL_OP, (yyvsp[(1) - (3)].rv_expr), (yyvsp[(3) - (3)].rv_expr)); }
    break;

  case 658:

/* Line 1806 of yacc.c  */
#line 2929 "cfg.y"
    {(yyval.rv_expr)=mk_rve2(RVE_DIV_OP, (yyvsp[(1) - (3)].rv_expr), (yyvsp[(3) - (3)].rv_expr)); }
    break;

  case 659:

/* Line 1806 of yacc.c  */
#line 2930 "cfg.y"
    {(yyval.rv_expr)=mk_rve2(RVE_MOD_OP, (yyvsp[(1) - (3)].rv_expr), (yyvsp[(3) - (3)].rv_expr)); }
    break;

  case 660:

/* Line 1806 of yacc.c  */
#line 2931 "cfg.y"
    {(yyval.rv_expr)=mk_rve2(RVE_BOR_OP, (yyvsp[(1) - (3)].rv_expr),  (yyvsp[(3) - (3)].rv_expr)); }
    break;

  case 661:

/* Line 1806 of yacc.c  */
#line 2932 "cfg.y"
    {(yyval.rv_expr)=mk_rve2(RVE_BAND_OP, (yyvsp[(1) - (3)].rv_expr),  (yyvsp[(3) - (3)].rv_expr));}
    break;

  case 662:

/* Line 1806 of yacc.c  */
#line 2933 "cfg.y"
    {(yyval.rv_expr)=mk_rve2(RVE_BXOR_OP, (yyvsp[(1) - (3)].rv_expr),  (yyvsp[(3) - (3)].rv_expr));}
    break;

  case 663:

/* Line 1806 of yacc.c  */
#line 2934 "cfg.y"
    {(yyval.rv_expr)=mk_rve2(RVE_BLSHIFT_OP, (yyvsp[(1) - (3)].rv_expr),  (yyvsp[(3) - (3)].rv_expr));}
    break;

  case 664:

/* Line 1806 of yacc.c  */
#line 2935 "cfg.y"
    {(yyval.rv_expr)=mk_rve2(RVE_BRSHIFT_OP, (yyvsp[(1) - (3)].rv_expr),  (yyvsp[(3) - (3)].rv_expr));}
    break;

  case 665:

/* Line 1806 of yacc.c  */
#line 2936 "cfg.y"
    { (yyval.rv_expr)=mk_rve2( (yyvsp[(2) - (3)].intval), (yyvsp[(1) - (3)].rv_expr), (yyvsp[(3) - (3)].rv_expr));}
    break;

  case 666:

/* Line 1806 of yacc.c  */
#line 2938 "cfg.y"
    { (yyval.rv_expr)=mk_rve2( (yyvsp[(2) - (3)].intval), (yyvsp[(1) - (3)].rv_expr), (yyvsp[(3) - (3)].rv_expr));}
    break;

  case 667:

/* Line 1806 of yacc.c  */
#line 2939 "cfg.y"
    { (yyval.rv_expr)=mk_rve2(RVE_LAND_OP, (yyvsp[(1) - (3)].rv_expr), (yyvsp[(3) - (3)].rv_expr));}
    break;

  case 668:

/* Line 1806 of yacc.c  */
#line 2940 "cfg.y"
    { (yyval.rv_expr)=mk_rve2(RVE_LOR_OP, (yyvsp[(1) - (3)].rv_expr), (yyvsp[(3) - (3)].rv_expr));}
    break;

  case 669:

/* Line 1806 of yacc.c  */
#line 2941 "cfg.y"
    { (yyval.rv_expr)=(yyvsp[(2) - (3)].rv_expr);}
    break;

  case 670:

/* Line 1806 of yacc.c  */
#line 2942 "cfg.y"
    { (yyval.rv_expr)=mk_rve1(RVE_STRLEN_OP, (yyvsp[(3) - (4)].rv_expr));}
    break;

  case 671:

/* Line 1806 of yacc.c  */
#line 2943 "cfg.y"
    {(yyval.rv_expr)=mk_rve1(RVE_STREMPTY_OP, (yyvsp[(3) - (4)].rv_expr));}
    break;

  case 672:

/* Line 1806 of yacc.c  */
#line 2944 "cfg.y"
    { (yyval.rv_expr)=mk_rve1(RVE_DEFINED_OP, (yyvsp[(2) - (2)].rv_expr));}
    break;

  case 673:

/* Line 1806 of yacc.c  */
#line 2945 "cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
    break;

  case 674:

/* Line 1806 of yacc.c  */
#line 2946 "cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
    break;

  case 675:

/* Line 1806 of yacc.c  */
#line 2947 "cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
    break;

  case 676:

/* Line 1806 of yacc.c  */
#line 2948 "cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
    break;

  case 677:

/* Line 1806 of yacc.c  */
#line 2949 "cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
    break;

  case 678:

/* Line 1806 of yacc.c  */
#line 2950 "cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
    break;

  case 679:

/* Line 1806 of yacc.c  */
#line 2951 "cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
    break;

  case 680:

/* Line 1806 of yacc.c  */
#line 2952 "cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
    break;

  case 681:

/* Line 1806 of yacc.c  */
#line 2953 "cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
    break;

  case 682:

/* Line 1806 of yacc.c  */
#line 2954 "cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
    break;

  case 683:

/* Line 1806 of yacc.c  */
#line 2956 "cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
    break;

  case 684:

/* Line 1806 of yacc.c  */
#line 2958 "cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
    break;

  case 685:

/* Line 1806 of yacc.c  */
#line 2959 "cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
    break;

  case 686:

/* Line 1806 of yacc.c  */
#line 2960 "cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
    break;

  case 687:

/* Line 1806 of yacc.c  */
#line 2961 "cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
    break;

  case 688:

/* Line 1806 of yacc.c  */
#line 2962 "cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
    break;

  case 689:

/* Line 1806 of yacc.c  */
#line 2963 "cfg.y"
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
    break;

  case 690:

/* Line 1806 of yacc.c  */
#line 2966 "cfg.y"
    { (yyval.action)=mk_action((yyvsp[(2) - (3)].intval), 2, LVAL_ST, (yyvsp[(1) - (3)].lval), 
														 	  RVE_ST, (yyvsp[(3) - (3)].rv_expr));
											set_cfg_pos((yyval.action));
										}
    break;

  case 691:

/* Line 1806 of yacc.c  */
#line 2984 "cfg.y"
    { (yyval.intval) = 1; }
    break;

  case 692:

/* Line 1806 of yacc.c  */
#line 2985 "cfg.y"
    { (yyval.intval) = 0; }
    break;

  case 693:

/* Line 1806 of yacc.c  */
#line 2986 "cfg.y"
    { (yyval.intval) = -1; }
    break;

  case 694:

/* Line 1806 of yacc.c  */
#line 2989 "cfg.y"
    { (yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); }
    break;

  case 695:

/* Line 1806 of yacc.c  */
#line 2990 "cfg.y"
    { (yyval.action)=mk_action(	FORWARD_T, 2, STRING_ST, (yyvsp[(3) - (4)].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
    break;

  case 696:

/* Line 1806 of yacc.c  */
#line 2991 "cfg.y"
    { (yyval.action)=mk_action(	FORWARD_T, 2, STRING_ST, (yyvsp[(3) - (4)].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
    break;

  case 697:

/* Line 1806 of yacc.c  */
#line 2992 "cfg.y"
    { (yyval.action)=mk_action(	FORWARD_T, 2, IP_ST, (void*)(yyvsp[(3) - (4)].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
    break;

  case 698:

/* Line 1806 of yacc.c  */
#line 2993 "cfg.y"
    { (yyval.action)=mk_action(FORWARD_T, 2, STRING_ST, (yyvsp[(3) - (6)].strval), NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action)); }
    break;

  case 699:

/* Line 1806 of yacc.c  */
#line 2994 "cfg.y"
    {(yyval.action)=mk_action(FORWARD_T, 2, STRING_ST, (yyvsp[(3) - (6)].strval), NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action)); }
    break;

  case 700:

/* Line 1806 of yacc.c  */
#line 2995 "cfg.y"
    { (yyval.action)=mk_action(FORWARD_T, 2, IP_ST, (void*)(yyvsp[(3) - (6)].ipaddr), NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action)); }
    break;

  case 701:

/* Line 1806 of yacc.c  */
#line 2996 "cfg.y"
    { (yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); }
    break;

  case 702:

/* Line 1806 of yacc.c  */
#line 2997 "cfg.y"
    {(yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action)); }
    break;

  case 703:

/* Line 1806 of yacc.c  */
#line 2998 "cfg.y"
    { (yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
    break;

  case 704:

/* Line 1806 of yacc.c  */
#line 2999 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
    break;

  case 705:

/* Line 1806 of yacc.c  */
#line 3000 "cfg.y"
    { (yyval.action)=0; yyerror("bad forward argument"); }
    break;

  case 706:

/* Line 1806 of yacc.c  */
#line 3001 "cfg.y"
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[(3) - (4)].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
    break;

  case 707:

/* Line 1806 of yacc.c  */
#line 3002 "cfg.y"
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[(3) - (4)].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
    break;

  case 708:

/* Line 1806 of yacc.c  */
#line 3003 "cfg.y"
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, IP_ST, (void*)(yyvsp[(3) - (4)].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
    break;

  case 709:

/* Line 1806 of yacc.c  */
#line 3004 "cfg.y"
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[(3) - (6)].strval), NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action)); }
    break;

  case 710:

/* Line 1806 of yacc.c  */
#line 3005 "cfg.y"
    {(yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[(3) - (6)].strval), NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action)); }
    break;

  case 711:

/* Line 1806 of yacc.c  */
#line 3006 "cfg.y"
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, IP_ST, (void*)(yyvsp[(3) - (6)].ipaddr), NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action)); }
    break;

  case 712:

/* Line 1806 of yacc.c  */
#line 3007 "cfg.y"
    {(yyval.action)=mk_action(FORWARD_UDP_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); }
    break;

  case 713:

/* Line 1806 of yacc.c  */
#line 3008 "cfg.y"
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action)); }
    break;

  case 714:

/* Line 1806 of yacc.c  */
#line 3009 "cfg.y"
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
    break;

  case 715:

/* Line 1806 of yacc.c  */
#line 3010 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
    break;

  case 716:

/* Line 1806 of yacc.c  */
#line 3011 "cfg.y"
    { (yyval.action)=0; yyerror("bad forward_udp argument"); }
    break;

  case 717:

/* Line 1806 of yacc.c  */
#line 3012 "cfg.y"
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[(3) - (4)].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
    break;

  case 718:

/* Line 1806 of yacc.c  */
#line 3013 "cfg.y"
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[(3) - (4)].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
    break;

  case 719:

/* Line 1806 of yacc.c  */
#line 3014 "cfg.y"
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, IP_ST, (void*)(yyvsp[(3) - (4)].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
    break;

  case 720:

/* Line 1806 of yacc.c  */
#line 3015 "cfg.y"
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[(3) - (6)].strval), NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action)); }
    break;

  case 721:

/* Line 1806 of yacc.c  */
#line 3016 "cfg.y"
    {(yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[(3) - (6)].strval), NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action)); }
    break;

  case 722:

/* Line 1806 of yacc.c  */
#line 3017 "cfg.y"
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, IP_ST, (void*)(yyvsp[(3) - (6)].ipaddr), NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action)); }
    break;

  case 723:

/* Line 1806 of yacc.c  */
#line 3018 "cfg.y"
    {(yyval.action)=mk_action(FORWARD_TCP_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); }
    break;

  case 724:

/* Line 1806 of yacc.c  */
#line 3019 "cfg.y"
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action)); }
    break;

  case 725:

/* Line 1806 of yacc.c  */
#line 3020 "cfg.y"
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
    break;

  case 726:

/* Line 1806 of yacc.c  */
#line 3021 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
    break;

  case 727:

/* Line 1806 of yacc.c  */
#line 3022 "cfg.y"
    { (yyval.action)=0; yyerror("bad forward_tcp argument"); }
    break;

  case 728:

/* Line 1806 of yacc.c  */
#line 3023 "cfg.y"
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[(3) - (4)].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
    break;

  case 729:

/* Line 1806 of yacc.c  */
#line 3031 "cfg.y"
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[(3) - (4)].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
    break;

  case 730:

/* Line 1806 of yacc.c  */
#line 3039 "cfg.y"
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, IP_ST, (void*)(yyvsp[(3) - (4)].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
    break;

  case 731:

/* Line 1806 of yacc.c  */
#line 3047 "cfg.y"
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[(3) - (6)].strval), NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
    break;

  case 732:

/* Line 1806 of yacc.c  */
#line 3055 "cfg.y"
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[(3) - (6)].strval), NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
    break;

  case 733:

/* Line 1806 of yacc.c  */
#line 3063 "cfg.y"
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, IP_ST, (void*)(yyvsp[(3) - (6)].ipaddr), NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
					}
    break;

  case 734:

/* Line 1806 of yacc.c  */
#line 3071 "cfg.y"
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
    break;

  case 735:

/* Line 1806 of yacc.c  */
#line 3079 "cfg.y"
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
    break;

  case 736:

/* Line 1806 of yacc.c  */
#line 3087 "cfg.y"
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
    break;

  case 737:

/* Line 1806 of yacc.c  */
#line 3095 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
    break;

  case 738:

/* Line 1806 of yacc.c  */
#line 3096 "cfg.y"
    { (yyval.action)=0; 
									yyerror("bad forward_tls argument"); }
    break;

  case 739:

/* Line 1806 of yacc.c  */
#line 3098 "cfg.y"
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[(3) - (4)].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
    break;

  case 740:

/* Line 1806 of yacc.c  */
#line 3106 "cfg.y"
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[(3) - (4)].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
    break;

  case 741:

/* Line 1806 of yacc.c  */
#line 3114 "cfg.y"
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, IP_ST, (void*)(yyvsp[(3) - (4)].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
    break;

  case 742:

/* Line 1806 of yacc.c  */
#line 3122 "cfg.y"
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[(3) - (6)].strval), NUMBER_ST,
							(void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
    break;

  case 743:

/* Line 1806 of yacc.c  */
#line 3131 "cfg.y"
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[(3) - (6)].strval), NUMBER_ST,
							(void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
    break;

  case 744:

/* Line 1806 of yacc.c  */
#line 3140 "cfg.y"
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, IP_ST, (void*)(yyvsp[(3) - (6)].ipaddr), NUMBER_ST, 
							(void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
					}
    break;

  case 745:

/* Line 1806 of yacc.c  */
#line 3149 "cfg.y"
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
    break;

  case 746:

/* Line 1806 of yacc.c  */
#line 3157 "cfg.y"
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, URIHOST_ST, 0, NUMBER_ST,
							(void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
    break;

  case 747:

/* Line 1806 of yacc.c  */
#line 3166 "cfg.y"
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
    break;

  case 748:

/* Line 1806 of yacc.c  */
#line 3174 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
    break;

  case 749:

/* Line 1806 of yacc.c  */
#line 3175 "cfg.y"
    { (yyval.action)=0; 
									yyerror("bad forward_tls argument"); }
    break;

  case 750:

/* Line 1806 of yacc.c  */
#line 3177 "cfg.y"
    {(yyval.action)=mk_action(LOG_T, 2, NUMBER_ST,
										(void*)(L_DBG+1), STRING_ST, (yyvsp[(3) - (4)].strval));
									set_cfg_pos((yyval.action)); }
    break;

  case 751:

/* Line 1806 of yacc.c  */
#line 3180 "cfg.y"
    {(yyval.action)=mk_action(LOG_T, 2, NUMBER_ST, (void*)(yyvsp[(3) - (6)].intval), STRING_ST, (yyvsp[(5) - (6)].strval)); set_cfg_pos((yyval.action)); }
    break;

  case 752:

/* Line 1806 of yacc.c  */
#line 3181 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
    break;

  case 753:

/* Line 1806 of yacc.c  */
#line 3182 "cfg.y"
    { (yyval.action)=0; yyerror("bad log argument"); }
    break;

  case 754:

/* Line 1806 of yacc.c  */
#line 3183 "cfg.y"
    {
							if (check_flag((yyvsp[(3) - (4)].intval))==-1)
								yyerror("bad flag value");
							(yyval.action)=mk_action(SETFLAG_T, 1, NUMBER_ST,
													(void*)(yyvsp[(3) - (4)].intval));
							set_cfg_pos((yyval.action));
									}
    break;

  case 755:

/* Line 1806 of yacc.c  */
#line 3190 "cfg.y"
    {
							i_tmp=get_flag_no((yyvsp[(3) - (4)].strval), strlen((yyvsp[(3) - (4)].strval)));
							if (i_tmp<0) yyerror("flag not declared");
							(yyval.action)=mk_action(SETFLAG_T, 1, NUMBER_ST,
										(void*)(long)i_tmp);
							set_cfg_pos((yyval.action));
									}
    break;

  case 756:

/* Line 1806 of yacc.c  */
#line 3197 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
    break;

  case 757:

/* Line 1806 of yacc.c  */
#line 3198 "cfg.y"
    {
							if (check_flag((yyvsp[(3) - (4)].intval))==-1)
								yyerror("bad flag value");
							(yyval.action)=mk_action(RESETFLAG_T, 1, NUMBER_ST, (void*)(yyvsp[(3) - (4)].intval));
							set_cfg_pos((yyval.action));
									}
    break;

  case 758:

/* Line 1806 of yacc.c  */
#line 3204 "cfg.y"
    {
							i_tmp=get_flag_no((yyvsp[(3) - (4)].strval), strlen((yyvsp[(3) - (4)].strval)));
							if (i_tmp<0) yyerror("flag not declared");
							(yyval.action)=mk_action(RESETFLAG_T, 1, NUMBER_ST,
										(void*)(long)i_tmp);
							set_cfg_pos((yyval.action));
									}
    break;

  case 759:

/* Line 1806 of yacc.c  */
#line 3211 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
    break;

  case 760:

/* Line 1806 of yacc.c  */
#line 3212 "cfg.y"
    {
							if (check_flag((yyvsp[(3) - (4)].intval))==-1)
								yyerror("bad flag value");
							(yyval.action)=mk_action(ISFLAGSET_T, 1, NUMBER_ST, (void*)(yyvsp[(3) - (4)].intval));
							set_cfg_pos((yyval.action));
									}
    break;

  case 761:

/* Line 1806 of yacc.c  */
#line 3218 "cfg.y"
    {
							i_tmp=get_flag_no((yyvsp[(3) - (4)].strval), strlen((yyvsp[(3) - (4)].strval)));
							if (i_tmp<0) yyerror("flag not declared");
							(yyval.action)=mk_action(ISFLAGSET_T, 1, NUMBER_ST,
										(void*)(long)i_tmp);
							set_cfg_pos((yyval.action));
									}
    break;

  case 762:

/* Line 1806 of yacc.c  */
#line 3225 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
    break;

  case 763:

/* Line 1806 of yacc.c  */
#line 3226 "cfg.y"
    {
		i_tmp=get_avpflag_no((yyvsp[(5) - (6)].strval));
		if (i_tmp==0) yyerror("avpflag not declared");
		(yyval.action)=mk_action(AVPFLAG_OPER_T, 3, AVP_ST, (yyvsp[(3) - (6)].attr), NUMBER_ST, (void*)(long)i_tmp, NUMBER_ST, (void*)(yyvsp[(1) - (6)].intval));
		set_cfg_pos((yyval.action));
	}
    break;

  case 764:

/* Line 1806 of yacc.c  */
#line 3232 "cfg.y"
    {
		(yyval.action)=0; yyerror("error parsing flag name");
	}
    break;

  case 765:

/* Line 1806 of yacc.c  */
#line 3235 "cfg.y"
    {
		(yyval.action)=0; yyerror("error parsing first parameter (avp or string)");
	}
    break;

  case 766:

/* Line 1806 of yacc.c  */
#line 3238 "cfg.y"
    { (yyval.action)=0; yyerror("bad parameters"); }
    break;

  case 767:

/* Line 1806 of yacc.c  */
#line 3239 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
    break;

  case 768:

/* Line 1806 of yacc.c  */
#line 3240 "cfg.y"
    {(yyval.action)=mk_action(ERROR_T, 2, STRING_ST, (yyvsp[(3) - (6)].strval), STRING_ST, (yyvsp[(5) - (6)].strval));
			set_cfg_pos((yyval.action));
	}
    break;

  case 769:

/* Line 1806 of yacc.c  */
#line 3243 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
    break;

  case 770:

/* Line 1806 of yacc.c  */
#line 3244 "cfg.y"
    { (yyval.action)=0; yyerror("bad error argument"); }
    break;

  case 771:

/* Line 1806 of yacc.c  */
#line 3245 "cfg.y"
    {
		if ((yyvsp[(3) - (4)].rv_expr)) {
			(yyval.action) = mk_action(ROUTE_T, 1, RVE_ST, (void*)(yyvsp[(3) - (4)].rv_expr));
			set_cfg_pos((yyval.action));
		} else {
			(yyval.action) = 0;
			YYERROR;
		}
	}
    break;

  case 772:

/* Line 1806 of yacc.c  */
#line 3254 "cfg.y"
    {
		if ((yyvsp[(3) - (4)].strval)) {
			(yyval.action) = mk_action(ROUTE_T, 1, STRING_ST, (void*)(yyvsp[(3) - (4)].strval));
			set_cfg_pos((yyval.action));
		} else {
			(yyval.action) = 0;
			YYERROR;
		}
	}
    break;

  case 773:

/* Line 1806 of yacc.c  */
#line 3263 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
    break;

  case 774:

/* Line 1806 of yacc.c  */
#line 3264 "cfg.y"
    { (yyval.action)=0; yyerror("bad route argument"); }
    break;

  case 775:

/* Line 1806 of yacc.c  */
#line 3265 "cfg.y"
    { (yyval.action)=mk_action(EXEC_T, 1, STRING_ST, (yyvsp[(3) - (4)].strval)); set_cfg_pos((yyval.action)); }
    break;

  case 776:

/* Line 1806 of yacc.c  */
#line 3266 "cfg.y"
    { (yyval.action)=mk_action(SET_HOST_T, 1, STRING_ST, (yyvsp[(3) - (4)].strval)); set_cfg_pos((yyval.action)); }
    break;

  case 777:

/* Line 1806 of yacc.c  */
#line 3267 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
    break;

  case 778:

/* Line 1806 of yacc.c  */
#line 3268 "cfg.y"
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
    break;

  case 779:

/* Line 1806 of yacc.c  */
#line 3269 "cfg.y"
    { (yyval.action)=mk_action(PREFIX_T, 1, STRING_ST,  (yyvsp[(3) - (4)].strval)); set_cfg_pos((yyval.action)); }
    break;

  case 780:

/* Line 1806 of yacc.c  */
#line 3270 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
    break;

  case 781:

/* Line 1806 of yacc.c  */
#line 3271 "cfg.y"
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
    break;

  case 782:

/* Line 1806 of yacc.c  */
#line 3272 "cfg.y"
    { (yyval.action)=mk_action(STRIP_TAIL_T, 1, NUMBER_ST, (void*)(yyvsp[(3) - (4)].intval)); set_cfg_pos((yyval.action)); }
    break;

  case 783:

/* Line 1806 of yacc.c  */
#line 3273 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
    break;

  case 784:

/* Line 1806 of yacc.c  */
#line 3274 "cfg.y"
    { (yyval.action)=0; yyerror("bad argument, number expected"); }
    break;

  case 785:

/* Line 1806 of yacc.c  */
#line 3275 "cfg.y"
    { (yyval.action)=mk_action(STRIP_T, 1, NUMBER_ST, (void*) (yyvsp[(3) - (4)].intval)); set_cfg_pos((yyval.action)); }
    break;

  case 786:

/* Line 1806 of yacc.c  */
#line 3276 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
    break;

  case 787:

/* Line 1806 of yacc.c  */
#line 3277 "cfg.y"
    { (yyval.action)=0; yyerror("bad argument, number expected"); }
    break;

  case 788:

/* Line 1806 of yacc.c  */
#line 3278 "cfg.y"
    { (yyval.action)=mk_action(SET_USERPHONE_T, 0); set_cfg_pos((yyval.action)); }
    break;

  case 789:

/* Line 1806 of yacc.c  */
#line 3279 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
    break;

  case 790:

/* Line 1806 of yacc.c  */
#line 3280 "cfg.y"
    {
			(yyval.action)=mk_action(REMOVE_BRANCH_T, 1, NUMBER_ST, (void*)(yyvsp[(3) - (4)].intval));
			set_cfg_pos((yyval.action));
	}
    break;

  case 791:

/* Line 1806 of yacc.c  */
#line 3284 "cfg.y"
    {
			(yyval.action)=mk_action(REMOVE_BRANCH_T, 0);
			set_cfg_pos((yyval.action));
	}
    break;

  case 792:

/* Line 1806 of yacc.c  */
#line 3288 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
    break;

  case 793:

/* Line 1806 of yacc.c  */
#line 3289 "cfg.y"
    { (yyval.action)=0; yyerror("bad argument, number expected"); }
    break;

  case 794:

/* Line 1806 of yacc.c  */
#line 3290 "cfg.y"
    { (yyval.action)=mk_action(CLEAR_BRANCHES_T, 0); set_cfg_pos((yyval.action)); }
    break;

  case 795:

/* Line 1806 of yacc.c  */
#line 3291 "cfg.y"
    { (yyval.action)=mk_action(SET_HOSTPORT_T, 1, STRING_ST, (yyvsp[(3) - (4)].strval)); set_cfg_pos((yyval.action)); }
    break;

  case 796:

/* Line 1806 of yacc.c  */
#line 3292 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
    break;

  case 797:

/* Line 1806 of yacc.c  */
#line 3293 "cfg.y"
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
    break;

  case 798:

/* Line 1806 of yacc.c  */
#line 3294 "cfg.y"
    { (yyval.action)=mk_action(SET_HOSTPORTTRANS_T, 1, STRING_ST, (yyvsp[(3) - (4)].strval)); set_cfg_pos((yyval.action)); }
    break;

  case 799:

/* Line 1806 of yacc.c  */
#line 3295 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
    break;

  case 800:

/* Line 1806 of yacc.c  */
#line 3296 "cfg.y"
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
    break;

  case 801:

/* Line 1806 of yacc.c  */
#line 3297 "cfg.y"
    { (yyval.action)=mk_action(SET_PORT_T, 1, STRING_ST, (yyvsp[(3) - (4)].strval)); set_cfg_pos((yyval.action)); }
    break;

  case 802:

/* Line 1806 of yacc.c  */
#line 3298 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
    break;

  case 803:

/* Line 1806 of yacc.c  */
#line 3299 "cfg.y"
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
    break;

  case 804:

/* Line 1806 of yacc.c  */
#line 3300 "cfg.y"
    { (yyval.action)=mk_action(SET_USER_T, 1, STRING_ST, (yyvsp[(3) - (4)].strval)); set_cfg_pos((yyval.action)); }
    break;

  case 805:

/* Line 1806 of yacc.c  */
#line 3301 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
    break;

  case 806:

/* Line 1806 of yacc.c  */
#line 3302 "cfg.y"
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
    break;

  case 807:

/* Line 1806 of yacc.c  */
#line 3303 "cfg.y"
    { (yyval.action)=mk_action(SET_USERPASS_T, 1, STRING_ST, (yyvsp[(3) - (4)].strval)); set_cfg_pos((yyval.action)); }
    break;

  case 808:

/* Line 1806 of yacc.c  */
#line 3304 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
    break;

  case 809:

/* Line 1806 of yacc.c  */
#line 3305 "cfg.y"
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
    break;

  case 810:

/* Line 1806 of yacc.c  */
#line 3306 "cfg.y"
    { (yyval.action)=mk_action(SET_URI_T, 1, STRING_ST,(yyvsp[(3) - (4)].strval)); set_cfg_pos((yyval.action)); }
    break;

  case 811:

/* Line 1806 of yacc.c  */
#line 3307 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
    break;

  case 812:

/* Line 1806 of yacc.c  */
#line 3308 "cfg.y"
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
    break;

  case 813:

/* Line 1806 of yacc.c  */
#line 3309 "cfg.y"
    { (yyval.action)=mk_action(REVERT_URI_T, 0); set_cfg_pos((yyval.action)); }
    break;

  case 814:

/* Line 1806 of yacc.c  */
#line 3310 "cfg.y"
    { (yyval.action)=mk_action(REVERT_URI_T, 0); set_cfg_pos((yyval.action)); }
    break;

  case 815:

/* Line 1806 of yacc.c  */
#line 3311 "cfg.y"
    { (yyval.action)=mk_action(FORCE_RPORT_T, 0); set_cfg_pos((yyval.action)); }
    break;

  case 816:

/* Line 1806 of yacc.c  */
#line 3312 "cfg.y"
    {(yyval.action)=mk_action(FORCE_RPORT_T, 0); set_cfg_pos((yyval.action)); }
    break;

  case 817:

/* Line 1806 of yacc.c  */
#line 3313 "cfg.y"
    { (yyval.action)=mk_action(ADD_LOCAL_RPORT_T, 0); set_cfg_pos((yyval.action)); }
    break;

  case 818:

/* Line 1806 of yacc.c  */
#line 3314 "cfg.y"
    {(yyval.action)=mk_action(ADD_LOCAL_RPORT_T, 0); set_cfg_pos((yyval.action)); }
    break;

  case 819:

/* Line 1806 of yacc.c  */
#line 3315 "cfg.y"
    {
		#ifdef USE_TCP
			(yyval.action)=mk_action(FORCE_TCP_ALIAS_T, 1, NUMBER_ST, (void*)(yyvsp[(3) - (4)].intval));
			set_cfg_pos((yyval.action));
		#else
			yyerror("tcp support not compiled in");
		#endif
	}
    break;

  case 820:

/* Line 1806 of yacc.c  */
#line 3323 "cfg.y"
    {
		#ifdef USE_TCP
			(yyval.action)=mk_action(FORCE_TCP_ALIAS_T, 0);
			set_cfg_pos((yyval.action));
		#else
			yyerror("tcp support not compiled in");
		#endif
	}
    break;

  case 821:

/* Line 1806 of yacc.c  */
#line 3331 "cfg.y"
    {
		#ifdef USE_TCP
			(yyval.action)=mk_action(FORCE_TCP_ALIAS_T, 0);
			set_cfg_pos((yyval.action));
		#else
			yyerror("tcp support not compiled in");
		#endif
	}
    break;

  case 822:

/* Line 1806 of yacc.c  */
#line 3339 "cfg.y"
    {(yyval.action)=0; yyerror("bad argument, number expected"); }
    break;

  case 823:

/* Line 1806 of yacc.c  */
#line 3341 "cfg.y"
    { (yyval.action)=mk_action(UDP_MTU_TRY_PROTO_T, 1, NUMBER_ST, (yyvsp[(3) - (4)].intval)); set_cfg_pos((yyval.action)); }
    break;

  case 824:

/* Line 1806 of yacc.c  */
#line 3343 "cfg.y"
    { (yyval.action)=0; yyerror("bad argument, UDP, TCP, TLS or SCTP expected"); }
    break;

  case 825:

/* Line 1806 of yacc.c  */
#line 3344 "cfg.y"
    {
		(yyval.action)=0;
		if ((str_tmp=pkg_malloc(sizeof(str)))==0) {
			LOG(L_CRIT, "ERROR: cfg. parser: out of memory.\n");
		} else {
			str_tmp->s=(yyvsp[(3) - (4)].strval);
			str_tmp->len=(yyvsp[(3) - (4)].strval)?strlen((yyvsp[(3) - (4)].strval)):0;
			(yyval.action)=mk_action(SET_ADV_ADDR_T, 1, STR_ST, str_tmp);
			set_cfg_pos((yyval.action));
		}
	}
    break;

  case 826:

/* Line 1806 of yacc.c  */
#line 3355 "cfg.y"
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
    break;

  case 827:

/* Line 1806 of yacc.c  */
#line 3356 "cfg.y"
    {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
    break;

  case 828:

/* Line 1806 of yacc.c  */
#line 3357 "cfg.y"
    {
		(yyval.action)=0;
		tmp=int2str((yyvsp[(3) - (4)].intval), &i_tmp);
		if ((str_tmp=pkg_malloc(sizeof(str)))==0) {
			LOG(L_CRIT, "ERROR: cfg. parser: out of memory.\n");
		} else {
			if ((str_tmp->s=pkg_malloc(i_tmp))==0) {
				LOG(L_CRIT, "ERROR: cfg. parser: out of memory.\n");
			} else {
				memcpy(str_tmp->s, tmp, i_tmp);
				str_tmp->len=i_tmp;
				(yyval.action)=mk_action(SET_ADV_PORT_T, 1, STR_ST, str_tmp);
				set_cfg_pos((yyval.action));
			}
		}
	}
    break;

  case 829:

/* Line 1806 of yacc.c  */
#line 3373 "cfg.y"
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
    break;

  case 830:

/* Line 1806 of yacc.c  */
#line 3374 "cfg.y"
    {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
    break;

  case 831:

/* Line 1806 of yacc.c  */
#line 3375 "cfg.y"
    { 
		(yyval.action)=mk_action(FORCE_SEND_SOCKET_T, 1, SOCKID_ST, (yyvsp[(3) - (4)].sockid));
		set_cfg_pos((yyval.action));
	}
    break;

  case 832:

/* Line 1806 of yacc.c  */
#line 3379 "cfg.y"
    {
		(yyval.action)=0; yyerror("bad argument, [proto:]host[:port] expected");
	}
    break;

  case 833:

/* Line 1806 of yacc.c  */
#line 3382 "cfg.y"
    {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
    break;

  case 834:

/* Line 1806 of yacc.c  */
#line 3383 "cfg.y"
    {
		(yyval.action)=mk_action(SET_FWD_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	}
    break;

  case 835:

/* Line 1806 of yacc.c  */
#line 3386 "cfg.y"
    {
		(yyval.action)=mk_action(SET_FWD_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	}
    break;

  case 836:

/* Line 1806 of yacc.c  */
#line 3389 "cfg.y"
    {
		(yyval.action)=mk_action(SET_RPL_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	}
    break;

  case 837:

/* Line 1806 of yacc.c  */
#line 3392 "cfg.y"
    {
		(yyval.action)=mk_action(SET_RPL_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	}
    break;

  case 838:

/* Line 1806 of yacc.c  */
#line 3395 "cfg.y"
    {
		(yyval.action)=mk_action(SET_FWD_CLOSE_T, 0); set_cfg_pos((yyval.action));
	}
    break;

  case 839:

/* Line 1806 of yacc.c  */
#line 3398 "cfg.y"
    {
		(yyval.action)=mk_action(SET_FWD_CLOSE_T, 0); set_cfg_pos((yyval.action));
	}
    break;

  case 840:

/* Line 1806 of yacc.c  */
#line 3401 "cfg.y"
    {
		(yyval.action)=mk_action(SET_RPL_CLOSE_T, 0); set_cfg_pos((yyval.action));
	}
    break;

  case 841:

/* Line 1806 of yacc.c  */
#line 3404 "cfg.y"
    {
		(yyval.action)=mk_action(SET_RPL_CLOSE_T, 0); set_cfg_pos((yyval.action));
	}
    break;

  case 842:

/* Line 1806 of yacc.c  */
#line 3407 "cfg.y"
    {
		(yyval.action)=mk_action(CFG_SELECT_T, 2, STRING_ST, (yyvsp[(3) - (6)].strval), NUMBER_ST, (void*)(yyvsp[(5) - (6)].intval)); set_cfg_pos((yyval.action));
	}
    break;

  case 843:

/* Line 1806 of yacc.c  */
#line 3410 "cfg.y"
    {
		(yyval.action)=mk_action(CFG_SELECT_T, 2, STRING_ST, (yyvsp[(3) - (6)].strval), RVE_ST, (yyvsp[(5) - (6)].rv_expr)); set_cfg_pos((yyval.action));
	}
    break;

  case 844:

/* Line 1806 of yacc.c  */
#line 3413 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
    break;

  case 845:

/* Line 1806 of yacc.c  */
#line 3414 "cfg.y"
    { (yyval.action)=0; yyerror("bad arguments, string and number expected"); }
    break;

  case 846:

/* Line 1806 of yacc.c  */
#line 3415 "cfg.y"
    {
		(yyval.action)=mk_action(CFG_RESET_T, 1, STRING_ST, (yyvsp[(3) - (4)].strval)); set_cfg_pos((yyval.action));
	}
    break;

  case 847:

/* Line 1806 of yacc.c  */
#line 3418 "cfg.y"
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
    break;

  case 848:

/* Line 1806 of yacc.c  */
#line 3419 "cfg.y"
    { (yyval.action)=0; yyerror("bad arguments, string expected"); }
    break;

  case 849:

/* Line 1806 of yacc.c  */
#line 3420 "cfg.y"
    {mod_func_action = mk_action(MODULE0_T, 2, MODEXP_ST, NULL, NUMBER_ST,
			0); }
    break;

  case 850:

/* Line 1806 of yacc.c  */
#line 3421 "cfg.y"
    {
		mod_func_action->val[0].u.data =
			find_export_record((yyvsp[(1) - (5)].strval), mod_func_action->val[1].u.number, rt,
								&u_tmp);
		if (mod_func_action->val[0].u.data == 0) {
			if (find_export_record((yyvsp[(1) - (5)].strval), mod_func_action->val[1].u.number, 0,
									&u_tmp) ) {
					LOG(L_ERR, "misused command %s\n", (yyvsp[(1) - (5)].strval));
					yyerror("Command cannot be used in the block\n");
			} else {
				LOG(L_ERR, "cfg. parser: failed to find command %s\n", (yyvsp[(1) - (5)].strval));
				yyerror("unknown command, missing loadmodule?\n");
			}
			free_mod_func_action(mod_func_action);
			mod_func_action=0;
		}else{
			if (mod_func_action && mod_f_params_pre_fixup(mod_func_action)<0) {
				/* error messages are printed inside the function */
				free_mod_func_action(mod_func_action);
				mod_func_action = 0;
				YYERROR;
			}
		}
		(yyval.action) = mod_func_action;
		set_cfg_pos((yyval.action));
	}
    break;

  case 851:

/* Line 1806 of yacc.c  */
#line 3447 "cfg.y"
    { yyerror("'('')' expected (function call)");}
    break;

  case 853:

/* Line 1806 of yacc.c  */
#line 3451 "cfg.y"
    { }
    break;

  case 854:

/* Line 1806 of yacc.c  */
#line 3452 "cfg.y"
    {}
    break;

  case 855:

/* Line 1806 of yacc.c  */
#line 3455 "cfg.y"
    {
		if ((yyvsp[(1) - (1)].rv_expr) && mod_func_action->val[1].u.number < MAX_ACTIONS-2) {
			mod_func_action->val[mod_func_action->val[1].u.number+2].type =
				RVE_ST;
			mod_func_action->val[mod_func_action->val[1].u.number+2].u.data =
				(yyvsp[(1) - (1)].rv_expr);
			mod_func_action->val[1].u.number++;
		} else if ((yyvsp[(1) - (1)].rv_expr)) {
			yyerror("Too many arguments\n");
			YYERROR;
		} else {
			YYERROR;
		}
	}
    break;

  case 856:

/* Line 1806 of yacc.c  */
#line 3472 "cfg.y"
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, 0, NUMBER_ST,
						(void*)(DROP_R_F|EXIT_R_F)); set_cfg_pos((yyval.action));
	}
    break;

  case 857:

/* Line 1806 of yacc.c  */
#line 3476 "cfg.y"
    {
		(yyval.action)=mk_action(DROP_T, 2, RVE_ST, (yyvsp[(2) - (2)].rv_expr), NUMBER_ST,
						(void*)(DROP_R_F|EXIT_R_F)); set_cfg_pos((yyval.action));
	}
    break;

  case 858:

/* Line 1806 of yacc.c  */
#line 3480 "cfg.y"
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, 0, NUMBER_ST, 
						(void*)(DROP_R_F|EXIT_R_F)); set_cfg_pos((yyval.action));
	}
    break;

  case 859:

/* Line 1806 of yacc.c  */
#line 3484 "cfg.y"
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)EXIT_R_F);
		set_cfg_pos((yyval.action));
	}
    break;

  case 860:

/* Line 1806 of yacc.c  */
#line 3489 "cfg.y"
    {
		(yyval.action)=mk_action(DROP_T, 2, RVE_ST, (yyvsp[(2) - (2)].rv_expr), NUMBER_ST, (void*)EXIT_R_F);
		set_cfg_pos((yyval.action));
	}
    break;

  case 861:

/* Line 1806 of yacc.c  */
#line 3493 "cfg.y"
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)EXIT_R_F);
		set_cfg_pos((yyval.action));
	}
    break;

  case 862:

/* Line 1806 of yacc.c  */
#line 3498 "cfg.y"
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)RETURN_R_F); set_cfg_pos((yyval.action));
	}
    break;

  case 863:

/* Line 1806 of yacc.c  */
#line 3502 "cfg.y"
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)RETURN_R_F); set_cfg_pos((yyval.action));
	}
    break;

  case 864:

/* Line 1806 of yacc.c  */
#line 3506 "cfg.y"
    {
		(yyval.action)=mk_action(DROP_T, 2, RVE_ST, (yyvsp[(2) - (2)].rv_expr), NUMBER_ST, (void*)RETURN_R_F);
		set_cfg_pos((yyval.action));
	}
    break;

  case 865:

/* Line 1806 of yacc.c  */
#line 3510 "cfg.y"
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, 0, NUMBER_ST, (void*)BREAK_R_F);
		set_cfg_pos((yyval.action));
	}
    break;



/* Line 1806 of yacc.c  */
#line 12857 "cfg.tab.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 2067 of yacc.c  */
#line 3516 "cfg.y"


static void get_cpos(struct cfg_pos* pos)
{
	pos->s_line=startline;
	pos->e_line=line;
	pos->s_col=startcolumn;
	pos->e_col=column-1;
	if(finame==0)
		finame = (cfg_file!=0)?cfg_file:"default";
	pos->fname=finame;
}


static void warn_at(struct cfg_pos* p, char* format, ...)
{
	va_list ap;
	char s[256];
	
	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	if (p->e_line!=p->s_line)
		LOG(L_WARN, "warning in config file %s, from line %d, column %d to"
					" line %d, column %d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_line, p->e_col, s);
	else if (p->s_col!=p->e_col)
		LOG(L_WARN, "warning in config file %s, line %d, column %d-%d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_col, s);
	else
		LOG(L_WARN, "warning in config file %s, line %d, column %d: %s\n",
				p->fname, p->s_line, p->s_col, s);
	cfg_warnings++;
}



static void yyerror_at(struct cfg_pos* p, char* format, ...)
{
	va_list ap;
	char s[256];
	
	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	if (p->e_line!=p->s_line)
		LOG(L_CRIT, "parse error in config file %s, from line %d, column %d"
					" to line %d, column %d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_line, p->e_col, s);
	else if (p->s_col!=p->e_col)
		LOG(L_CRIT,"parse error in config file %s, line %d, column %d-%d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_col, s);
	else
		LOG(L_CRIT, "parse error in config file %s, line %d, column %d: %s\n",
					p->fname, p->s_line, p->s_col, s);
	cfg_errors++;
}



static void warn(char* format, ...)
{
	va_list ap;
	char s[256];
	struct cfg_pos pos;
	
	get_cpos(&pos);
	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	warn_at(&pos, s);
}



static void yyerror(char* format, ...)
{
	va_list ap;
	char s[256];
	struct cfg_pos pos;
	
	get_cpos(&pos);
	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	yyerror_at(&pos, s);
}



/** mk_rval_expr_v wrapper.
 *  checks mk_rval_expr_v return value and sets the cfg. pos
 *  (line and column numbers)
 *  @return rval_expr* on success, 0 on error (@see mk_rval_expr_v)
 */
static struct rval_expr* mk_rve_rval(enum rval_type type, void* v)
{
	struct rval_expr* ret;
	struct cfg_pos pos;

	get_cpos(&pos);
	ret=mk_rval_expr_v(type, v, &pos);
	if (ret==0){
		yyerror("internal error: failed to create rval expr");
		/* YYABORT; */
	}
	return ret;
}


/** mk_rval_expr1 wrapper.
 *  checks mk_rval_expr1 return value (!=0 and type checking)
 *  @return rval_expr* on success, 0 on error (@see mk_rval_expr1)
 */
static struct rval_expr* mk_rve1(enum rval_expr_op op, struct rval_expr* rve1)
{
	struct rval_expr* ret;
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;
	
	if (rve1==0)
		return 0;
	ret=mk_rval_expr1(op, rve1, &rve1->fpos);
	if (ret && (rve_check_type(&type, ret, &bad_rve, &bad_t, &exp_t)!=1)){
		yyerror_at(&rve1->fpos, "bad expression: type mismatch"
					" (%s instead of %s)", rval_type_name(bad_t),
					rval_type_name(exp_t));
		rve_destroy(ret);
		ret=0;
	}
	return ret;
}


/** mk_rval_expr2 wrapper.
 *  checks mk_rval_expr2 return value (!=0 and type checking)
 *  @return rval_expr* on success, 0 on error (@see mk_rval_expr2)
 */
static struct rval_expr* mk_rve2(enum rval_expr_op op, struct rval_expr* rve1,
									struct rval_expr* rve2)
{
	struct rval_expr* ret;
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;
	struct cfg_pos pos;
	
	if ((rve1==0) || (rve2==0))
		return 0;
	bad_rve=0;
	bad_t=0;
	exp_t=0;
	cfg_pos_join(&pos, &rve1->fpos, &rve2->fpos);
	ret=mk_rval_expr2(op, rve1, rve2, &pos);
	if (ret && (rve_check_type(&type, ret, &bad_rve, &bad_t, &exp_t)!=1)){
		if (bad_rve)
			yyerror_at(&pos, "bad expression: type mismatch:"
						" %s instead of %s at (%d,%d)",
						rval_type_name(bad_t), rval_type_name(exp_t),
						bad_rve->fpos.s_line, bad_rve->fpos.s_col);
		else
			yyerror("BUG: unexpected null \"bad\" expression\n");
		rve_destroy(ret);
		ret=0;
	}
	return ret;
}


/** check if the expression is an int.
 * if the expression does not evaluate to an int return -1 and
 * log an error.
 * @return 0 success, no warnings; 1 success but warnings; -1 on error */
static int rval_expr_int_check(struct rval_expr *rve)
{
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;
	
	if (rve==0){
		yyerror("invalid expression");
		return -1;
	}else if (!rve_check_type(&type, rve, &bad_rve, &bad_t ,&exp_t)){
		if (bad_rve)
			yyerror_at(&rve->fpos, "bad expression: type mismatch:"
						" %s instead of %s at (%d,%d)",
						rval_type_name(bad_t), rval_type_name(exp_t),
						bad_rve->fpos.s_line, bad_rve->fpos.s_col);
		else
			yyerror("BUG: unexpected null \"bad\" expression\n");
		return -1;
	}else if (type!=RV_INT && type!=RV_NONE){
		warn_at(&rve->fpos, "non-int expression (you might want to use"
				" casts)\n");
		return 1;
	}
	return 0;
}


/** warn if the expression is constant.
 * @return 0 on success (no warning), 1 when warning */
static int warn_ct_rve(struct rval_expr *rve, char* name)
{
	if (rve && rve_is_constant(rve)){
		warn_at(&rve->fpos, "constant value in %s%s",
				name?name:"expression", name?"(...)":"");
		return 1;
	}
	return 0;
}


static struct name_lst* mk_name_lst(char* host, int flags)
{
	struct name_lst* l;
	if (host==0) return 0;
	l=pkg_malloc(sizeof(struct name_lst));
	if (l==0) {
		LOG(L_CRIT,"ERROR: cfg. parser: out of memory.\n");
	} else {
		l->name=host;
		l->flags=flags;
		l->next=0;
	}
	return l;
}


static struct socket_id* mk_listen_id(char* host, int proto, int port)
{
	struct socket_id* l;
	if (host==0) return 0;
	l=pkg_malloc(sizeof(struct socket_id));
	if (l==0) {
		LOG(L_CRIT,"ERROR: cfg. parser: out of memory.\n");
	} else {
		l->addr_lst=mk_name_lst(host, 0);
		if (l->addr_lst==0){
			pkg_free(l);
			return 0;
		}
		l->flags=0;
		l->port=port;
		l->proto=proto;
		l->next=0;
	}
	return l;
}


static void free_name_lst(struct name_lst* lst)
{
	struct name_lst* tmp;
	
	while(lst){
		tmp=lst;
		lst=lst->next;
		pkg_free(tmp);
	}
}


static struct socket_id* mk_listen_id2(struct name_lst* addr_l, int proto,
										int port)
{
	struct socket_id* l;
	if (addr_l==0) return 0;
	l=pkg_malloc(sizeof(struct socket_id));
	if (l==0) {
		LOG(L_CRIT,"ERROR: cfg. parser: out of memory.\n");
	} else {
		l->flags=addr_l->flags;
		l->port=port;
		l->proto=proto;
		l->addr_lst=addr_l;
		l->next=0;
	}
	return l;
}


static void free_socket_id(struct socket_id* i)
{
	free_name_lst(i->addr_lst);
	pkg_free(i);
}


static void free_socket_id_lst(struct socket_id* lst)
{
	struct socket_id* tmp;
	
	while(lst){
		tmp=lst;
		lst=lst->next;
		free_socket_id(tmp);
	}
}


/** create a temporary case statmenet structure.
 *  *err will be filled in case of error (return == 0):
 *   -1 - non constant expression
 *   -2 - expression error (bad type)
 *   -10 - memory allocation error
 */
static struct case_stms* mk_case_stm(struct rval_expr* ct, int is_re,
											struct action* a, int* err)
{
	struct case_stms* s;
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;
	enum match_str_type t;
	
	t=MATCH_UNKNOWN;
	if (ct){
		/* if ct!=0 => case, else if ct==0 is a default */
		if (!rve_is_constant(ct)){
			yyerror_at(&ct->fpos, "non constant expression in case");
			*err=-1;
			return 0;
		}
		if (rve_check_type(&type, ct, &bad_rve, &bad_t, &exp_t)!=1){
			yyerror_at(&ct->fpos, "bad expression: type mismatch:"
							" %s instead of %s at (%d,%d)",
							rval_type_name(bad_t), rval_type_name(exp_t),
							bad_rve->fpos.s_line, bad_rve->fpos.s_col);
			*err=-2;
			return 0;
		}
		if (is_re)
			t=MATCH_RE;
		else if (type==RV_STR)
			t=MATCH_STR;
		else
			t=MATCH_INT;
	}

	s=pkg_malloc(sizeof(*s));
	if (s==0) {
		yyerror("internal error: memory allocation failure");
		*err=-10;
	} else {
		memset(s, 0, sizeof(*s));
		s->ct_rve=ct;
		s->type=t;
		s->actions=a;
		s->next=0;
		s->append=0;
	}
	return s;
}


/*
 * @return 0 on success, -1 on error.
 */
static int case_check_type(struct case_stms* stms)
{
	struct case_stms* c;
	struct case_stms* s;
	
	for(c=stms; c ; c=c->next){
		if (!c->ct_rve) continue;
		for (s=c->next; s; s=s->next){
			if (!s->ct_rve) continue;
			if ((s->type!=c->type) &&
				!(	(c->type==MATCH_STR || c->type==MATCH_RE) &&
					(s->type==MATCH_STR || s->type==MATCH_RE) ) ){
					yyerror_at(&s->ct_rve->fpos, "type mismatch in case");
					return -1;
			}
		}
	}
	return 0;
}


/*
 * @return 0 on success, -1 on error.
 */
static int case_check_default(struct case_stms* stms)
{
	struct case_stms* c;
	int default_no;
	
	default_no=0;
	for(c=stms; c ; c=c->next)
		if (c->ct_rve==0) default_no++;
	return (default_no<=1)?0:-1;
}



/** fixes the parameters and the type of a module function call.
 * It is done here instead of fix action, to have quicker feedback
 * on error cases (e.g. passing a non constant to a function with a 
 * declared fixup) 
 * The rest of the fixup is done inside do_action().
 * @param a - filled module function call (MODULE*_T) action structure
 *            complete with parameters, starting at val[2] and parameter
 *            number at val[1].
 * @return 0 on success, -1 on error (it will also print the error msg.).
 *
 */
static int mod_f_params_pre_fixup(struct action* a)
{
	sr31_cmd_export_t* cmd_exp;
	action_u_t* params;
	int param_no;
	struct rval_expr* rve;
	struct rvalue* rv;
	int r;
	str s;
	
	cmd_exp = a->val[0].u.data;
	param_no = a->val[1].u.number;
	params = &a->val[2];
	
	switch(cmd_exp->param_no) {
		case 0:
			a->type = MODULE0_T;
			break;
		case 1:
			a->type = MODULE1_T;
			break;
		case 2:
			a->type = MODULE2_T;
			break;
		case 3:
			a->type = MODULE3_T;
			break;
		case 4:
			a->type = MODULE4_T;
			break;
		case 5:
			a->type = MODULE5_T;
			break;
		case 6:
			a->type = MODULE6_T;
			break;
		case VAR_PARAM_NO:
			a->type = MODULEX_T;
			break;
		default:
			yyerror("function %s: bad definition"
					" (invalid number of parameters)", cmd_exp->name);
			return -1;
	}
	
	if ( cmd_exp->fixup) {
		if (is_fparam_rve_fixup(cmd_exp->fixup))
			/* mark known fparam rve safe fixups */
			cmd_exp->fixup_flags  |= FIXUP_F_FPARAM_RVE;
		else if (!(cmd_exp->fixup_flags & FIXUP_F_FPARAM_RVE) &&
				 cmd_exp->free_fixup == 0) {
			/* v0 or v1 functions that have fixups and no coresp. fixup_free
			   functions, need constant, string params.*/
			for (r=0; r < param_no; r++) {
				rve=params[r].u.data;
				if (!rve_is_constant(rve)) {
					yyerror_at(&rve->fpos, "function %s: parameter %d is not"
								" constant\n", cmd_exp->name, r+1);
					return -1;
				}
				if ((rv = rval_expr_eval(0, 0, rve)) == 0 ||
						rval_get_str(0, 0, &s, rv, 0) < 0 ) {
					/* out of mem or bug ? */
					rval_destroy(rv);
					yyerror_at(&rve->fpos, "function %s: bad parameter %d"
									" expression\n", cmd_exp->name, r+1);
					return -1;
				}
				rval_destroy(rv);
				rve_destroy(rve);
				params[r].type = STRING_ST; /* asciiz */
				params[r].u.string = s.s;
				params[r].u.str.len = s.len; /* not used right now */
			}
		}
	}/* else
		if no fixups are present, the RVEs can be transformed
		into strings at runtime, allowing seamless var. use
		even with old functions.
		Further optimizations -> in fix_actions()
		*/
	return 0;
}



/** frees a filled module function call action structure.
 * @param a - filled module function call action structure
 *            complete with parameters, starting at val[2] and parameter
 *            number at val[1].
 */
static void free_mod_func_action(struct action* a)
{
	action_u_t* params;
	int param_no;
	int r;
	
	param_no = a->val[1].u.number;
	params = &a->val[2];
	
	for (r=0; r < param_no; r++)
		if (params[r].u.data)
			rve_destroy(params[r].u.data);
	pkg_free(a);
}



/*
int main(int argc, char ** argv)
{
	if (yyparse()!=0)
		fprintf(stderr, "parsing error\n");
}
*/

